//
// Copyright (C) 1999-2008 WideStudio/MWT Project Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#ifndef WSCsheetComboBox_H
#define WSCsheetComboBox_H

#include <WScom.h>
#include <WSCform.h>
#define WSCsheetComboBox_VER  1000

#define WSCSHEET_COMBO_BUTTON_WIDTH 15

#define WSCSHEET_COMBO_EDIT 0
#define WSCSHEET_COMBO_LIST 1

class WSCwindow;
class WSClist;
class WSCvifield;
class WSDkeyboard;

class WSCsheetComboBox  :public WSCform{
  protected:
    WSCwindow* _win;
    WSClist*   _list;
    WSCvifield* _if;
    char* _menu_str;
    WSCushort _max_height;
    short     _bg_blink_color;
    short     _work_back_color;
    short     _item_height;
    WSCushort _increment;
    WSCushort _page_increment;
    unsigned  _font:4;
    unsigned  _enable_input:1;
    unsigned  _selected_by_key:1;
    short     _dropdown_type;
    WSCstring _text;

    WSMFpropertyDef( WSNmenuItems, char*, _menu_str);
    WSMFpropertyDef( WSNmaxHeight, WSCushort, _max_height);
    WSMFpropertyDef(WSNbackBlinkColor,  short,     _bg_blink_color);
    WSMFpropertyDef(WSNworkBackColor,   short,     _work_back_color);
    WSMFpropertyDef(WSNfont,         WSCuchar,   _font         );
    WSMFpropertyDef(WSNitemHeight,         WSCuchar,   _item_height     );
    WSMFpropertyDef(WSNincrement,     WSCushort, _increment   );
    WSMFpropertyDef(WSNpageIncrement, WSCushort, _page_increment );

 
    WSDLEX32 virtual void setWorkWSNdet(WSCbool);
    WSDLEX32 virtual void setWorkWSNwidth(WSCushort);
    WSDLEX32 virtual void setWorkWSNheight(WSCushort);
    WSDLEX32 virtual void setWorkWSNshadowType(char);
    WSDLEX32 virtual void setWorkWSNbackColor(short);
    WSDLEX32 virtual void setWorkWSNforeColor(short);
    WSDLEX32 virtual void setWorkWSNtopShadowColor(short);
    WSDLEX32 virtual void setWorkWSNbottomShadowColor(short);
    WSDLEX32 virtual void setWorkWSNshadowThickness(WSCuchar);

    WSDLEX32 long _menu_popup();
    WSDLEX32 long _menu_popdown();
    WSDLEX32 void _adjust();


    WSDLEX32 static void _modal_proc(WSDdev*);
    WSDLEX32 virtual long _device_initialize(); 
    WSDLEX32 static void _list_work(WSCbase*);
    WSDLEX32 static void _list_ptr_work(WSCbase*);
    WSDLEX32 static WSCbool _special_key_handler(void*,WSDkeyboard*,WSCbool);

    WSDLEX32 static void _list_timer_work(void*);
    WSDLEX32 static void _btn_work(WSCbase*);
    WSDLEX32 static void _btn_key_press_work(WSCbase*);
    WSDLEX32 static void _key_press_work(WSCbase*);
    WSDLEX32 static void _key_release_work(WSCbase*);
    WSDLEX32 static void _key_hook_work(WSCbase*);
    WSDLEX32 static void _value_ch_work(WSCbase*);
    WSDLEX32 static void _cancel_work(WSCbase*);
    
  public:
    WSDLEX32 WSCsheetComboBox(WSCbase*,char*);
    WSDLEX32 virtual ~WSCsheetComboBox();

    WSDLEX32 virtual void onActivate();
    WSDLEX32 virtual void onFocusChange(WSCbool);

    WSDLEX32 virtual long initialize();
    WSDLEX32 virtual long draw();
    WSDLEX32 virtual char* getDefaultProperty();
    WSDLEX32 WSCvifield*  getTextFrame();
    WSDLEX32 virtual WSCbase* getPropertyInheritChild();

    WSMFguiClassDef(WSCsheetComboBox,WSCform);
    WSMFversionDef(WSCsheetComboBox);

  public:
    WSDLEX32 virtual void onMousePress(WSCpoint* pt);
    WSDLEX32 virtual void onMouseRelease(WSCpoint* pt);

	WSDLEX32 static void _focus_ch(WSCbase* ifield);

	WSDLEX32 void buttonDraw(WSDdev* dev, WSCrect rect);
	WSDLEX32 void  setDropdown(short type);
	WSDLEX32 short getDropdown();
	WSDLEX32 void  setText(WSCstring text);
	WSDLEX32 WSCstring getText();
	WSDLEX32 WSCbool isButton(WSCpoint* pt);
	WSDLEX32 void setListIndex(long index);
	WSDLEX32 long getListIndex();
	WSDLEX32 WSCbool isFocus();
	WSDLEX32 void setSheetComboText(WSCstring text);

	long      _listindex;
	short     _list_down;
	short     _focus_color;
	WSCbool   _focus;
};

#endif
