//
// Copyright (C) 1999-2008 WideStudio/MWT Project Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#ifndef WSCSHEETLISTDATA_H
#define WSCSHEETLISTDATA_H

#include <WScom.h>

class WSCsheetListData {

    void**  _data;
    unsigned _num:24;
    unsigned char _seg_size;

  public:
    WSDLEX32 WSCsheetListData();
    WSDLEX32 WSCsheetListData(long);
    WSDLEX32 WSCsheetListData(WSCsheetListData&);
    WSDLEX32 WSCsheetListData(const WSCsheetListData&);
    WSDLEX32 virtual ~WSCsheetListData();

    WSDLEX32 long   setSize(long i);
    WSDLEX32 long   add(void* data,long i =-1);
    WSDLEX32 void   setData(long i,void*);

    WSDLEX32 void*  getData(long i);
    WSDLEX32 long   getNum();
    WSDLEX32 void*  getTopData();
    WSDLEX32 void*  getBottomData();
    WSDLEX32 void** getBuf();

    WSDLEX32 long   del(void* data);
    WSDLEX32 long   delPos(long i);
    WSDLEX32 void   clear();
    WSDLEX32 WSCsheetListData& operator = (WSCsheetListData&);
    WSDLEX32 void*  &operator[](long index);
};
#endif
