//
// Copyright (C) 1999-2008 WideStudio/MWT Project Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#ifndef WSCVLINEGRAPH_H
#define WSCVLINEGRAPH_H

#include <WScom.h>
#include <WSCnwbase.h>
#define WSCvlineGraph_VER	1000

class WSCvlineGraph :public WSCnwbase{

  protected:
    char*     _values;
#ifndef NO_DATA_SOURCE_FUNCTION
    char*     _data_source_name;
#endif
    WSCushort _num;
    short     _hatch_color;
#ifndef NO_BLINK
    short     _bg_blink_color;
#endif
    WSCuchar  _barw;
    WSCuchar  _orientation;
    WSCuchar  _rev;
    WSCuchar _lw;
#ifndef NO_HATCHING
    unsigned  _hatch_pattern:4;
#endif
    unsigned  _lt:4;
#ifndef NO_DATA_SOURCE_FUNCTION
    unsigned  _data_source_type:2;
    unsigned  _need_ds_update:1;
#endif
    unsigned  _stippled:1;


    WSMFpropertyDef(WSNvalue,     char*,_values     );
    WSMFpropertyDef(WSNcolumns,   WSCushort,_num    );
    WSMFpropertyDef(WSNbarThickness,  WSCuchar,_barw );
    WSMFpropertyDef(WSNorientation,  WSCuchar,_orientation );
    WSMFpropertyDef(WSNreverseFlag,  WSCbool,_rev );
    WSMFpropertyDef(WSNstippled,        WSCbool, _stippled         );
#ifndef NO_HATCHING
    WSMFpropertyDef(WSNhatchPattern,    WSCuchar, _hatch_pattern    );
#endif
    WSMFpropertyDef(WSNhatchColor,      short,   _hatch_color      );
    WSMFpropertyDef(WSNlineWidth, WSCuchar, _lw);
    WSMFpropertyDef(WSNlineType,  WSCuchar,      _lt);
#ifndef NO_DATA_SOURCE_FUNCTION
    WSMFpropertyDef(WSNdataSource,  WSCuchar, _data_source_type  );
    WSMFpropertyDef(WSNdataSourceName,  char*, _data_source_name  );
#endif
#ifndef NO_BLINK
    WSMFpropertyDef(WSNbackBlinkColor,      short,   _bg_blink_color      );
#endif
#ifndef NO_DATA_SOURCE_FUNCTION
    WSDLEX32 void _set_ds_instance();
#endif


  public:
    WSDLEX32 WSCvlineGraph(WSCbase* base, char* name);
    WSDLEX32 virtual ~WSCvlineGraph();

    WSDLEX32 virtual long draw();
#ifndef NO_DATA_SOURCE_FUNCTION
    WSDLEX32 virtual void setData(WSCvariant*,long code = WS_EN_DEFAULT);
    WSDLEX32 virtual long getDataSourceType();
    WSDLEX32 virtual char* getDataSourcePropertyName();
    WSDLEX32 virtual void update();
#endif
    WSDLEX32 virtual char* getDefaultProperty();

    WSMFguiClassDef(WSCvlineGraph, WSCnwbase);
    WSMFversionDef  (WSCvlineGraph);
};
#endif
