//
// Copyright (C) 1999-2008 WideStudio/MWT Project Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#ifndef WSCVMULTISERVERSOCKET_H
#define WSCVMULTISERVERSOCKET_H

#include <WScom.h>
#include <WSCngbase.h>
#define WSCvmultiServerSocket_VER  1000
#include <WSDsocket.h>
#include <WSDthread.h>

class WSCvmultiServerSocket   :public WSCngbase{
  protected:
    WSDsocket*  _socket;
    WSDthread*  _accept_thread;

    char*     _addr;
    WSCulong _timeout; 
    void* _handle;
    WSCstring _error_str;
    WSCushort _port; 
    WSCbool _on; 
    WSCbool _disable;    

    WSMFpropertyDef(WSNip,        char*,      _addr);
    WSMFpropertyDef(WSNport,      WSCushort,      _port);
    WSMFpropertyDef(WSNtimeout,   WSCulong,      _timeout);
    WSMFpropertyDef(WSNrunning,   WSCbool,      _on);

WSDLEX32 static void* _accept_thread_proc(WSDthread*,void*);
WSDLEX32 static void* _server_thread_proc(WSDthread*,void*);
  public:

    WSDLEX32 WSCvmultiServerSocket(WSCbase* base, char* name);
    WSDLEX32 virtual ~WSCvmultiServerSocket();
    WSDLEX32 virtual void onActivate();

    WSDLEX32 long read(WSCuchar* buf,long size);
    WSDLEX32 long write(WSCuchar* buf,long size);

    WSDLEX32 WSCstring getDestAddr();
    WSDLEX32 WSDsocket* getSocket();

    WSDLEX32 void getErrorMsg(char* buffer,long size);
    WSDLEX32 WSCstring getErrorMessage();

    WSMFguiClassDef(WSCvmultiServerSocket,WSCngbase);
    WSMFversionDef(WSCvmultiServerSocket);
};

#endif //WSCVSSOCKET_H
