//
// Copyright (C) 1999-2008 WideStudio/MWT Project Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#ifndef WSDCOMM_H
#define WSDCOMM_H

#include <WSCroot.h>
#include <WScom.h>
#include <WSCstring.h>

#define WS_BAUD_DEFAULT   0
#define WS_B9600          1
#define WS_B19200         2
#define WS_B38400         3
#define WS_B57600         4
#define WS_B115200        5

class WSDcomm :public WSCroot{

  protected:
    WSCstring _com_name;
    char      _baud;

    static WSDcomm* (*_create_handler)();

  public:
    WSDLEX32 WSDcomm();
    WSDLEX32 virtual ~WSDcomm();
    WSDLEX32 void setBaud(char);
    WSDLEX32 char getBaud();

    WSDLEX32 virtual long    open(char* name,int mode);
    WSDLEX32 virtual long    close();
    WSDLEX32 virtual long    read(void*,long len);
    WSDLEX32 virtual long    write(void*,long len);

    WSDLEX32 static WSDcomm* getNewInstance();
    WSDLEX32 static void      setCreateInstanceHandler(void* hd);
    WSDLEX32 static void*     getCreateInstanceHandler();

    WSMFclassDef(WSDcomm,WSCroot);
};
#endif
