//
// Copyright (C) 1999-2008 WideStudio/MWT Project Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
//

#include <WScom.h>
#include <advance/WSCobjectBox.h>
#include <WSCclassInformation.h>
#include <WSCdevice.h>
#include <WSDdev.h>
#include <WSCscrForm.h>
#include <WSCvlabel.h>
#include <WSCvtoggle.h>
#include <WSCvifield.h>
#include <WSCvbtn.h>
#include <WSDkeyboard.h>
#include <WSCimageSet.h>
#include <WSDfileSystem.h>
#include <WSDfile.h>
#include <WSCvlabel.h>
#include <WSDdragDrop.h>
#include <WSCballoonHelp.h>
#include <WSCindexForm.h>
#include <WSDappDev.h>
#include <WSClocaleSet.h>
#include <WSCcomboBox.h>

#define WS_TOOLB_PIX    WS_PIXMAP_DIR "bi24.xpm"

#define WS_TB_WIDTH     450
#define WS_TB_HEIGHT    280
#define WS_TB_SCRHEIGHT 600
//#define WS_TB_BGCOLOR1  "gray85"
//#define WS_TB_BGCOLOR2  "gray80"
//#define WS_TB_SLBARBG1  "gray80"
//#define WS_TB_SELECTBG  "slategray2"
#define WS_TB_T         48
#define WS_TB_H         48
#define WS_TB_W         48
#define WS_TB_X         8
#define WS_TB_Y         8

WSMFguiClassInitialize(WSCobjectBox,WSCform);

WSCobjectBox::WSCobjectBox(WSCbase* base,char* objname):
                WSCform(base,objname){
  _class_text = NULL;
  _visible_lbs = 0;
  _file_name = WSGFstrdup("");
  _combo = NULL;
  _index = NULL;

  WSMFpropertyCreateStart
    WSMFpropertyCreate(WSNfileName,char*,_file_name,WSSfileName);
  WSMFpropertyCreateEnd
}

WSMFproperty( WSCobjectBox, WSNfileName, char*, _file_name, WSGFstrdup(""));

void WSCobjectBox::setWorkWSNfileName(char* /*data*/){
  updateList();
}

void WSCobjectBox::getWorkWSNfileName(char** /*data*/){
}

void WSCobjectBox::clearItems(){
  long num = _added.getNum();
  long i;
  for(i=0; i<num; i++){
    WSCstring* items = (WSCstring*)_added[i];
    delete items;
  }
  _added.clear();
  updateList();
}
void WSCobjectBox::addItems(WSCstring* str){
  WSCstring* items = new WSCstring;
  items->setString(str->getString());
  _added.add((void*)items);
  updateList();
}

void WSCobjectBox::delItems(WSCstring* str){
  long num = _added.getNum();
  long i;
  for(i=0; i<num; i++){
    WSCstring* items = (WSCstring*)_added.getData(i);
    if (!strcmp(items->getString(),str->getString())){
      _added.del((void*)items);
      delete items;
    }
  }
  updateList();
}

void WSCobjectBox::updateList(){
  _req_lib_by_obj.clear();

  if (!strcmp(_file_name,"")){
    return ;
  }

  _index->setProperty(WSNmenuItems,"");
  WSCstring menu;
  WSCstring files(_file_name);
  long i;
  long num = files.getWords(",");
  long libno = 0;
  for(i=0; i<num+1; i++){
    WSCstring* data = NULL;
    if (i < num){
      WSCstring filename = files.getWord(i,",");
      data = WSGFreadTextFile(filename,
                   WSGIappLocaleSet()->getSystemLocaleEncoding());
      if (data == NULL){
        fprintf(stderr,"Error: Class library definition file can not open. file=%s\n",
                (char*)filename);
        continue;
      }
    }else{
      data = new WSCstring;
      (*data) << "Imported\n";
      long j;
      long n = _added.getNum();
      for(j=0; j < n; j++){
        WSCstring* items = (WSCstring*)_added[j];
//printf("WSCobjectBox::updateList %d=#%s#\n",j,(char*)(*items));

        while(items->eof() == False){
          (*data) << items->gets() << "\n";
          (*data) << items->gets() << "\n";
        }
        items->seek(0);
      }
//printf("WSCobjectBox::updateList added=#%s# num=%d\n",(char*)(*data),n);
    }

    WSCscrForm* scrarea = (WSCscrForm*)_areas[i];
    if (scrarea == NULL){
      scrarea = new WSCscrForm(_index,"fs-area2");
      scrarea->initialize();
      scrarea->setInternalObject(True);
//      WSGFsetGeometry(scrarea,5,1,400,150);
      scrarea->setPropertyV(WSNworkWidth,(WSCushort)( WS_TB_X*2 + WS_TB_W * 8));
      scrarea->setPropertyV(WSNworkHeight,(WSCushort)(WS_TB_SCRHEIGHT));
      scrarea->setPropertyV(WSNshadowThickness,(WSCuchar)1);
      scrarea->setPropertyV(WSNshadowType,(char)WS_SHADOW_IN);
      scrarea->setPropertyV(WSNforeColor,WSGFcolor("black"));
      scrarea->setProperty(WSNbackColor,WS_DF_DARKBACKCOLOR);
      scrarea->setPropertyV(WSNpixmapStyle,(WSCuchar)WS_DYNAMIC_PIXMAP);
      scrarea->setPropertyV(WSNscrollHeight,(WSCushort)2);
      scrarea->setPropertyV(WSNincrement,(WSCushort)50);
      scrarea->setPropertyV(WSNpageIncrement,(WSCushort)100);
      scrarea->setPropertyV(WSNuserValue,(long)(i+1));

      scrarea->setProperty(WSNanchorLeft,1);
      scrarea->setProperty(WSNanchorLeftFlag,1);
      scrarea->setProperty(WSNanchorRight,0);
      scrarea->setProperty(WSNanchorRightFlag,1);
      scrarea->setProperty(WSNanchorTop,0);
      scrarea->setProperty(WSNanchorTopFlag,1);
      scrarea->setProperty(WSNanchorBottom,0);
      scrarea->setProperty(WSNanchorBottomFlag,1);
      if (i==0){
        scrarea->setVisible(True);
      }
      _areas.add(scrarea);
      scrarea->setUserData("lb-list",(void*)(new WSClistData));
    }
#ifndef NO_GUI_POLICY
    if (WSGIappDev()->getGuiPolicy() & WS_POLICY_ORIGINAL){
      scrarea->setProperty(WSNshadowThickness,1);
    }else
    if (WSGIappDev()->getGuiPolicy() & WS_POLICY_WINDOWS){
      scrarea->setProperty(WSNshadowThickness,2);
    }
#else
    scrarea->setProperty(WSNshadowThickness,2);
#endif
    WSCstring comment = data->gets();
    comment.delHeadSpace();
    comment.delTailSpace();
    if (!strcmp((char*)comment,"")){
      libno++;
      menu << "LIB" << WSGFltoa(libno);
    }else{
      menu << comment;
    }
    if (i < num){
      menu << ",";
    }
    
    WSClistData* lblist = (WSClistData*)scrarea->getUserData("lb-list");
    long j;
    long num2 = lblist->getNum();
    for(j=0; j<num2; j++){
      WSCbase* lb = (WSCbase*)(*lblist)[j];
      lb->setVisible(False);
    }
    long cnt= 0; 
    while( data->eof() == False ){
      WSCstring str = data->gets();

      WSCbase* lb = (WSCbase*)(*lblist)[cnt];
      if (lb == NULL){
        lb = new WSCvlabel(scrarea,"TBlb");
        lb->initialize();
        lb->setInternalObject(True);
        lb->setPropertyV(WSNx,(short)( WS_TB_X + WS_TB_W *(cnt%8)));
        lb->setPropertyV(WSNy,(short)( WS_TB_Y + WS_TB_H *(cnt/8)));
        lb->setPropertyV(WSNwidth,(WSCushort) WS_TB_W );
        lb->setPropertyV(WSNheight,(WSCushort)WS_TB_H );
        lb->setPropertyV(WSNshadowType,(char)WS_SHADOW_OUT);
        lb->setPropertyV(WSNshadowThickness,(WSCuchar)1);
        lb->setUserData("TOOL BOX",(void*)this);
        WSGFsetMargin(lb,0);
        lblist->add(lb);
        WSGIappDragDrop()->registerDragSite(lb,"OBJECT-CREATE");
        WSCprocedure* inop = new WSCprocedure("in op",WSEV_MOUSE_IN);
        inop->setFunction(_label_in_work,"_label_in_work");
        lb->addProcedure(inop);

        WSCprocedure* outop = new WSCprocedure("out op",WSEV_MOUSE_OUT);
        outop->setFunction(_label_out_work,"_label_out_work");
        lb->addProcedure(outop);
      }
      lb->setPropertyV(WSNuserString,(char*)str.getWord(0));
      lb->setPropertyV(WSNlabelPixmap,(char*)str.getWord(1));
      lb->setVisible(True);
      WSCstring reqlib = str.getWord(2);
      if (strcmp((char*)reqlib,"")){
        WSCvariant val = (char*)reqlib;
        _req_lib_by_obj.setData((char*)str.getWord(0),val);
      }
      str = data->gets();
      str.delLineFeed();
      WSGIappBalloonHelp()->unregisterClient(lb);
      WSGIappBalloonHelp()->registerClient(lb,str.getString());
      cnt++;
    }
    delete data;
  }
  _index->setProperty(WSNmenuItems,(char*)menu);
  _combo->setProperty(WSNmenuItems,(char*)menu);
  long val = _index->getProperty(WSNvalue);
  WSCstring tmp = menu.getWord(val,",");
  _combo->setProperty(WSNlabelString,(char*)tmp);
  _index->cdraw();
  onResize(NULL);
}
void WSCobjectBox::_combo_vch_work(WSCbase* ptr){
  WSCobjectBox* _this = (WSCobjectBox*)ptr->getUserData("TOOL BOX");
  WSCstring menu = _this->_combo->getProperty(WSNmenuItems);
  WSCstring val  = _this->_combo->getProperty(WSNlabelString);
  int i;
  int num = menu.getWords(",");
  for(i=0; i<num; i++){
    WSCstring tmp = menu.getWord(i,",");
    if (!strcmp((char*)tmp,(char*)val)){
      _this->_index->setProperty(WSNvalue,i);
      _this->_index->setAbsoluteDraw(True);
      _this->_index->draw();
      break;
    }
  }
}
WSCstring WSCobjectBox::getRequiredLibrary(char* classname){
  WSCstring ret;
  WSCbool exist = _req_lib_by_obj.isExist(classname);
  if (exist == False){
    return ret;
  }
  ret = _req_lib_by_obj.getData(classname);
  return ret;
}


WSCobjectBox::~WSCobjectBox(){
  long num = _added.getNum();
  long i;
  for(i=0; i<num; i++){
    WSCstring* str = (WSCstring*)_added.getData(i);
    delete str;
  }
  num = _areas.getNum();
  for(i=0; i<num; i++){
    WSCscrForm* scr = (WSCscrForm*)_areas[i];
    WSClistData* lblist =(WSClistData*)scr->getUserData("lb-list");
    long j;
    long num2 = lblist->getNum();
    for(j=0; j<num2; j++){
      WSCvlabel* lb = (WSCvlabel*)(*lblist)[i];
      WSGIappDragDrop()->unregisterDragSite(lb);
    }
    delete lblist;
  }
  delete _file_name;
}


void WSCobjectBox::_label_in_work(WSCbase* obj){
  WSCobjectBox* fs = (WSCobjectBox*)obj->getUserData("TOOL BOX");
  WSCstring str(obj->getProperty(WSNuserString));
  if (strcmp(str,"")){
//WSMFtrace("WSCobjectBox::_label_in_work   %s\n",str);
    fs->_class_text->setPropertyV(WSNlabelString,(char*)str);
    fs->_class_text->redraw();
//    obj->setPropertyV(WSNtopShadowColor,"cyan2");
//    obj->setPropertyV(WSNbottomShadowColor,"cyan4");
    obj->update();
  }
}

void WSCobjectBox::_label_out_work(WSCbase* obj){
  WSCobjectBox* fs = (WSCobjectBox*)obj->getUserData("TOOL BOX");


//  if ( fs->_class_text->cmpPropertye(WSNlabelString, obj->getProperty(WSNuserString) ) ){
  if ( !strcmp(fs->_class_text->getProperty(WSNlabelString),obj->getProperty(WSNuserString) ) ){
    fs->_class_text->setPropertyV(WSNlabelString,"");
    fs->_class_text->update();
  }
//  obj->setPropertyV(WSNtopShadowColor,"gray95");
//  obj->setPropertyV(WSNbottomShadowColor,"gray45");
  obj->update();

}

long WSCobjectBox::initialize(){
  WSCform::initialize();
  setProperty(WSNshadowType,WS_SHADOW_NONE);

  _combo = new WSCcomboBox(this,"ob-combo");
  _combo->initialize();
  _combo->setProperty(WSNx,5);
  _combo->setProperty(WSNy,5);
  _combo->setProperty(WSNdisplayOnly,True);
  _combo->setProperty(WSNheight,20);
  _combo->setProperty(WSNanchorLeft,5);
  _combo->setProperty(WSNanchorLeftFlag,True);
  _combo->setProperty(WSNanchorRight,5);
  _combo->setProperty(WSNanchorRightFlag,True);
  _combo->setProperty(WSNbackColor,WS_DF_DARKBACKCOLOR);
  _combo->setUserData("TOOL BOX",(void*)this);
  _combo->setVisible(True);

  WSCprocedure* op = new WSCprocedure("vch",WSEV_VALUE_CH);
  op->setFunction(_combo_vch_work,"_combo_vch_work");
  _combo->addProcedure(op);

  _class_text = new WSCvlabel(this,"fs-dtitle");
  _class_text->initialize();
  _class_text->setInternalObject(True);
//  _class_text->setPropertyV(WSNx,     (short)55 );
  _class_text->setPropertyV(WSNx,     (short)5 );
  _class_text->setPropertyV(WSNy,     (short)35 );
  _class_text->setProperty(WSNheight,20);
  _class_text->setProperty(WSNanchorLeft,5);
  _class_text->setProperty(WSNanchorLeftFlag,True);
  _class_text->setProperty(WSNanchorRight,5);
  _class_text->setProperty(WSNanchorRightFlag,True);
  _class_text->setPropertyV(WSNlabelString,"");
  _class_text->setPropertyV(WSNalignmentH,(WSCuchar)WS_LEFT);
  _class_text->setPropertyV(WSNshadowType,(char)WS_SHADOW_IN);
  _class_text->setProperty(WSNshadowThickness,1);
  _class_text->setVisible(True);
  WSGFsetMargin(_class_text,0);

  WSCvlabel* sp1 = new WSCvlabel(this,"FS-sp1");
  sp1->initialize();
  sp1->setInternalObject(True);
  WSGFsetGeometry(sp1,0,30,1280,2);
  sp1->setPropertyV(WSNshadowThickness,(WSCuchar)1);
  sp1->setPropertyV(WSNshadowType,(char)WS_SHADOW_IN);
  sp1->setProperty(WSNbackColor,WS_DF_BACKCOLOR);
  sp1->setProperty(WSNtopShadowColor,WS_DF_TOPSHADOWCOLOR);
  sp1->setProperty(WSNbottomShadowColor,WS_DF_BOTTOMSHADOWCOLOR);
  sp1->setProperty(WSNanchorLeft,0);
  sp1->setProperty(WSNanchorLeftFlag,1);
  sp1->setProperty(WSNanchorRight,0);
  sp1->setProperty(WSNanchorRightFlag,1);
  sp1->setVisible(True);

#if 0
  WSCbase* dtitle = new WSCvlabel(this,"fs-dtitle");
  dtitle->initialize();
  dtitle->setInternalObject(True);
  dtitle->setPropertyV(WSNx,     (short)5 );
  dtitle->setPropertyV(WSNy,     (short)7 );
  dtitle->setPropertyV(WSNwidth, (WSCushort)45);
  dtitle->setPropertyV(WSNheight,(WSCushort)16);
  dtitle->setPropertyV(WSNlabelString,"CLASS:");
  dtitle->setPropertyV(WSNalignmentH,(WSCuchar)WS_LEFT);
  dtitle->setPropertyV(WSNshadowType,(char)WS_SHADOW_TRANS);
  dtitle->setVisible(True);
  WSGFsetMargin(dtitle,0);
#endif

  _index = new WSCindexForm(this,"ob-area");
  _index->initialize();
  _index->setInternalObject(True);
  WSGFsetGeometry(_index,5,60,400,200);
  _index->setProperty(WSNbackColor,WS_DF_DARKBACKCOLOR);
  _index->setProperty(WSNshadowType,WS_SHADOW_NONE);
  _index->setPropertyV(WSNmenuItems,"");
  _index->setProperty(WSNanchorLeft,0);
  _index->setProperty(WSNanchorLeftFlag,1);
  _index->setProperty(WSNanchorRight,0);
  _index->setProperty(WSNanchorRightFlag,1);
  _index->setProperty(WSNanchorTop,60);
  _index->setProperty(WSNanchorTopFlag,1);
  _index->setProperty(WSNanchorBottom,0);
  _index->setProperty(WSNanchorBottomFlag,1);
  _index->setProperty(WSNbarThickness,0);
  _index->setVisible(True);

  setPropertyV(WSNfileName,"");
  return WS_NO_ERR;
}
void WSCobjectBox::onResize(WSCrect* ){
  int i;
  int num = _areas.getNum();
  WSCulong w = getProperty(WSNwidth);
  long sect = w/WS_TB_W;
  if (sect < 1){
    sect = 1;
  }
  for(i=0; i<num; i++){
    WSCscrForm* scrarea = (WSCscrForm*)_areas[i];
    WSClistData* lblist = (WSClistData*)scrarea->getUserData("lb-list");

    long j;
    long num2 = lblist->getNum();
    long height = 0;
    for(j=0; j<num2; j++){
      WSCbase* lb = (WSCbase*)(*lblist)[j];
      short y = WS_TB_Y + WS_TB_H *(j/sect);
      lb->setPropertyV(WSNx,(short)( WS_TB_X + WS_TB_W *(j%sect)));
      lb->setPropertyV(WSNy,(short)y);
      if (height < y + WS_TB_H ){
        height = y + WS_TB_H;
      }
    }
    scrarea->setProperty(WSNworkHeight,height + WS_TB_Y);
    scrarea->setProperty(WSNworkWidth,w);
    scrarea->getScrFrame()->redraw();
  }
}
void WSCobjectBox::resetRequiredLibrary(){
  _req_lib_by_obj.clear();
}
