//
// Copyright (C) 1999-2008 WideStudio/MWT Project Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
//

#include <WScom.h>
#include <WSDcomm.h>
#ifndef NO_COMM

WSMFclassInit(WSDcomm,WSCroot);

WSDcomm* (*WSDcomm::_create_handler)() = NULL;

WSDcomm::WSDcomm(){
  _baud = WS_B9600;
}

WSDcomm::~WSDcomm(){
}

void WSDcomm::setBaud(char b){
  _baud = b;
};
char WSDcomm::getBaud(){
  return _baud;
}

WSDcomm* WSDcomm::getNewInstance(){
  if (_create_handler == NULL){
    return new WSDcomm();
  }
  return _create_handler();
}

void* WSDcomm::getCreateInstanceHandler(){
  return (void*)_create_handler;
}

void WSDcomm::setCreateInstanceHandler(void* hd){
  _create_handler = (WSDcomm* (*)())hd;
}

long WSDcomm::open(char* fname,int){
WSMFtrace("WSDcomm Warring. This system does not support open().\n");
  return WS_ERR;
}

long WSDcomm::close(){
WSMFtrace("WSDcomm Warring. This system does not support close().\n");
  return WS_ERR;
}

long WSDcomm::read(void* buf,long size){
WSMFtrace("WSDcomm Warring. This system does not support read().\n");
  return 0;
}

long WSDcomm::write(void* buf,long size){
WSMFtrace("WSDcomm Warring. This system does not support write().\n");
  return 0;
}

#endif
