//
// Copyright (C) 1999-2008 WideStudio/MWT Project Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
//

#include <WScom.h>
#include <WSDfileSystem.h>
#include <WSClistData.h>
#include <WSClocaleSet.h>

WSDfileSystem::WSDfileSystem(){
  _link_encoding=WS_EN_NONE;

  // checking unix encoding then estimate windows encoding
  long encoding = WSGIappLocaleSet()->getSystemLocaleEncoding();
  if( encoding==WS_EN_SJIS || encoding==WS_EN_EUCJP ){
    _link_encoding=WS_EN_SJIS;
  }
}

WSDfileSystem::~WSDfileSystem(){
}

long WSDfileSystem::setLinkEncoding(long en){
  long old_en=_link_encoding;
  _link_encoding=en;
  return old_en;
}

long WSDfileSystem::getLinkEncoding(void){
  return _link_encoding;
} 

char* WSDfileSystem::adjustFileName(char* str){
WSMFtrace("WSDfileSystem Warring. This system does not support adjustFileName().\n");
  return str;
}

long WSDfileSystem::rename(char*,char*){
WSMFtrace("WSDfileSystem Warring. This system does not support rename().\n");
  return WS_ERR;
}

long WSDfileSystem::deleteFile(char*){
WSMFtrace("WSDfileSystem Warring. This system does not support deleteFile().\n");
  return WS_ERR;
}

long WSDfileSystem::createDir(char*){
WSMFtrace("WSDfileSystem Warring. This system does not support createDir().\n");
  return WS_ERR;
}

long WSDfileSystem::deleteDir(char*){
WSMFtrace("WSDfileSystem Warring. This system does not support deleteDir().\n");
  return WS_ERR;
}

WSClistData* WSDfileSystem::showNetDir(char*,char*){
WSMFtrace("WSDfileSystem Warring. This system does not support showNetDir().\n");
  return NULL;
}
WSClistData* WSDfileSystem::showDir(char*){
WSMFtrace("WSDfileSystem Warring. This system does not support showDir().\n");
  return NULL;
}
WSClistData* WSDfileSystem::showDirWithLink(char*,WSCindexData**){
WSMFtrace("WSDfileSystem Warring. This system does not support showDirWithLink().\n");
  return NULL;
}

WSClistData* WSDfileSystem::showFile(char*){
WSMFtrace("WSDfileSystem Warring. This system does not support showFile().\n");
  return NULL;
}
WSClistData* WSDfileSystem::showFileWithLink(char*,WSCindexData**){
WSMFtrace("WSDfileSystem Warring. This system does not support showFileWithLink().\n");
  return NULL;
}
WSCstring* WSDfileSystem::readLink(char*linkname){
WSMFtrace("WSDfileSystem Warring. This system does not support readLink().\n");
  return NULL;
}
long WSDfileSystem::check(char*){
WSMFtrace("WSDfileSystem Warring. This system does not support check().\n");
  return 0;
}

static WSDfileSystem* (*_create_handler)() = NULL;
void WSDfileSystem::setCreateInstanceHandler( WSDfileSystem* (*hd)()){
  _create_handler = hd;
}
static WSDfileSystem* theAppFileSystem = NULL;
WSDfileSystem* WSGIappFileSystem(){
  if (theAppFileSystem == NULL){
    if (_create_handler == NULL){
      theAppFileSystem = new WSDfileSystem();
WSMFtrace("WSGIfileSystem() ERROR. cannot create WSDfileSystem class instance.\n");
      return theAppFileSystem;
    }
    theAppFileSystem = _create_handler();
  }
  return theAppFileSystem;
}


