//
// Copyright (C) 1999-2009 WideStudio/MWT Project Team
// Copyright (C) 2006,2007 FUJITSU LIMITED
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
//

#include <WScom.h>
#include <WSCpopupMenu.h>
#include <WSCclassInformation.h>
#include <WSDmouse.h>
#include <WSDfont.h>
#include <WSCfontSet.h>
#include <WSDappDev.h>
#include <WSCdevice.h>
#include <string.h>
#include <ctype.h>

WSCpopupMenu* WSCpopupMenu::_popuped_instance = NULL;

WSMFguiClassInitialize(WSCpopupMenu,WSCpulldownMenuPopup);

WSCpopupMenu::WSCpopupMenu(WSCbase* base,char* objname):
                WSCpulldownMenuPopup(base,objname){
  _press_state = 0;
  _client = NULL;
  _grabed = 0;
  _internal_popup = 0;

  WSMFpropertyCreateStart
    WSMFpropertyCreate(WSNclient,void*, _client,WSSclient );

  WSMFpropertyCreateEnd
}
WSMFproperty( WSCpopupMenu, WSNclient, void*, _client, NULL);
static WSCbool _popup_on_client_site = False;

void WSCpopupMenu::setWorkWSNclient(void* data){}
void WSCpopupMenu::getWorkWSNclient(void** data){}

WSCpopupMenu::~WSCpopupMenu(){
  if (_popuped_instance == this){
    _popuped_instance = NULL;
  }
  long i;
  long num = _client_list.getNum();
  for(i=0; i<num; i++){
    WSCbase* client = (WSCbase*)_client_list[i];

    client->setUserData("PM-RGST",(void*)0);
    client->setUserData("PM-SERVER",(void*)0);
    WSCprocedure* op1 = (WSCprocedure*)client->getUserData("PM-BTNPRESS");
    if (op1 != NULL){
      client->delProcedure(op1);
      delete op1;
    }
    WSCprocedure* op2 = (WSCprocedure*)client->getUserData("PM-BTNRELEASE");
    if (op2 != NULL){
      client->delProcedure(op2);
      delete op2;
    }

    WSCprocedure* op3 = (WSCprocedure*)client->getUserData("PM-BTNMOVE");
    if (op3 != NULL){
      client->delProcedure(op3);
      delete op3;
    }

    WSCprocedure* op4 = (WSCprocedure*)client->getUserData("PM-DELETE");
    if (op4 != NULL){
      client->delProcedure(op4);
      delete op4;
    }
  }
}
void WSCpopupMenu::onActivate(){
  execProcedure(WSEV_ACTIVATE);
}
long WSCpopupMenu::_popup_menu(){
  if (_popuped_instance != NULL){
    return WS_ERR;
  }else{
    _popuped_instance = this;
  }
  onActivate();
  short px, py;
  WSCbool ret = WSGIappMouse()->getMousePosition(&px, &py);
  if (_popup_on_client_site == True){
    ret = True;
    _popup_on_client_site = False;
    WSCbase* client = (WSCbase*)_client;
    if (client == NULL){
      return WS_ERR;
    }
    WSDdev* dev = client->getowndev();
    if (dev == NULL){
      return WS_ERR;
    }
    dev->getDispAddr(&px,&py);
    px += 10;
    py += 10;
  }
  if (ret == False){
    return WS_ERR;
  }

  WSCushort st = _shadow_thick;
#ifndef NO_GUI_POLICY
  if (WSGIappDev()->getGuiPolicy() & WS_POLICY_WINDOWS){
#endif
    st = 2;
    _shadow_thick = 2;
#ifndef NO_GUI_POLICY
  }
#endif
  WSCstring str( getProperty(WSNmenuItems) );  

  long num = str.getWords(_separator2);    

  short len = 0;
  short ww = 0;
  short hh = st*2;

  //--- [20041015]
  // We use this variable to determinate if menu will use
  // any pixmap on any option
  WSCbool use_pixmap = False;
  //---

  WSDfont* fn = WSGIappFontSet()->getFont(getFontNo());
  WSCushort h = getItemHeight();
  WSCbool cascaded = False;
  long i =0;
  long cnt = 0;
  for (i=0; i<num; i++) {
    WSCstring item = str.getWord(i, _separator2);
    WSCstring itemName = item.getWord(0, _separator);
    WSCstring itemPrc = item.getWord(1, _separator);

    if (!strcmp(itemName.getString(),"SP") ||
          !strcmp(itemName.getString(),"SEPARATOR")){
      hh += st*2;
#ifndef NO_GUI_POLICY
      if (WSGIappDev()->getGuiPolicy() & WS_POLICY_WINDOWS){
#endif
        hh += 4;
#ifndef NO_GUI_POLICY
      }
#endif
    }else{
      if ( !strncmp(itemPrc.getString(),"{",1) ){
        cascaded = True;
        long wpos = str.getWordCharPos(i, _separator2);
        WSCstring tmp(str.getString());
        tmp.deleteChars(0,wpos);
        wpos = tmp.getWordCharPos(1,"{");
        tmp.deleteChars(0,wpos);
        char* tstr = tmp.getString(WS_EN_UTF8);
        long len = strlen(tstr);
        long num_of_conma = 0;
        long j;
        long layers = 0;
        for(j=0; j< len; j++){
          if (tstr[j] == '}'){
            if (layers == 0){
              if (!strncmp(_separator,&tstr[j+1],strlen(_separator))){
                use_pixmap = True;
              }
              tstr[j] = 0;
              break;
            }else{
              layers--;
            }
          }
          if (tstr[j] == '{'){
            layers++;
          }
          if (tstr[j] == _separator2[0]){
            num_of_conma++;
          }
        }
        i += num_of_conma;
      }
      hh += h;
      cnt++;
    }
//--- [20041015]
    // Here, we have to determinate if puldownMenuPopup of first level
    // will have pixmaps. We need to activate use_pixmap only if there
    // is a fifth option in menu item string and if this menu item string
    // doesn't content a sub-menu. This is, if this menu item string
    // hasn't got "{" symbol at second option.
    WSCstring tmp_second_opt = item.getWord(1, _separator);
    if ((strlen(item.getWord(4, _separator).getString()) > 0) &&
        !(strchr(tmp_second_opt.getString(), '{'))){
      use_pixmap = True;
    }
//---
    if (len < (short)strlen(itemName.getString())) {
      len = (short)strlen(itemName.getString());
      WSCstring space(" ");
      WSCushort smargin = WSGIappFontSet()->getStringWidth(getFontNo(),&space);
      ww = (short)fn->getStringWidth(&itemName) + st * 2 + st * 2 + smargin;
    }
  }

  //--- [20041015]
  // Here, if there are pixmaps, we need to make pulldownMenuPopup
  // 24 pixles + smargin widest
  if (use_pixmap != False){
//    WSCstring space(" ");
//    WSCushort smargin = WSGIappFontSet()->getStringWidth(_font,&space);
    ww = ww + 32;
  }
  //---
  WSCpulldownData* own_pld = (WSCpulldownData*)_pld_data;
  if (own_pld == NULL){
    return WS_ERR;
  }
  if (own_pld->_is_toggle(get_parent_pld_data()) != False){
    if (use_pixmap == False){
      ww += 32;
    }
  }
  if (cascaded != False){
      ww += 30;
  }
  long dw = (long)WSGIappDev()->getWidth();
  if (px > dw-1){
    px = dw -1;
  }
  if (px < dw){
    if (px + ww > dw) {
//      px -= (px + ww - WSGIappDev()->getWidth());
      px -= ww;
      if (px < 0){
        px = 0;
      }
    }
  }

  long dh = (long)WSGIappDev()->getHeight();
  if (py > dh-1){
    py = dh -1;
  }
  if (py < dh){
    if (py + hh > dh) {
//      py -= (py + hh - WSGIappDev()->getHeight());
      py -= hh;
      if (py < 0){
        py = 0;
      }
    }
  }

//WSMFtrace("WSCpopupMenu::popup %d %d %d %d   st=%d ih=%d\n",px,py,ww,hh,st,h+st*2);

  setPropertyV(WSNx,(short)px);
  setPropertyV(WSNy,(short)py);
//  setPropertyV(WSNmenuItemHeight,(WSCushort)(h + st*2));
  setPropertyV(WSNwidth,(WSCushort)(ww));
  setPropertyV(WSNheight,(WSCushort)(hh));
  set_id_value(0);
  setVisible(True);

  //--- [20041015]
  set_use_pixmap(use_pixmap);
  //---
  if (getVisible() == False){
    return WS_ERR;
  }
  setFocus();
  WSGIappKeyboard()->setFocusInputWorkProc(_key_handler,NULL,this,this);
  return WS_NO_ERR;
}
#if 0
long WSCpopupMenu::popdown(){
  if (_popuped_instance == this){
    _popuped_instance = NULL;
  }
  setVisible(False);
  _selected = False;
  _client = NULL;
  return WS_NO_ERR;
}
#endif
long WSCpopupMenu::_popdown_and_execute(){
  WSGIappKeyboard()->resetFocusInputWorkProc();
  if (_popuped_instance == this){
    _popuped_instance = NULL;
  }
  _press_state = 0;
#ifndef NO_MODAL
  WSGIappDev()->setPopupModalClient(NULL);
#endif
  setVisible(False);
  if (strcmp(getProcName(),"")){
    execProcedure(getProcName());
  }
  _selected = False;
  _client = NULL;
  _internal_popup = False;
  return WS_NO_ERR;
}
long WSCpopupMenu::popdown(){
  if (_grabed != False){
    if (_client != NULL){
      WSCbase* client = (WSCbase*)_client;
      WSCbase* mt =  (WSCbase*)client->getUserData("PM-MODAL-TARGET");
      client->setUserData("PM-MODAL-TARGET",NULL);
      WSCbase* tclient = client;
      if (mt != NULL){
        tclient = mt;
      }
      WSDdev* dev = tclient->getowndev();
      if ((tclient->getObjectType() & WS_TYPE_NON_WINDOW)!=0){
        dev = dev->getEventParentDev();
      }

      WSCbool fl = False;
      if (dev != NULL){
#ifndef NO_MODAL
        if (_modal_bk != NULL){
          WSGIappDev()->deleteModalClient(_modal_bk);
        }
#endif
        WSGIappMouse()->setMouseUngrabClient(NULL);
        dev->setValue(WSDEV_GRAB_POINTER,&fl);
      }
      _grabed = False;
    }
  }

  WSGIappKeyboard()->resetFocusInputWorkProc();
  if (_popuped_instance == this){
    _popuped_instance = NULL;
  }
  _press_state = 0;
#ifndef NO_MODAL
  WSGIappDev()->setPopupModalClient(NULL);
#endif
  setVisible(False);
  _selected = False;
  _client = NULL;
  _internal_popup = False;
  return WS_NO_ERR;
}
long WSCpopupMenu::registerClient(WSCbase* client,WSCbool recursive){
  long registered = (long)client->getUserData("PM-RGST");
  if (registered == 1){
    return WS_NO_ERR;
  }

  _client_list.add((void*)client);

  client->setUserData("PM-RGST",(void*)1);
  client->setUserData("PM-SERVER",(void*)this);

  long trg1 = WSEV_MOUSE_PRESS;
  long trg2 = WSEV_MOUSE_RELEASE;
  long trg3 = WSEV_MOUSE_MOVE;
  long trg4 = WSEV_MOUSE_OUT;
  long trg5 = WSEV_DELETE;

  WSCprocedure* btnpress = new WSCprocedure("PM_btn_press",trg1);
  btnpress->setFunction(_on_btn_press,"_on_btn_press");
  btnpress->setInternal(True);
  client->addProcedure(btnpress);
  client->setUserData("PM-BTNPRESS",(void*)btnpress);

  WSCprocedure* btnrelease = new WSCprocedure("PM_btn_release",trg2);
  btnrelease->setFunction(_on_btn_release,"_on_btn_release");
  btnrelease->setInternal(True);
  client->addProcedure(btnrelease);
  client->setUserData("PM-BTNRELEASE",(void*)btnrelease);

  WSCprocedure* btnmove = new WSCprocedure("PM_btn_move",trg3);
  btnmove->setFunction(_on_btn_move,"_on_btn_move");
  btnmove->setInternal(True);
  client->addProcedure(btnmove);
  client->setUserData("PM-BTNMOVE",(void*)btnmove);

  WSCprocedure* btnout = new WSCprocedure("PM_out",trg4);
  btnout->setFunction(_on_out,"_on_out");
  btnout->setInternal(True);
  client->addProcedure(btnout);
  client->setUserData("PM-BTNOUT",(void*)btnout);

  WSCprocedure* idelete = new WSCprocedure("PM_idelete",trg5);
  idelete->setFunction(_on_delete,"_on_delete");
  idelete->setInternal(True);
  client->addProcedure(idelete);
  client->setUserData("PM-DELETE",(void*)idelete);

  if (recursive != False){
    long val =(long)recursive;
    client->setUserData("PM-RECURSIVE",(void*)val);
    WSClistData children = client->getChildren();
    long i,num;
    num = children.getNum();
    for(i=0; i<num; i++){
      WSCbase* child = (WSCbase*)children[i];
      if (!(child->getObjectType() & WS_TYPE_NON_WINDOW)){
        _registerClient(child,True);
      }
    } 
  }
  return WS_NO_ERR;
}
long WSCpopupMenu::_registerClient(WSCbase* client,WSCbool recursive){
  long registered = (long)client->getUserData("PM-RGST");
  if (registered == 1){
    return WS_NO_ERR;
  }

  _client_list.add((void*)client);

  client->setUserData("PM-RGST",(void*)1);
  client->setUserData("PM-SERVER",(void*)this);

  long trg1 = WSEV_MOUSE_PRESS;
  long trg2 = WSEV_MOUSE_RELEASE;
  long trg3 = WSEV_MOUSE_MOVE;
  long trg4 = WSEV_MOUSE_OUT;
  long trg5 = WSEV_DELETE;

  WSCprocedure* btnpress = new WSCprocedure("PM_btn_press",trg1);
  btnpress->setFunction(_on_btn_press_recursive,"_on_btn_press_recursive");
  btnpress->setInternal(True);
  client->addProcedure(btnpress);
  client->setUserData("PM-BTNPRESS",(void*)btnpress);

  WSCprocedure* btnrelease = new WSCprocedure("PM_btn_release",trg2);
  btnrelease->setFunction(_on_btn_release_recursive,"_on_btn_release_recursive");
  btnrelease->setInternal(True);
  client->addProcedure(btnrelease);
  client->setUserData("PM-BTNRELEASE",(void*)btnrelease);

  WSCprocedure* btnmove = new WSCprocedure("PM_btn_move",trg3);
  btnmove->setFunction(_on_btn_move_recursive,"_on_btn_move_recursive");
  btnmove->setInternal(True);
  client->addProcedure(btnmove);
  client->setUserData("PM-BTNMOVE",(void*)btnmove);

  WSCprocedure* btnout = new WSCprocedure("PM_out",trg4);
  btnout->setFunction(_on_btn_move_recursive,"_on_out_recursive");
  btnout->setInternal(True);
  client->addProcedure(btnout);
  client->setUserData("PM-BTNOUT",(void*)btnout);

  WSCprocedure* idelete = new WSCprocedure("PM_idelete",trg5);
  idelete->setFunction(_on_delete,"_on_delete");
  idelete->setInternal(True);
  client->addProcedure(idelete);
  client->setUserData("PM-DELETE",(void*)idelete);


  if (recursive != False){
    long val =(long)recursive;
    client->setUserData("PM-RECURSIVE",(void*)val);
    WSClistData children = client->getChildren();
    long i,num;
    num = children.getNum();
    for(i=0; i<num; i++){
      WSCbase* child = (WSCbase*)children[i];
      if (!(child->getObjectType() & WS_TYPE_NON_WINDOW)){
        _registerClient(child,True);
      }
    } 
  }
  return WS_NO_ERR;
}

long WSCpopupMenu::unregisterClient(WSCbase* client){
  _client_list.del((void*)client);
  long registered = (long)client->getUserData("PM-RGST");
  long val =(long)client->getUserData("PM-RECURSIVE");
  WSCpopupMenu* serv = (WSCpopupMenu*)client->getUserData("PM-SERVER");

  if (registered == 1 && serv == this){
    client->setUserData("PM-RGST",(void*)0);
    client->setUserData("PM-SERVER",(void*)0);

    WSCprocedure* op1 = (WSCprocedure*)client->getUserData("PM-BTNPRESS");
    if (op1 != NULL){
      client->delProcedure(op1);
      delete op1;
    }
    WSCprocedure* op2 = (WSCprocedure*)client->getUserData("PM-BTNRELEASE");
    if (op2 != NULL){
      client->delProcedure(op2);
      delete op2;
    }

    WSCprocedure* op3 = (WSCprocedure*)client->getUserData("PM-BTNMOVE");
    if (op3 != NULL){
      client->delProcedure(op3);
      delete op3;
    }

    WSCprocedure* op4 = (WSCprocedure*)client->getUserData("PM-BTNOUT");
    if (op4 != NULL){
      client->delProcedure(op4);
      delete op4;
    }

    WSCprocedure* op5 = (WSCprocedure*)client->getUserData("PM-DELETE");
    if (op5 != NULL){
      client->delProcedure(op5);
      delete op5;
    }

    if( val != False){
      client->setUserData("PM-RECURSIVE",(void*)0);
      WSClistData children = client->getChildren();
      long i,num;
      num = children.getNum();
      for(i=0; i<num; i++){
        WSCbase* child = (WSCbase*)children[i];
        if (child->getObjectType() & WS_TYPE_MANAGER){
          unregisterClient(child);
        }
      } 
    }
  }
  return WS_NO_ERR;
}

void WSCpopupMenu::_on_delete(WSCbase* client){
  WSCpopupMenu* obj = (WSCpopupMenu*)client->getUserData("PM-SERVER");
  if (obj == NULL){
    return;
  }
  if (WSGIappDev()->getMenuFocusInstance() == obj){
    WSGIappDev()->setMenuFocusInstance(NULL,NULL);
  }
  client->setUserData("PM-DELETE",(void*)NULL);
  obj->unregisterClient(client);
}
void WSCpopupMenu::_on_out(WSCbase* client){
  WSCpopupMenu* obj = (WSCpopupMenu*)client->getUserData("PM-SERVER");
  if (obj == NULL){
    return;
  }
  if (obj->_on_fire_client == client){
    obj->_on_fire_client = NULL;
  }
  if (obj->_client == client){
    obj->_client = NULL;
  }
  client->setUserData("PM-MODAL-TARGET",NULL);
}
void WSCpopupMenu::_on_btn_press(WSCbase* client){
//printf("WSCpopupMenu::_on_btn_press press... client=%s\n",client->getInstanceName());
    if (!WSIFstrcmp(client->getUseDevName(),"nwDev")){
      WSCbase* parent = client->getParent();
      if (parent != NULL){
        WSClistData children = parent->getChildren();
        long num = children._num;
        long i,j=0;
        for(i=0; i<num; i++){
          WSCbase* base = (WSCbase*)children[i];
          if (base == client){
            j = i;
            break;
          }
        }
        if (i < num -1){
          short mx=0,my=0;
          if (client->existProperty(WSNx) != False){
            client->getPropertyV(WSNx,&mx);
          }
          if (client->existProperty(WSNy) != False){
            client->getPropertyV(WSNy,&my);
          }
          short mouse_x = 0;
          short mouse_y = 0;
          client->getMouseAddr(&mouse_x,&mouse_y);
          long px = mouse_x + mx;
          long py = mouse_y + my;
          for(i=j+1; i<num; i++){
            WSCbase* child = (WSCbase*)children[i];
            if (child->getdev() == NULL){
              continue;
            }else if (child->getdev()->getParentDev() == NULL){
              continue;
            }
            if (child->existProperty(WSNx)      != False &&
                child->existProperty(WSNy)      != False &&
                child->existProperty(WSNwidth)  != False &&
                child->existProperty(WSNheight) != False ){
              short x,y;
              WSCushort w,h;
              child->getPropertyV(WSNx,&x);
              child->getPropertyV(WSNy,&y);
              child->getPropertyV(WSNwidth,&w);
              child->getPropertyV(WSNheight,&h);
              if ( px >= x   && py >= y   &&
                   px < x + w && py <= y + h &&
                   child->getVisible() != False ){
                return;
              }
            }
          }
        }
      }
    }

  WSCbase* mt =  (WSCbase*)client->getUserData("PM-MODAL-TARGET");
  client->setUserData("PM-MODAL-TARGET",NULL);
  WSCbase* tclient = client;
  if (mt != NULL){
    tclient = mt;
  }

  if (_popuped_instance != NULL){
    return;
  }
  WSCpopupMenu* obj = (WSCpopupMenu*)client->getUserData("PM-SERVER");
  if (obj == NULL){
    return;
  }
  if (WSGIappMouse()->getTargetBtn() != WS_MOUSE_BTN3){
    WSGIappDev()->setMenuFocusInstance(obj,client);
    return;
  }

  if (obj->_client != NULL && obj->_client != (void*)client){
    if (WSCpopupMenu::_on_fire_client != NULL){
      if (client->isParent((WSCbase*)WSCpopupMenu::_on_fire_client) != False){
        //OK..
      }else{
        return;
      }
    }else{
      return;
    }
  }else if (obj->_client == NULL){
    if (WSCpopupMenu::_on_fire_client != NULL){
      if (client->isParent((WSCbase*)WSCpopupMenu::_on_fire_client) != False){
        //OK..
      }else{
        return;
      }
    }
  }

  if (client->getSensitive() == False){
    return;
  }
  if (obj->_press_state != False){
    return;
  }
#if 0 //changed for calling _menu_popup() in _on_btn_release..
  client->setUserData("PM-POPUP",(void*)1);
  obj->_press_state = True;
  if ((tclient->getObjectType() & WS_TYPE_NON_WINDOW) != 0){
    if (tclient->getOutSideMousePress() == False){
      tclient->setOutSideMousePress(True);
      tclient->setUserData("OSMP-ch",(void*)1);
    }
    if (tclient->getOutSideMouseMove() == False){
      tclient->setOutSideMouseMove(True);
      tclient->setUserData("OSMM-ch",(void*)1);
    }
    if (tclient->getOutSideMouseRelease() == False){
      tclient->setOutSideMouseRelease(True);
      tclient->setUserData("OSMR-ch",(void*)1);
    }
    if (tclient->getMouseGrabed() == False){
      tclient->setMouseGrabed(True);
      tclient->setUserData("MG-ch",(void*)1);
    }
  }
#endif
//printf("WSCpopupMenu::_on_btn_press pm=%s client=%s tclient=%s\n",obj->getInstanceName(),client->getInstanceName(),tclient->getInstanceName());
  obj->_client = (void*)client;
  obj->_on_fire_client = tclient;
#if 0 //changed for calling _menu_popup() in _on_btn_release..
  long ret = obj->_popup_menu();
  if (ret != WS_ERR){
#ifndef NO_MODAL
    WSGIappDev()->setPopupModalClient(tclient);
#endif
    client->setUserData(WS_PM_POPUPED,(void*)1);
  }
#endif
}
WSCbase* WSCpopupMenu::_on_fire_client = NULL;

void WSCpopupMenu::_on_btn_release(WSCbase* client){
//printf("WSCpopupMenu::_on_btn_release... client=%s\n",client->getInstanceName());
  WSCpopupMenu* obj = (WSCpopupMenu*)client->getUserData("PM-SERVER");
  if (obj == NULL){
    return;
  }
  if (obj->_on_fire_client != NULL){
    if (obj->_client == client){
      client->setUserData("PM-POPUP",(void*)1);
      obj->_press_state = True;
      WSCbase* tclient = obj->_on_fire_client;
//printf("WSCpopupMenu::_on_btn_release... onfire.. client=%s tclient=%s\n",client->getInstanceName(),tclient->getInstanceName());
      if ((tclient->getObjectType() & WS_TYPE_NON_WINDOW) != 0){
        if (tclient->getOutSideMousePress() == False){
//printf("WSCpopupMenu::_on_btn_release... outside.. client=%s tclient=%s\n",client->getInstanceName(),tclient->getInstanceName());
          tclient->setOutSideMousePress(True);
          tclient->setUserData("OSMP-ch",(void*)1);
        }
        if (tclient->getOutSideMouseMove() == False){
          tclient->setOutSideMouseMove(True);
          tclient->setUserData("OSMM-ch",(void*)1);
        }
        if (tclient->getOutSideMouseRelease() == False){
          tclient->setOutSideMouseRelease(True);
          tclient->setUserData("OSMR-ch",(void*)1);
        }
        if (tclient->getMouseGrabed() == False){
          tclient->setMouseGrabed(True);
          tclient->setUserData("MG-ch",(void*)1);
        }
      }
      obj->_on_fire_client = NULL;

      WSDdev* dev = tclient->getowndev();
      if ((tclient->getObjectType() & WS_TYPE_NON_WINDOW)!=0){
        dev = dev->getEventParentDev();
      }
      if (dev != NULL){
#ifndef NO_MODAL
        obj->_modal_bk = WSGIappDev()->getModalClient();
        if (tclient != obj->_modal_bk){
          WSGIappDev()->addModalClient(tclient);
          obj->_modal_bk = tclient;
        }else{
          obj->_modal_bk = NULL;
        }
#endif
        WSCbool fl = True;
        WSGIappMouse()->setMouseUngrabClient(obj);
        dev->setValue(WSDEV_GRAB_POINTER,&fl);
        obj->_grabed = True;
        if ((tclient->getObjectType() & WS_TYPE_NON_WINDOW) != 0){
          tclient->setMouseGrabed(True);
        }
      }
      long ret = obj->_popup_menu();
      if (ret != WS_ERR){
#ifndef NO_MODAL
        WSGIappDev()->setPopupModalClient(tclient);
#endif
        client->setUserData(WS_PM_POPUPED,(void*)1);
      }
      return;
    }else{
      return;
    }
  }
  if (obj->getVisible() == False){
    return;
  }

  WSCbase* mt =  (WSCbase*)client->getUserData("PM-MODAL-TARGET");
  client->setUserData("PM-MODAL-TARGET",NULL);
  WSCbase* tclient = client;
  if (mt != NULL){
    tclient = mt;
  } 

  if (obj->_client != NULL && obj->_client != (void*)client){
    return;
  }
  if (obj->_grabed == 0){
    if (WSGIappMouse()->getTargetBtn() != WS_MOUSE_BTN3){
//printf("WSCpopupMenu::_on_btn_release returned..\n");
      return;
    }
  }

  if (obj->_grabed == 0 && obj->_selected == False){
    WSDdev* dev = tclient->getowndev();
//WSMFtrace("WSCpopupMenu::_on_btn_release here----------- client=%s\n",client->getInstanceName()); 
    if ((tclient->getObjectType() & WS_TYPE_NON_WINDOW)!=0){
      dev = dev->getEventParentDev();
    }
    if (dev != NULL){
//printf("_on_btn_release.. grab.. devdl=%s\n",dev->getAttachedClient()->getInstanceName());
//WSMFtrace("WSCpopupMenu::_on_btn_release grabed  %s!!!!!!!!!!!!\n",dev->getClassName());
#ifndef NO_MODAL
      obj->_modal_bk = WSGIappDev()->getModalClient();
//      WSGIappDev()->setModalClient(tclient);
      if (tclient != obj->_modal_bk){
        WSGIappDev()->addModalClient(tclient);
        obj->_modal_bk = tclient;
      }else{
        obj->_modal_bk = NULL;
      }
#endif
      WSCbool fl = True;
      WSGIappMouse()->setMouseUngrabClient(obj);
      dev->setValue(WSDEV_GRAB_POINTER,&fl);
      obj->_grabed = True;
      if ((tclient->getObjectType() & WS_TYPE_NON_WINDOW) != 0){
        tclient->setMouseGrabed(True);
      }
    }
//printf("popup:: grabed...\n");
    return;
  }else if (obj->_grabed != 0){
    WSCbool fl = False;
//    WSDdev* dev = tclient->getdev();
    WSDdev* dev = tclient->getowndev();
    if ((tclient->getObjectType() & WS_TYPE_NON_WINDOW)!=0){
      dev = dev->getEventParentDev();
    }
    if (dev != NULL){
//WSMFtrace("WSCpopupMenu::_on_btn_press grab -> false\n");
//      WSGIappDev()->setModalClient(obj->_modal_bk);
#ifndef NO_MODAL
      if (obj->_modal_bk != NULL){
        WSGIappDev()->deleteModalClient(obj->_modal_bk);
      }
#endif
      WSGIappMouse()->setMouseUngrabClient(NULL);
      dev->setValue(WSDEV_GRAB_POINTER,&fl);
      obj->_grabed = False;
//printf("popup:: grabed canceled...\n");
    }
  } 
 
  if ((long)client->getUserData("PM-POPUP") == 0){
    return;
  }
  if ((tclient->getObjectType() & WS_TYPE_NON_WINDOW) != 0){
    if ((long)tclient->getUserData("OSMP-ch") == 1){
      tclient->setOutSideMousePress(False);
      tclient->setUserData("OSMP-ch",(void*)0);
    }
    if ((long)tclient->getUserData("OSMM-ch") == 1){
      tclient->setOutSideMouseMove(False);
      tclient->setUserData("OSMM-ch",(void*)0);
    }
    if ((long)tclient->getUserData("OSMR-ch") == 1){
      tclient->setOutSideMouseRelease(False);
      tclient->setUserData("OSMR-ch",(void*)0);
    }
    if ((long)tclient->getUserData("MG-ch") == 1){
      tclient->setMouseGrabed(False);
      tclient->setUserData("MG-ch",(void*)0);
    }
  }
  client->setUserData(WS_PM_POPUPED,(void*)0);
  long val = obj->getValue();
  if (obj->getValueToggleMenu(val) != False &&
      obj->getValueSensitive(val) != False){
    WSCbool fl = obj->getValueToggleState(val);
    if (fl == False){
      obj->setValueToggleState(val,True);
    }else{
      obj->setValueToggleState(val,False);
    }
  }
  obj->execProcedure(WSEV_VALUE_CH);

//printf("WSCpopupMenu::_on_btn_release pm=%s client=%s\n",obj->getInstanceName(),client->getInstanceName());
  obj->_popdown_and_execute();
//printf("popup:: popdown...\n");
}

void WSCpopupMenu::_on_btn_move(WSCbase* client){
  WSCpopupMenu* obj = (WSCpopupMenu*)client->getUserData("PM-SERVER");
  if (obj == NULL){
    return;
  }
//WSMFtrace("WSCpopupMenu::_on_btn_move()  grabed=%d\n",obj->_grabed);
  if (obj->_grabed == False){
//    if (WSGIappMouse()->getTargetBtn() != WS_MOUSE_BTN3){
    if ((WSGIappMouse()->getStatus() & WS_MOUSE_BTN3) == 0){
      return;
    }
  }
  if ((long)client->getUserData("PM-POPUP") == 0){
    return;
  }
  short x, y;
  WSCbool ret = WSGIappMouse()->getMousePosition(&x, &y);
  if (ret != False){
    obj->setAbsoluteDraw(True);
    obj->draw();
  }
}

void WSCpopupMenu::_on_btn_press_recursive(WSCbase* client){
  WSCpopupMenu* obj = (WSCpopupMenu*)client->getUserData("PM-SERVER");
  WSCbase* parent = client->getParent();
  if (parent != NULL){
    WSCpopupMenu* obj2 = (WSCpopupMenu*)parent->getUserData("PM-SERVER");
    if (obj == obj2){
      if (client->getUserData("PM-MODAL-TARGET") == NULL){
        parent->setUserData("PM-MODAL-TARGET",(void*)client);
      }else{
        parent->setUserData("PM-MODAL-TARGET",
                            client->getUserData("PM-MODAL-TARGET"));
        client->setUserData("PM-MODAL-TARGET",NULL);
      }
      parent->execProcedure("PM_btn_press");
    }
  }
}
void WSCpopupMenu::_on_btn_release_recursive(WSCbase* client){
  WSCpopupMenu* obj = (WSCpopupMenu*)client->getUserData("PM-SERVER");
  WSCbase* parent = client->getParent();
  if (parent != NULL){
    WSCpopupMenu* obj2 = (WSCpopupMenu*)parent->getUserData("PM-SERVER");
    if (obj == obj2){
      if (client->getUserData("PM-MODAL-TARGET") == NULL){
        parent->setUserData("PM-MODAL-TARGET",(void*)client);
      }else{
        parent->setUserData("PM-MODAL-TARGET",
                            client->getUserData("PM-MODAL-TARGET"));
        client->setUserData("PM-MODAL-TARGET",NULL);
      }
      parent->execProcedure("PM_btn_release");
    }
  }
}
void WSCpopupMenu::_on_btn_move_recursive(WSCbase* client){
  WSCpopupMenu* obj = (WSCpopupMenu*)client->getUserData("PM-SERVER");
  WSCbase* parent = client->getParent();
  if (parent != NULL){
    WSCpopupMenu* obj2 = (WSCpopupMenu*)parent->getUserData("PM-SERVER");
    if (obj == obj2){
      parent->execProcedure("PM_btn_move");
    }
  }
}

long WSCpopupMenu::beginCascade(char* lb){
  WSCstring str(_menu_string);
  str.delHeadSpace();
  str.delTailSpace();
  if (strcmp(str.getString(),"")){
    str += _separator2;
  }
  str = str + lb + _separator + "{";
  setPropertyV(WSNmenuItems,str.getString());
  return WS_NO_ERR;
}
long WSCpopupMenu::endCascade(char* pix){
  WSCstring str(_menu_string);
  str += "}";
  if (pix != NULL){
    str += ":";
    str += pix;
  }
  setPropertyV(WSNmenuItems,str.getString());
  return WS_NO_ERR;
}
long WSCpopupMenu::addItem(char* lb,char* op,char* sc,long id,char *px){
//---
  WSCstring str(_menu_string);
  if (_menu_string[0] != 0 && _menu_string[strlen(_menu_string)-1] != '{'){
    str += _separator2;
  }
//--- [20041015]
  if (px == NULL){
    str = str + lb + _separator + op + _separator + sc + _separator + WSGFltoa(id);
  }else{
    str = str + lb + _separator + op + _separator + sc + _separator + WSGFltoa(id) + _separator + px;
  }
//---
  setPropertyV(WSNmenuItems,str.getString());
  return WS_NO_ERR;
}

long WSCpopupMenu::popup(){
  _internal_popup = True;
  int ret = _popup_menu();
  if (ret == WS_ERR){
    return ret;
  }
  WSDdev* dev = getowndev();
  if (dev != NULL){
    WSCbool fl = True;
    WSGIappMouse()->setMouseUngrabClient(this);
    dev->setValue(WSDEV_GRAB_POINTER,&fl);
    _grabed = True;
    dev->setEnableEventBit( WSEV_MOUSE_MOVE_BIT | WSEV_MOUSE_OUT_BIT |
                            WSEV_MOUSE_IN_BIT |
                            WSEV_MOUSE_PRESS_BIT | WSEV_MOUSE_RELEASE_BIT );
  }
  WSGIappDev()->setFocusDialog(this,True);

  while(1){
    if (_internal_popup == 0){
      break;
    }
    WSGIappDev()->setFocusDialog(this,True);
    WSGIappDev()->dispatchEvent();
    WSGIappDevice()->clearDeleteList();
  }
  return WS_NO_ERR;
}

void WSCpopupMenu::onMousePress(WSCpoint* pt){
  if (_internal_popup == False){
    return;
  }
}
void WSCpopupMenu::onMouseMove(WSCpoint* pt){
  if (_internal_popup == False){
    return;
  }
  short x, y;
  WSCbool ret = WSGIappMouse()->getMousePosition(&x, &y);
  if (ret != False){
    setAbsoluteDraw(True);
    draw();
  }
}
void WSCpopupMenu::onMouseRelease(WSCpoint* pt){
  if (_internal_popup == False){
    return;
  }
  if (_grabed != False){
    WSDdev* dev = getowndev();
    WSCbool fl = False;
    if (dev != NULL){
      WSGIappMouse()->setMouseUngrabClient(NULL);
      dev->setValue(WSDEV_GRAB_POINTER,&fl);
    }
    _grabed = False;
  }
  if (_selected != False){
    long val = getValue();
    if (getValueToggleMenu(val) != False &&
        getValueSensitive(val) != False){
      WSCbool fl = getValueToggleState(val);
      if (fl == False){
        setValueToggleState(val,True);
      }else{
        setValueToggleState(val,False);
      }
    }
    execProcedure(WSEV_VALUE_CH);

    _popdown_and_execute();




  }else{
    _internal_popup = False;
    WSGIappKeyboard()->resetFocusInputWorkProc();
    setVisible(False);
    if (_popuped_instance == this){
      _popuped_instance = NULL;
    }
    _client = NULL;
  }
}
void WSCpopupMenu::_key_handler(void* ptr,WSDkeyboard* keyboard,WSCbool fl){
  WSCpopupMenu* obj = (WSCpopupMenu*)ptr;
  if (fl != False){
    long key = keyboard->getKey();
    char* text = keyboard->getText();
    if (obj->getVisible() != False){
      char buf[2];
      buf[0] = (char)toupper(text[0]);
      buf[1] = 0;
//      WSCstring pname = obj->_get_proc_name_by_sc(obj->_menu_str,buf);
      int act_val = -1;
      WSCstring pname = obj->_get_proc_name_by_sc(buf,&act_val);
      if (strcmp(buf,"") && strcmp((char*)pname,"")){
        if (obj->_client != NULL){
          WSCbase* client = (WSCbase*)obj->_client;
          WSCbase* mt =  (WSCbase*)client->getUserData("PM-MODAL-TARGET");
          client->setUserData("PM-MODAL-TARGET",NULL);
          WSCbase* tclient = client;
          if (mt != NULL){
            tclient = mt;
          }

          if (obj->_grabed != 0){
            WSCbool fl = False;
//            WSDdev* dev = tclient->getdev();
            WSDdev* dev = tclient->getowndev();
            if ((tclient->getObjectType() & WS_TYPE_NON_WINDOW) != 0){
              dev = dev->getEventParentDev();
            }
            if (dev != NULL){
//WSMFtrace("WSCpopupMenu::_on_btn_press grab -> false\n");
//              WSGIappDev()->setModalClient(obj->_modal_bk);
#ifndef NO_MODAL
              if (obj->_modal_bk){
                WSGIappDev()->deleteModalClient(obj->_modal_bk);
              }
#endif
              WSGIappMouse()->setMouseUngrabClient(NULL);
              dev->setValue(WSDEV_GRAB_POINTER,&fl);
              obj->_grabed = False;
//printf("popup:: grabed canceled...\n");
            }
          }
          if ((long)client->getUserData("PM-POPUP") == 0){
            return;
          }
          if ((tclient->getObjectType() & WS_TYPE_NON_WINDOW) != 0){
            if ((long)tclient->getUserData("OSMP-ch") == 1){
              tclient->setOutSideMousePress(False);
              tclient->setUserData("OSMP-ch",(void*)0);
            }
            if ((long)tclient->getUserData("OSMM-ch") == 1){
              tclient->setOutSideMouseMove(False);
              tclient->setUserData("OSMM-ch",(void*)0);
            }
            if ((long)tclient->getUserData("OSMR-ch") == 1){
              tclient->setOutSideMouseRelease(False);
              tclient->setUserData("OSMR-ch",(void*)0);
            }
            if ((long)tclient->getUserData("MG-ch") == 1){
              tclient->setMouseGrabed(False);
              tclient->setUserData("MG-ch",(void*)0);
            }
          }
          client->setUserData(WS_PM_POPUPED,(void*)0);
        }

        if (obj->getValueToggleMenu(act_val) != False &&
            obj->getValueSensitive(act_val) != False){
          WSCbool fl = obj->getValueToggleState(act_val);
          if (fl == False){
            obj->setValueToggleState(act_val,True);
          }else{
            obj->setValueToggleState(act_val,False);
          }
        }
       obj->_prc_name.setString((char*)pname);
       obj->_popdown_and_execute();
#if 0
        obj->popdown();
        obj->execProcedure(WSEV_VALUE_CH);
            
        if (obj->getSensitive() != False){
          obj->onActivate();
          obj->execProcedure((char*)pname);
        }
#endif
      }else
      if (key == WSK_Up || key == WSK_Down || key == WSK_Left || key == WSK_Right){
        obj->setUserData("KEY_PROCESSED",(void*)0);
        obj->onKeyPress(keyboard,fl);
      }else
      if (key == WSK_Escape || key == WSK_Super_L || key == WSK_Super_R ||
          key == WSK_Control_L || key == WSK_Control_R || key == WSK_Apps ||
          key == WSK_Alt_L || key == WSK_Alt_R ||
          key == WSK_Meta_L || key == WSK_Meta_R || key == WSK_Return ||
          key == WSK_KP_Enter){
//        obj->setSelected(False);
//        WSCpoint pt;
//        pt.x = 1;
//        pt.y = 1;
//        obj->onMousePress(&pt);
//        obj->onMouseRelease(&pt);
        keyboard->setKey(0);
        if (obj->getVisible() == False){
          return;
        }
        if (obj->_client != NULL){
          WSCbase* client = (WSCbase*)obj->_client;
          WSCbase* mt =  (WSCbase*)client->getUserData("PM-MODAL-TARGET");
          client->setUserData("PM-MODAL-TARGET",NULL);
          WSCbase* tclient = client;
          if (mt != NULL){
            tclient = mt;
          }

          if (obj->_grabed != 0){
            WSCbool fl = False;
//            WSDdev* dev = tclient->getdev();
            WSDdev* dev = tclient->getowndev();
            if ((tclient->getObjectType() & WS_TYPE_NON_WINDOW) != 0){
              dev = dev->getEventParentDev();
            }
            if (dev != NULL){
//WSMFtrace("WSCpopupMenu::_on_btn_press grab -> false\n");
//              WSGIappDev()->setModalClient(obj->_modal_bk);
#ifndef NO_MODAL
              if (obj->_modal_bk){
                WSGIappDev()->deleteModalClient(obj->_modal_bk);
              }
#endif
              WSGIappMouse()->setMouseUngrabClient(NULL);
              dev->setValue(WSDEV_GRAB_POINTER,&fl);
              obj->_grabed = False;
//printf("popup:: grabed canceled...\n");
            }
          }
          if ((long)client->getUserData("PM-POPUP") == 0){
            return;
          }
          if ((tclient->getObjectType() & WS_TYPE_NON_WINDOW) != 0){
            if ((long)tclient->getUserData("OSMP-ch") == 1){
              tclient->setOutSideMousePress(False);
              tclient->setUserData("OSMP-ch",(void*)0);
            }
            if ((long)tclient->getUserData("OSMM-ch") == 1){
              tclient->setOutSideMouseMove(False);
              tclient->setUserData("OSMM-ch",(void*)0);
            }
            if ((long)tclient->getUserData("OSMR-ch") == 1){
              tclient->setOutSideMouseRelease(False);
              tclient->setUserData("OSMR-ch",(void*)0);
            }
            if ((long)tclient->getUserData("MG-ch") == 1){
              tclient->setMouseGrabed(False);
              tclient->setUserData("MG-ch",(void*)0);
            }
          }
          client->setUserData(WS_PM_POPUPED,(void*)0);

          if (obj->_selected == True && key == WSK_Return){
            long val = obj->getValue();
            if (obj->getValueToggleMenu(val) != False &&
                obj->getValueSensitive(val) != False){
              WSCbool fl = obj->getValueToggleState(val);
              if (fl == False){
                obj->setValueToggleState(val,True);
              }else{
                obj->setValueToggleState(val,False);
              }
            }
            obj->execProcedure(WSEV_VALUE_CH);
            obj->_popdown_and_execute();
            return;
          }

        }
        obj->popdown();
      }
    }
  }
}
long WSCpopupMenu::execEventProc(long ev,void* data){
  if (ev == WSEV_GRAB_CANCELED){
    popdown();
  }else
  if (ev == WSEV_KEY_PRESS){
    onKey(WSGIappKeyboard(),True);
  }else
  if (ev == WSEV_KEY_RELEASE){
    onKey(WSGIappKeyboard(),False);
  }
  return WSCpulldownMenuPopup::execEventProc(ev,data);
}
void WSCpopupMenu::onKey(WSDkeyboard* keyb,WSCbool fl){
  if (keyb->getKey() == WSK_Menu && fl == True){
    WSCbase* client = WSGIappDev()->getMenuFocusClient();

    WSCbase* mt =  (WSCbase*)client->getUserData("PM-MODAL-TARGET");
    client->setUserData("PM-MODAL-TARGET",NULL);
    WSCbase* tclient = client;
    if (mt != NULL){
      tclient = mt;
    }

    if (_popuped_instance != NULL){
      return;
    }
    WSCpopupMenu* obj = (WSCpopupMenu*)client->getUserData("PM-SERVER");
    if (obj != this){
      return;
    }

    if (_on_fire_client != NULL){
      return;
    }

    if (client->getSensitive() == False){
      return;
    }
    if (_press_state != False){
      return;
    }
    client->setUserData("PM-POPUP",(void*)1);
    _press_state = True;
    if ((tclient->getObjectType() & WS_TYPE_NON_WINDOW) != 0){
      if (tclient->getOutSideMousePress() == False){
        tclient->setOutSideMousePress(True);
        tclient->setUserData("OSMP-ch",(void*)1);
      }
      if (tclient->getOutSideMouseMove() == False){
        tclient->setOutSideMouseMove(True);
        tclient->setUserData("OSMM-ch",(void*)1);
      }
      if (tclient->getOutSideMouseRelease() == False){
        tclient->setOutSideMouseRelease(True);
        tclient->setUserData("OSMR-ch",(void*)1);
      }
      if (tclient->getMouseGrabed() == False){
        tclient->setMouseGrabed(True);
        tclient->setUserData("MG-ch",(void*)1);
      }
    }
    _client = (void*)client;

    WSDdev* dev = tclient->getowndev();
    if ((tclient->getObjectType() & WS_TYPE_NON_WINDOW)!=0){
      dev = dev->getEventParentDev();
    }
    if (dev != NULL){
#ifndef NO_MODAL
      _modal_bk = WSGIappDev()->getModalClient();
      if (tclient != obj->_modal_bk){
        WSGIappDev()->addModalClient(tclient);
        _modal_bk = tclient;
      }else{
        _modal_bk = NULL;
      }
#endif
      WSCbool fl = True;
      WSGIappMouse()->setMouseUngrabClient(obj);
      dev->setValue(WSDEV_GRAB_POINTER,&fl);
      _grabed = True;
      if ((tclient->getObjectType() & WS_TYPE_NON_WINDOW) != 0){
        tclient->setMouseGrabed(True);
      }
    }
    _popup_on_client_site = True;
    long ret = _popup_menu();
    if (ret != WS_ERR){
#ifndef NO_MODAL
      WSGIappDev()->setPopupModalClient(tclient);
#endif
      client->setUserData(WS_PM_POPUPED,(void*)1);
    }
  }
}
