//
// Copyright (C) 1999-2008 WideStudio/MWT Project Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
//

#include <WScom.h>
#include <WSCtouchScr.h>
#include <WSCclassInformation.h>
#include <WSCdevice.h>
#include <WSDdev.h>
#include <WSDmouse.h>
#include <WSDwindowDev.h>
#include <WSDprivateTimer.h>

WSMFguiClassInitialize(WSCtouchScr,WSCscrFrame);
WSMFversion(WSCtouchScr,WSCscrFrame);
WSMFdefineUseDevice(WSCtouchScr,scrFrameDev)

WSCtouchScr::WSCtouchScr(WSCbase* base,char* objname):
                WSCscrFrame(base,objname){

  _ax = 0;
  _ay = 0;
  _timer = NULL;
  _tx = 0;
  _ty = 0;
  _count = 0;
  _value = 32;
  _scrolling = False;

  WSMFpropertyCreateStart
      WSMFparentCheckVerSrc(WSCtouchScr);
      WSMFpropertyCreate(WSNvalue,    WSCuchar,_value,WSSvalue);

  WSMFpropertyCreateEnd

}

WSMFproperty( WSCtouchScr, WSNvalue,    WSCuchar, _value    ,32);

void WSCtouchScr::setWorkWSNvalue(WSCuchar data){
} 
void WSCtouchScr::getWorkWSNvalue(WSCuchar* data){
} 

void WSCtouchScr::_timer_work(void* ptr){
  WSCtouchScr* _this = (WSCtouchScr*)ptr;
  long wx,wy;
  wx = _this->_s_w; //x of work area
  wy = _this->_s_h; //y of work area
  if ( _this->_scrolling == False){
    return;
  }

  if (_this->_count ==0){
    short px,py;
    WSGIappMouse()->getMousePosition(&px,&py,_this);
    _this->_ax = _this->_tx -px;
    _this->_ay = _this->_ty -py;
  }else{
    long value = (long)_this->_value;
    if (value < 1){
      value = 2;
    }
    _this->_ax = _this->_ax*(value-1)/value;
    _this->_ay = _this->_ay*(value-1)/value;
    if (_this->_count > 0){
      _this->_count--;
    }
    if (_this->_count == 1){
      _this->_timer->stopTimer();
      _this->_scrolling = False;
    }
  }

  wx += _this->_ax;
  wy += _this->_ay;
  if (wx < 0){
    wx = 0;
  }
  if (wy < 0){
    wy = 0;
  }
  long wmax = _this->_w_w;
  long hmax = _this->_w_h;
  if (wx > wmax){
    wx = wmax;
  }
  if (wy > hmax){
    wy = hmax;
  }
  _this->setHbarValue(wx);
  _this->setVbarValue(wy);
}

void WSCtouchScr::onMousePress(WSCpoint* pt){
  WSCbase::onMousePress(pt);
  if (_timer == NULL){
    _timer = WSDprivateTimer::getNewInstance();
    _timer->setRate(50);
    _timer->setCont(True);
    _timer->setWorkProc(_timer_work,(void*)this);
  }
  _count = 0;
  if (_timer != NULL){
    _timer->startTimer();
    _scrolling = True;
  }
  _tx = pt->x;
  _ty = pt->y;
}
void WSCtouchScr::onMouseRelease(WSCpoint* pt){
  WSCbase::onMouseRelease(pt);
  _count = 32; 
}
#ifndef WS_EMBED
long WSCtouchScr::drawGriphand(){
  if (_show_grip_hand == False){
    return WS_NO_ERR;
  }
  short x,y;
  WSCushort w,h;
  if (existProperty(WSNx) == False ||
      existProperty(WSNy) == False ||
      existProperty(WSNwidth) == False ||
      existProperty(WSNheight) == False ){
    return WS_ERR;
  }

  getPropertyV(WSNx,&x);
  getPropertyV(WSNy,&y);
  getPropertyV(WSNwidth,&w);
  getPropertyV(WSNheight,&h);

  _draw_grip_hand(x,y,w,h);
  return WS_NO_ERR;
}

extern void _griph_geom_handler(WSCbase* base,short no,short diff_x,short diff_y);

void WSCtouchScr::_draw_grip_hand(short x,short y,WSCushort w,WSCushort h){

#ifndef NO_GRIPHAND
  WSClistData* glist = (WSClistData*)getUserData("GH-LIST");
  long i;
  WSCbase* gh = NULL;
  if (glist == NULL){
    glist = new WSClistData(16);
    setUserData("GH-LIST",glist);

//DEVELOP ////////////////////////////
//to implement settings of mouse shages...
    WSCbase* parent = getParent();
    for(i=0; i<9; i++){
      gh = WSGFgetNewGripHand(parent);
      if (i % 2 == 1){
        if (i == 1 || i == 5){
          WSCushort h;
          gh->getPropertyV(WSNheight,&h);
          h = h/2;
          gh->setPropertyV(WSNheight,h);
        }else{
          WSCushort w;
          gh->getPropertyV(WSNwidth,&w);
          w = w/2;
          gh->setPropertyV(WSNwidth,w);
        }
      }
      gh->setUserData(WS_GRIPH_HANDLER,(void*)_griph_geom_handler);
      gh->setUserData("CLIENT",(void*)this);
      gh->setUserData("GH-NO",(void*)i);
      glist->add( gh );
    }   
  }
  gh = (WSCbase*)(*glist)[0];
  gh->setPropertyV(WSNx,x);
  gh->setPropertyV(WSNy,y);
  gh->setPropertyV(WSNmouse,(WSCushort)195);
  gh = (WSCbase*)(*glist)[1];
  gh->setPropertyV(WSNx, (short)(x + w/2 - WS_GRIPH_SIZE) );
  gh->setPropertyV(WSNy,y);
  gh->setPropertyV(WSNmouse,(WSCushort)197);
  gh = (WSCbase*)(*glist)[2];
  gh->setPropertyV(WSNx, (short)(x + w - WS_GRIPH_SIZE*2) );
  gh->setPropertyV(WSNy,y);
  gh->setPropertyV(WSNmouse,(WSCushort)196);
  gh = (WSCbase*)(*glist)[3];
  gh->setPropertyV(WSNx, (short)(x + w - WS_GRIPH_SIZE) );
  gh->setPropertyV(WSNy, (short)(y + h/2 - WS_GRIPH_SIZE) );
  gh->setPropertyV(WSNmouse,(WSCushort)176);
  gh = (WSCbase*)(*glist)[4];
  gh->setPropertyV(WSNx, (short)(x + w - WS_GRIPH_SIZE*2) );
  gh->setPropertyV(WSNy, (short)(y + h - WS_GRIPH_SIZE*2) );
  gh->setPropertyV(WSNmouse,(WSCushort)135);
  gh = (WSCbase*)(*glist)[5];
  gh->setPropertyV(WSNx, (short)(x + w/2 - WS_GRIPH_SIZE) );
  gh->setPropertyV(WSNy, (short)(y + h - WS_GRIPH_SIZE) );
  gh->setPropertyV(WSNmouse,(WSCushort)136);
  gh = (WSCbase*)(*glist)[6];
  gh->setPropertyV(WSNx, x );
  gh->setPropertyV(WSNy, (short)(y + h - WS_GRIPH_SIZE*2) );
  gh->setPropertyV(WSNmouse,(WSCushort)134);
  gh = (WSCbase*)(*glist)[7];
  gh->setPropertyV(WSNx, x );
  gh->setPropertyV(WSNy, (short)(y + h/2 - WS_GRIPH_SIZE) );
  gh->setPropertyV(WSNmouse,(WSCushort)163);
  gh = (WSCbase*)(*glist)[8];
  gh->setPropertyV(WSNx, (short)(x + w/2 - WS_GRIPH_SIZE) );
  gh->setPropertyV(WSNy, (short)(y + h/2 - WS_GRIPH_SIZE) );
  gh->setPropertyV(WSNmouse,(WSCushort)154);

  for(i=0; i<9; i++){
    gh = (WSCbase*)(*glist)[i];
    gh->setVisible(True);
  }
#endif
}
#endif

