//
// Copyright (C) 1999-2009 WideStudio/MWT Project Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
//

#include <WScom.h>
#include <WSCvscrForm.h>
#include <WSCclassInformation.h>
#include <WSCvbscrBar.h>
#include <WSCscrFrame.h>
#include <WSCdevice.h>
#include <WSDdev.h>
#include <WSCbaseList.h>
#include <WSDappDev.h>
#include <WSDmouse.h>
#include <WSCguiPolicy.h>

#ifdef WS_EMBED
#include <WSCvscrBar.h>
#endif

#define NO_PIX

WSMFguiClassInitialize(WSCvscrForm,WSCvform);
WSMFversion(WSCvscrForm,WSCvform);

WSMFpropertyValueChange( WSCvscrForm, WSNshadowType , char,WS_SHADOW_IN);

WSCvscrForm::WSCvscrForm(WSCbase* base,char* objname):
                WSCvform(base,objname){
  _scr_area = NULL;
  _v_scr = NULL;
  _h_scr = NULL;

  _v_scr_slider_sz = 0;
  _h_scr_slider_sz = 0;
  _v_scr_max_sz = 0;
  _h_scr_max_sz = 0;

  _v_scr_x_bk = -1;
  _h_scr_y_bk = -1;
//  _scr_shadowthick_bk = 0xffff;

  _v_scr_w_bk = 0xffff;
  _h_scr_w_bk = 0xffff;
  _v_scr_h_bk = 0xffff;
  _h_scr_h_bk = 0xffff;

  _bar_thick = 16;
  _work_width   = 1000;
  _work_height  = 1000;
  _wx_pos  = 0;
  _wy_pos  = 0;
  _increment = 10;
  _page_increment = 100;
  _hbar_visible = True;
  _vbar_visible = True;
  _scroll_width  = 30;
  _scroll_height = 30;
//  _work_back_color = WSGFcolor("gray80");
//  _bar_back_color    = WSGFcolor("gray75");
  _work_back_color = WS_DF_WORKBACKCOLOR;
  _bar_back_color    = WS_DF_BARSHADOWCOLOR;
  _dev_is_public_dev = True;
  _shadow_type = WS_SHADOW_IN;
  _marginw = 4;
  _padding = 0;
#if 0
  _virtual_scr = True;
#endif
  _scr_offset_x = 0;
  _scr_offset_y = 0;
  _frame = True;
  _no_scroll = False;
  _update_work_area = False;

  WSGIappObjectList()->addEvent(this,WSEV_GUI_POLICY_CH);

  WSMFpropertyCreateStart
    WSMFparentCheckVerSrc(WSCvscrForm);

    WSMFpropertyCreate(WSNbarThickness, WSCushort, _bar_thick,WSSbarThickness );
    WSMFpropertyCreate(WSNworkWidth,  WSCushort, _work_width,WSSworkWidth   );
    WSMFpropertyCreate(WSNworkHeight, WSCushort, _work_height,WSSworkHeight  );
    WSMFpropertyCreate(WSNhbarValue,  WSCushort, _wx_pos,WSShbarValue  );
    WSMFpropertyCreate(WSNvbarValue,  WSCushort, _wy_pos,WSSvbarValue  );
    WSMFpropertyCreate(WSNincrement,    WSCushort, _increment,WSSincrement );
    WSMFpropertyCreate(WSNpageIncrement,WSCushort, _page_increment,WSSpageIncrement );
    WSMFpropertyCreate(WSNhbarVisible,WSCbool,_hbar_visible,WSShbarVisible );
      WSMFpropertySetSelection(WSRbool2,WSRbool2D);
    WSMFpropertyCreate(WSNvbarVisible,WSCbool, _vbar_visible,WSSvbarVisible );
      WSMFpropertySetSelection(WSRbool2,WSRbool2D);
    WSMFpropertyCreate(WSNworkBackColor,short,_work_back_color,WSSworkBackColor );
    WSMFpropertyCreate(WSNbarShadowColor, short,_bar_back_color, WSSbarShadowColor  );
    WSMFpropertyCreate(WSNscrollWidth,WSCushort,_scroll_width,WSSscrollWidth );
      WSMFpropertyVisibleOff(WSNscrollWidth);

    WSMFpropertyCreate(WSNscrollHeight,WSCushort,_scroll_height,WSSscrollHeight );
      WSMFpropertyVisibleOff(WSNscrollHeight);

    WSMFpropertyCreate(WSNmargin,WSCuchar,_marginw,WSSmargin );
//    WSMFpropertyCreate(WSNvirtualScroll,WSCbool,_virtual_scr,WSSvirtualScroll );
//      WSMFpropertySetSelection(WSRbool1,WSRbool1D);
    WSMFpropertyCreate(WSNframe,WSCbool,_frame,WSSframe );
      WSMFpropertySetSelection(WSRbool1,WSRbool1D);

    WSMFpropertyValueChangeDef( WSCvscrForm,WSNshadowType ,char);

    WSMFpropertyVisibleOff(WSNshadowType);
#ifndef NO_GRADATION
    WSMFpropertyDelete(WSNgradation);
    WSMFpropertyDelete(WSNgradationMargin);
#endif
    WSMFaddTrigger(WSEV_VALUE_CH    );
    WSMFaddTrigger(WSEV_ACTIVATE    );
    WSMFaddExtTrigger(WSEV_SCR_MOUSE_PRESS,"SCR-MOUSE-PRESS"  );
    WSMFaddExtTrigger(WSEV_SCR_MOUSE_RELEASE,"SCR-MOUSE-RELEASE"  );
    WSMFaddExtTrigger(WSEV_SCR_MOUSE_MOVE,"SCR-MOUSE-MOVE"  );
    WSMFaddExtTrigger(WSEV_SCR_MOUSE_DOUBLE_CLICK,"SCR-MOUSE-DCLICK"  );

  WSMFpropertyCreateEnd
}

WSCvscrForm::~WSCvscrForm(){
  WSGIappMouse()->deleteMouseFocusClient(this);
  WSGIappObjectList()->delEvent(this,WSEV_GUI_POLICY_CH);
}

WSMFproperty( WSCvscrForm, WSNbarThickness,  WSCushort, _bar_thick, 16);
WSMFproperty( WSCvscrForm, WSNworkWidth,     WSCushort, _work_width, 1000);
//WSMFproperty( WSCvscrForm, WSNworkHeight,    WSCushort, _work_height, 1000);
WSMFproperty( WSCvscrForm, WSNworkHeight,    WSCushort, _work_height, 500);
WSMFproperty( WSCvscrForm, WSNhbarValue,     WSCushort, _wx_pos,   0);
WSMFproperty( WSCvscrForm, WSNvbarValue,     WSCushort, _wy_pos,   0);
WSMFproperty( WSCvscrForm, WSNincrement,     WSCushort, _increment,  10);
WSMFproperty( WSCvscrForm, WSNpageIncrement, WSCushort, _page_increment, 100);
WSMFproperty( WSCvscrForm, WSNvbarVisible,   WSCbool, _vbar_visible, True);
WSMFproperty( WSCvscrForm, WSNhbarVisible,   WSCbool, _hbar_visible, True);
//WSMFproperty( WSCvscrForm, WSNworkBackColor, short, _work_back_color, WSGFcolor("gray80"));
WSMFproperty( WSCvscrForm, WSNworkBackColor, short, _work_back_color, WS_DF_WORKBACKCOLOR);
//WSMFproperty( WSCvscrForm, WSNbarShadowColor,short, _bar_back_color,WSGFcolor("gray75"));
WSMFproperty( WSCvscrForm, WSNbarShadowColor,short, _bar_back_color,WS_DF_BARSHADOWCOLOR);
WSMFproperty( WSCvscrForm, WSNscrollWidth,  WSCushort,_scroll_width,30);
WSMFproperty( WSCvscrForm, WSNscrollHeight, WSCushort,_scroll_height,30);
WSMFproperty( WSCvscrForm, WSNmargin, WSCuchar,_marginw,4);
//WSMFproperty( WSCvscrForm, WSNvirtualScroll, WSCbool,_virtual_scr,0);
WSMFproperty( WSCvscrForm, WSNframe, WSCbool,_frame,True);
#if 0
void WSCvscrForm::setWorkWSNpixmapStyle(WSCuchar data){
  if (_scr_area != NULL){
    _scr_area->setPropertyV(WSNpixmapStyle,data);
  }
#ifndef NO_PIX
  WSCvform::setWorkWSNpixmapStyle(data);
#endif //NO_PIX
}
#endif
void WSCvscrForm::setWorkWSNbarThickness(WSCushort){
  if (_scr_area != NULL){
    _adjust();
  }
}
void WSCvscrForm::getWorkWSNbarThickness(WSCushort*){}

void WSCvscrForm::setWorkWSNmargin(WSCuchar){
  if (_scr_area != NULL){
    _adjust();
  }
}
void WSCvscrForm::getWorkWSNmargin(WSCuchar*){}

void WSCvscrForm::setWorkWSNworkWidth(WSCushort data){
  if (data & 0x8000){
    data = 0x7fff;
    _work_width = 0x7fff;
  }
  if (_scr_area != NULL){
    _update_work_area = True;
    WSCulong slsize;
    _h_scr->getPropertyV(WSNsliderSize,&slsize);
    WSCulong pos;
    _h_scr->getPropertyV(WSNvalue,&pos);
    if (data < pos + slsize){
      if ((long)data - (long)slsize -1 > 0){
        setPropertyV(WSNhbarValue,(WSCushort)(data -slsize-1));
      }else{
        setPropertyV(WSNhbarValue,(WSCushort)0);
      }
    }
#if 0
    if (_virtual_scr == 0){
      _scr_area->setPropertyV(WSNworkWidth,data);
    }else{
#endif
      WSCushort ww_org = 0;
      _scr_area->getPropertyV(WSNworkWidth,&ww_org);
      if (ww_org > _w){
        if (ww_org > _w + 256){
          _scr_area->setPropertyV(WSNworkWidth,_w);
        }
      }else if (ww_org < _w){
        _scr_area->setProperty(WSNworkWidth,(_w+256));
      }
#if 0
    }
#endif
    if (data <_h_scr_slider_sz){
      _h_scr->setPropertyV(WSNsliderSize,(WSCulong)_h_scr_slider_sz);
    }
    _h_scr->setPropertyV(WSNmaximum,(WSCulong)data);
    _adjust();
  }
}

void WSCvscrForm::getWorkWSNworkWidth(WSCushort* ){
}

void WSCvscrForm::setWorkWSNworkHeight(WSCushort data){
  if (data & 0x8000){
    data = 0x7fff;
    _work_height = 0x7fff;
  }
  if (_scr_area != NULL){
    _update_work_area = True;
    WSCulong slsize;
    _v_scr->getPropertyV(WSNsliderSize,&slsize);
    WSCulong pos;
    _v_scr->getPropertyV(WSNvalue,&pos);

    if (data < pos + slsize){
      if ((long)data - (long)slsize-1 > 0){
        setPropertyV(WSNvbarValue,(WSCushort)(data -slsize-1));
      }else{
        setPropertyV(WSNvbarValue,(WSCushort)0);
      }
    }
#if 0
    if (_virtual_scr == 0){
      _scr_area->setPropertyV(WSNworkHeight,data);
      _scr_area->setAbsoluteDraw(False); //set work height clear bug fix
    }else{
#endif
      WSCushort wh_org = 0;
      _scr_area->getPropertyV(WSNworkHeight,&wh_org);
      if (wh_org > _h){
        if (wh_org > _h + 256){
          _scr_area->setPropertyV(WSNworkHeight,_h);
        }
      }else if (wh_org < _h){
        if (wh_org > _h + 256){
          _scr_area->setProperty(WSNworkHeight,(_h+256));
        }

      }
#if 0
    }
#endif
    if (data <_v_scr_slider_sz){
      _v_scr->setPropertyV(WSNsliderSize,(WSCulong)_v_scr_slider_sz);
    }
    _v_scr->setPropertyV(WSNmaximum,(WSCulong)data);
    _adjust();
  }
}

void WSCvscrForm::getWorkWSNworkHeight(WSCushort* ){
}

void WSCvscrForm::setWorkWSNhbarValue(WSCushort data){
  if (_scr_area != NULL){
    _scr_offset_x = -data;
#if 0
    if (_virtual_scr == False){
      _scr_area->setHbarValue(data);
    }else{
//      _scr_area->redraw();
#endif
      _redraw_scr();
#if 0
    }
#endif
    _h_scr->setPropertyV(WSNvalue,(WSCulong)data);
    _h_scr->setAbsoluteDraw(True);
    _h_scr->draw();
  }
}

void WSCvscrForm::getWorkWSNhbarValue(WSCushort*){
}

void WSCvscrForm::setWorkWSNvbarValue(WSCushort data){
  if (_scr_area != NULL){
    _scr_offset_y = -data;
#if 0
    if (_virtual_scr == False){
      _scr_area->setVbarValue(data);
    }else{
//      _scr_area->redraw();
#endif
      _redraw_scr();
#if 0
    }
#endif
    _v_scr->setPropertyV(WSNvalue,(WSCulong)data);
    _v_scr->setAbsoluteDraw(True);
    _v_scr->draw();
  }
}

void WSCvscrForm::getWorkWSNvbarValue(WSCushort*){
}

void WSCvscrForm::setWorkWSNtopShadowColor(short data){
  if (_scr_area != NULL){
    _h_scr->setPropertyV(WSNtopShadowColor,data);
    _v_scr->setPropertyV(WSNtopShadowColor,data);
  }
}
void WSCvscrForm::setWorkWSNbottomShadowColor(short data){
  if (_scr_area != NULL){
    _h_scr->setPropertyV(WSNbottomShadowColor,data);
    _v_scr->setPropertyV(WSNbottomShadowColor,data);
  }
}
void WSCvscrForm::setWorkWSNshadowThickness(WSCuchar data){
  if (_scr_area != NULL){
#ifndef NO_GUI_POLICY
    if (WSGIappDev()->getGuiPolicy() & WS_POLICY_ORIGINAL){
      _h_scr->setPropertyV(WSNshadowThickness,data);
      _v_scr->setPropertyV(WSNshadowThickness,data);
    }else
    if (WSGIappDev()->getGuiPolicy() & WS_POLICY_WINDOWS){
      _h_scr->setProperty(WSNshadowThickness,2);
      _v_scr->setProperty(WSNshadowThickness,2);
    }
#else
    _h_scr->setProperty(WSNshadowThickness,2);
    _v_scr->setProperty(WSNshadowThickness,2);
#endif
    _scr_area->setPropertyV(WSNx,(short)data);
    _scr_area->setPropertyV(WSNy,(short)(data + _padding));
    _scr_area->setAbsoluteDraw(False);
  }
}
void WSCvscrForm::setWorkWSNbackColor(short data){
  if (_scr_area != NULL){
    _h_scr->setPropertyV(WSNbackColor,data);
    _v_scr->setPropertyV(WSNbackColor,data);
  }
  if (_dev != NULL){
    _dev->setValue(WSDEV_BACKCOLOR,(void*)&data);
  }
}

void WSCvscrForm::setWorkWSNforeColor(short data){
  if (_scr_area != NULL){
    _h_scr->setPropertyV(WSNforeColor,data);
    _v_scr->setPropertyV(WSNforeColor,data);
  }
}

void WSCvscrForm::setWorkWSNbarShadowColor(short data){
  if (_scr_area != NULL){
    _h_scr->setPropertyV(WSNbarShadowColor,data);
    _v_scr->setPropertyV(WSNbarShadowColor,data);
  }
}

void WSCvscrForm::getWorkWSNbarShadowColor(short*){ }
void WSCvscrForm::setWorkWSNscrollWidth(WSCushort){ }
void WSCvscrForm::getWorkWSNscrollWidth(WSCushort*){ }
void WSCvscrForm::setWorkWSNscrollHeight(WSCushort){ }
void WSCvscrForm::getWorkWSNscrollHeight(WSCushort*){ }

void WSCvscrForm::setWorkWSNpageIncrement(WSCushort data){
  if (data == 0){
    data = 1;
    _page_increment = 1;
  }
  if (_scr_area != NULL){
    _v_scr->setPropertyV(WSNpageIncrement,data);
    _h_scr->setPropertyV(WSNpageIncrement,data);
  }
}
void WSCvscrForm::getWorkWSNpageIncrement(WSCushort*){ }

void WSCvscrForm::setWorkWSNincrement(WSCushort data){
  if (data == 0){
    data = 1;
    _increment = 1;
  }
  if (_scr_area != NULL){
    _v_scr->setPropertyV(WSNincrement,data);
    _h_scr->setPropertyV(WSNincrement,data);
  }
}
void WSCvscrForm::getWorkWSNincrement(WSCushort*){ }

void WSCvscrForm::setWorkWSNhbarVisible(WSCbool){
  if (_scr_area != NULL){
    _adjust();
  }
}
void WSCvscrForm::getWorkWSNhbarVisible(WSCbool*){ }

void WSCvscrForm::setWorkWSNvbarVisible(WSCbool){
  if (_scr_area != NULL){
    _adjust();
  }
}
void WSCvscrForm::getWorkWSNvbarVisible(WSCbool*){ }

void WSCvscrForm::setWorkWSNworkBackColor(short data){
  if (_scr_area != NULL){
    _scr_area->setPropertyV(WSNbackColor,data);
//    _scr_area->setPropertyV(WSNbackColor,WSGFcolor("red"));
  }
}
void WSCvscrForm::getWorkWSNworkBackColor(short*){ }
void WSCvscrForm::setWorkWSNframe(WSCbool fl){ };
void WSCvscrForm::getWorkWSNframe(WSCbool* fl){ };


long WSCvscrForm::initialize(){
  WSCvform::initialize();
  if (_scr_area == NULL){
    WSCstring scrname(getInstanceName());
    WSCstring addstr("-scr");
    scrname.addString(addstr);
//    _scr_area = new WSCscrFrame(this,scrname.getString());
    _scr_area = new WSCvform(this,scrname.getString());
    _scr_area->setInternalObject(True);
    _scr_area->setUseParentBaseDev(True);
    _scr_area->initialize();
    _scr_area_w = 0;
    _scr_area_h = 0;
    _dev_public = _scr_area;
    _scr_area->setNoExtGuiProc(True);
    _scr_area->setPropertyV(WSNshadowThickness,(WSCuchar)0);
    _scr_area->setPropertyV(WSNx,(short)_shadow_thick);
    _scr_area->setPropertyV(WSNy,(short)(_shadow_thick + _padding));
    _scr_area->setPropertyV(WSNbackColor,(short)_work_back_color);
    _scr_area->setVisible(True);
    WSCprocedure* op_p = new WSCprocedure("scrmp",WSEV_MOUSE_PRESS);
    op_p->setInternal(True);
    op_p->setFunction(_scr_mouse_press,"_scr_mouse_press");
    _scr_area->addProcedure(op_p);
    WSCprocedure* op_r = new WSCprocedure("scrmr",WSEV_MOUSE_RELEASE);
    op_r->setInternal(True);
    op_r->setFunction(_scr_mouse_release,"_scr_mouse_release");
    _scr_area->addProcedure(op_r);
    WSCprocedure* op_m = new WSCprocedure("scrmm",WSEV_MOUSE_MOVE);
    op_m->setInternal(True);
    op_m->setFunction(_scr_mouse_move,"_scr_mouse_move");
    _scr_area->addProcedure(op_m);
    WSCprocedure* op_dc = new WSCprocedure("scrmm",WSEV_MOUSE_DOUBLE_CLICK);
    op_dc->setInternal(True);
    op_dc->setFunction(_scr_mouse_dclick,"_scr_mouse_dclick");
    _scr_area->addProcedure(op_dc);

    scrname.setString(getInstanceName());
    addstr.setString("-hscr");
    scrname.addString(addstr);
#ifdef WS_EMBED
    WSCbase* htmp = new WSCvscrBar(this,scrname.getString());
#else
    WSCbase* htmp = WSCbase::getNewInstance(getUseScrBarClass(),this,scrname.getString());
#endif
    if (htmp == NULL){
WSMFtrace("Error: WSCvscrForm cannot create ScrBarClass:%s.\n",getUseScrBarClass());
    }
    _h_scr = (WSCvscrBar*)htmp->cast("WSCvscrBar");
    if (_h_scr == NULL){
WSMFtrace("Error: WSCvscrForm cannot create ScrBarClass:%s.\n",getUseScrBarClass());
      _h_scr = new WSCvscrBar(this,scrname.getString());
    }
    _h_scr->setInternalObject(True);
    _h_scr->setUseParentBaseDev(True);
    _h_scr->initialize();
    WSCprocedure* op1 = new WSCprocedure("value-ch",WSEV_VALUE_CH);
    op1->setInternal(True);
    op1->setFunction(_h_scr_work_op,"_h_scr_work_op");
    _h_scr->addProcedure(op1);
    WSCprocedure* op3 = new WSCprocedure("activate",WSEV_ACTIVATE);
    op3->setInternal(True);
    op3->setFunction(_ha_scr_work_op,"_ha_scr_work_op");
    _h_scr->addProcedure(op3);
    _h_scr->setPropertyV(WSNshadowThickness,(WSCuchar)_shadow_thick);
    _h_scr->setPropertyV(WSNbackColor,_back_color);
    _h_scr->setPropertyV(WSNforeColor,_fore_color);
    _h_scr->setPropertyV(WSNtopShadowColor,_ts_color);
    _h_scr->setPropertyV(WSNbottomShadowColor,_bs_color);
    _h_scr->setPropertyV(WSNbarShadowColor,_bar_back_color);
    _h_scr->setPropertyV(WSNpageIncrement,_page_increment);

    scrname.setString(getInstanceName());
    addstr.setString("-vscr");
    scrname.addString(addstr);
#ifdef WS_EMBED
    WSCbase* vtmp = new WSCvscrBar(this,scrname.getString());
#else
    WSCbase* vtmp = WSCbase::getNewInstance(getUseScrBarClass(),this,scrname.getString());
#endif
    if (vtmp == NULL){
WSMFtrace("Error: WSCvscrForm cannot create ScrBarClass:%s.\n",getUseScrBarClass());
    }
    _v_scr = (WSCvscrBar*)vtmp->cast("WSCvscrBar");
    if (_v_scr == NULL){
WSMFtrace("Error: WSCvscrForm cannot create ScrBarClass:%s.\n",getUseScrBarClass());
      _v_scr = new WSCvscrBar(this,scrname.getString());
    }
    _v_scr->setInternalObject(True);
    _v_scr->setUseParentBaseDev(True);
    _v_scr->initialize();
    _v_scr->setPropertyV(WSNorientation,(WSCuchar)WS_VERTICAL);
    WSCprocedure* op2 = new WSCprocedure("value-ch",WSEV_VALUE_CH);
    op2->setInternal(True);
    op2->setFunction(_v_scr_work_op,"_v_scr_work_op");
    _v_scr->addProcedure(op2);
    WSCprocedure* op4 = new WSCprocedure("activate",WSEV_ACTIVATE);
    op4->setInternal(True);
    op4->setFunction(_va_scr_work_op,"_va_scr_work_op");
    _v_scr->addProcedure(op4);
    _v_scr->setPropertyV(WSNshadowThickness,(WSCuchar)_shadow_thick);
    _v_scr->setPropertyV(WSNbackColor,_back_color);
    _v_scr->setPropertyV(WSNforeColor,_fore_color);
    _v_scr->setPropertyV(WSNtopShadowColor,_ts_color);
    _v_scr->setPropertyV(WSNbottomShadowColor,_bs_color);
    _v_scr->setPropertyV(WSNbarShadowColor,_bar_back_color);
    _v_scr->setPropertyV(WSNpageIncrement,_page_increment);

    setWorkWSNworkWidth(_work_width);
    setWorkWSNworkHeight(_work_height);
    WSClistData children = getChildren();
    _scr_area->setPropertyV(WSNvbarValue,(WSCushort)0);
    _scr_area->setPropertyV(WSNhbarValue,(WSCushort)0);
    long i;
    long num = children.getNum();
    for(i=0; i<num; i++){
      WSCbase* child = (WSCbase*)children[i];
      if (child->getUseParentBaseDev() != False){
        continue;
      }
#ifndef NO_SCALE_OFFSET
      child->setXOffsetPtr(&_scr_offset_x);
      child->setYOffsetPtr(&_scr_offset_y);
#endif
    }

#if 0
    if (_virtual_scr != 0){
      setWorkWSNvirtualScroll(1);
    }
#endif
    _adjust();
  }
  return WS_NO_ERR;
}

long WSCvscrForm::_device_initialize(){
  WSDdev* dev = getowndev();
  if (dev == NULL){
    return WS_ERR;
  }
  _adjust();

  dev->setEnableEventBit( WSEV_MOUSE_MOVE_BIT | WSEV_MOUSE_OUT_BIT |
                              WSEV_MOUSE_IN_BIT |
                              WSEV_MOUSE_PRESS_BIT  | WSEV_MOUSE_RELEASE_BIT );
  WSCvform::_device_initialize();
#ifndef NO_PIX
  char fl = False;
  _dev->setValue(WSDEV_PIXMAP_STYLE,(void*)&fl);
#endif //NO_PIX
  return WS_NO_ERR;
}

long WSCvscrForm::execEventProc(long ev,void* data){
  if (ev == WSEV_MOUSE_MOVE){
    WSCpoint* point = (WSCpoint*)data;
    _btn_x = point->x;
    _btn_y = point->y;
  }else if (ev == WSEV_MOUSE_PRESS){
    WSCpoint* point = (WSCpoint*)data;
    _btn_x = point->x;
    _btn_y = point->y;
    _btn_x_pressed = point->x;
    _btn_y_pressed = point->y;
    onGetMouseFocus();
  }else if (ev == WSEV_MOUSE_RELEASE){
    WSCpoint* point = (WSCpoint*)data;
    _btn_x = point->x;
    _btn_y = point->y;
  }
  return WSCvform::execEventProc(ev,data);
}


short WSCvscrForm::_btn_x = 0;
short WSCvscrForm::_btn_y = 0;
short WSCvscrForm::_btn_x_pressed = 0;
short WSCvscrForm::_btn_y_pressed = 0;
WSCushort WSCvscrForm::_value_pressed = 0;

void WSCvscrForm::_redraw_scr(){
  if (_scr_area != NULL){
    _scr_area->redraw();
  }
}

long WSCvscrForm::redraw(){
  return WSCvform::redraw();
}

long WSCvscrForm::clear(){
  WSCvform::clear();
  return WS_NO_ERR;
}

void WSCvscrForm::_adjust(){
  long _margin = _marginw;
#ifndef NO_GUI_POLICY
  if (WSGIappDev()->getGuiPolicy() & WS_POLICY_WINDOWS){
    _margin = 0;
  }
#else
  _margin = 0;
#endif
  WSCushort sh = _h - _bar_thick -_shadow_thick*2 - _padding;
  if (_get_hbar_visible() == False){
    sh = _h  - _shadow_thick*2 - _padding;
  }

  if (_v_scr_max_sz != _work_height ||
      _v_scr_slider_sz != sh){
    _v_scr->setPropertyV(WSNmaximum,(WSCulong)_work_height);
    _v_scr_max_sz = _work_height;
    _v_scr->setPropertyV(WSNsliderSize,(WSCulong)sh);
    _v_scr_slider_sz = sh;
  }

  WSCushort sw = _w - _bar_thick - _shadow_thick*2;
  if (_get_vbar_visible() == False){
    sw = _w  - _shadow_thick*2;
  }

  if (_h_scr_max_sz != _work_width ||
      _h_scr_slider_sz != sw){
    _h_scr->setPropertyV(WSNmaximum,(WSCulong)_work_width);
    _h_scr_max_sz = _work_width;
    _h_scr->setPropertyV(WSNsliderSize,(WSCulong)sw);
    _h_scr_slider_sz = sw;
  }

  WSCushort w = _w;
  WSCushort h = _h;

  if (_scr_area == NULL){
    return;
  }
  WSCushort st = 0;
#ifndef NO_GUI_POLICY
  if (WSGIappDev()->getGuiPolicy() & WS_POLICY_WINDOWS){
    st = _shadow_thick;
  }
#else
  st = _shadow_thick;
#endif
  short bw = 0,bh = 0;
  if (_get_hbar_visible() != False){
    bw = w - _bar_thick -_margin;
    if (_get_vbar_visible() == False){
      bw = w;
    }
    if (bw < 1){
      bw =1;
    }
    bh = _bar_thick;
    if (bh < 1){
      bh =1;
    }

    if (h - _bar_thick -st != _h_scr_y_bk){
      _h_scr->setPropertyV(WSNx,(short)st);
      _h_scr->setPropertyV(WSNy,(short)(h - _bar_thick-st));
      _h_scr_y_bk = h - _bar_thick -st;
    }

    if (bw -st*2 != _h_scr_w_bk){
      _h_scr->setPropertyV(WSNwidth,(WSCushort)(bw -st*2));
      _h_scr_w_bk = bw -st*2;
    }

    if (bh != _h_scr_h_bk){
      _h_scr->setPropertyV(WSNheight,(WSCushort)bh);
      _h_scr_h_bk = bh;
    }
    if (_h_scr->getVisible() == False){
      _h_scr->setVisible(True);
    }
  }else{ 
    if (_h_scr->getVisible() != False){
      _h_scr->setVisible(False);
    }
  }

  if (_get_vbar_visible() != False){
#ifndef NO_GUI_POLICY
    if (WSGIappDev()->getGuiPolicy() & WS_POLICY_ORIGINAL){
      bh = h - _bar_thick -_margin - _padding;
      if (_get_hbar_visible() == False){
        bh = h - _padding;
      }
    }else
    if (WSGIappDev()->getGuiPolicy() & WS_POLICY_WINDOWS){
      bh = h - _bar_thick -_margin;
      if (_get_hbar_visible() == False){
        bh = h;
      }
    }
#else
    bh = h - _bar_thick -_margin;
    if (_get_hbar_visible() == False){
      bh = h;
    }
#endif
    if (bh < 1){
      bh =1;
    }
    bw = _bar_thick;
    if (bw < 1){
      bw =1;
    }

    if (w - _bar_thick-st != _v_scr_x_bk){
      _v_scr->setPropertyV(WSNx,(short)(w - _bar_thick -st));
#ifndef NO_GUI_POLICY
      if (WSGIappDev()->getGuiPolicy() & WS_POLICY_ORIGINAL){
        _v_scr->setPropertyV(WSNy,(short)(_padding +st));
      }else
      if (WSGIappDev()->getGuiPolicy() & WS_POLICY_WINDOWS){
        _v_scr->setPropertyV(WSNy,(short)st);
      }
#else
      _v_scr->setPropertyV(WSNy,(short)st);
#endif
      _v_scr_x_bk = w - _bar_thick -st;
    }

    if (bw != _v_scr_w_bk){
      _v_scr->setPropertyV(WSNwidth,(WSCushort)bw);
      _v_scr_w_bk = bw;
    }

    if (bh -st*2!= _v_scr_h_bk){
      _v_scr->setPropertyV(WSNheight,(WSCushort)(bh -st*2));
      _v_scr_h_bk = bh-st*2;
    }
    if (_v_scr->getVisible() == False){
      _v_scr->setVisible(True);
    }
  }else{
    if (_v_scr->getVisible() != False){
      _v_scr->setVisible(False);
    }
  }

}

void WSCvscrForm::update(){
  _adjust();
  _adjust_scr_area();
  WSCvform::update();
  return;
}
void WSCvscrForm::_adjust_scr_area(){
  long _margin = _marginw;
  long st = 0;
#ifndef NO_GUI_POLICY
  if (WSGIappDev()->getGuiPolicy() & WS_POLICY_WINDOWS){
    _margin = 0;
    st = _shadow_thick;
  }
#else
  _margin = 0;
  st = _shadow_thick;
#endif
  unsigned v_bar_thick = _bar_thick + _margin+st; 
  unsigned h_bar_thick = _bar_thick + _margin+st; 
  long st2 = _shadow_thick;
  if (_get_hbar_visible() == False &&
      _get_vbar_visible() == False && _frame == False){
    st2 = 0;
    _scr_area->setProperty(WSNx,0);
    _scr_area->setProperty(WSNy,_padding);
  }else{
    _scr_area->setProperty(WSNx,st2);
    _scr_area->setProperty(WSNy,st2 + _padding);
  }
  if (_get_vbar_visible() != False){
    if (_scr_area_w != _w - st2*2 - _bar_thick -_margin){
      _scr_area_w = _w - st2*2 - _bar_thick -_margin;
      _scr_area->setPropertyV(WSNwidth,_scr_area_w);
      _scr_area->setAbsoluteDraw(False); //resize clear bug fix
    }
  }else{
    if (_scr_area_w != _w - st2*2){
      _scr_area_w = _w - st2*2 ;
      _scr_area->setPropertyV(WSNwidth,_scr_area_w);
      _scr_area->setPropertyV(WSNworkWidth,_scr_area_w);
      _scr_area->setAbsoluteDraw(False); //resize clear bug fix
    }
    v_bar_thick = 0;
  }
  if (_get_hbar_visible() != False){
    if (_scr_area_h != _h - st2*2 - _bar_thick -_margin - _padding){
      _scr_area_h = _h - st2*2 - _bar_thick -_margin - _padding;
      _scr_area->setPropertyV(WSNheight,_scr_area_h);
      _scr_area->setPropertyV(WSNworkHeight,_scr_area_h);
      _scr_area->setAbsoluteDraw(False); //resize clear bug fix
    }
  }else{
    if (_scr_area_h != _h - st2*2 - _padding){
      _scr_area_h = _h - st2*2 - _padding;
      _scr_area->setPropertyV(WSNheight,_scr_area_h);
      _scr_area->setPropertyV(WSNworkHeight,_scr_area_h);
      _scr_area->setAbsoluteDraw(False); //resize clear bug fix
    }
    h_bar_thick = 0;
  }
  
}
long WSCvscrForm::cdraw(){
  _scr_area->cdraw();
  return WSCvform::cdraw();
}

long WSCvscrForm::draw(){
return WSCvform::draw();
}

WSCushort WSCvscrForm::_get_shift_width(){
  long _margin = _marginw;
#ifndef NO_GUI_POLICY
  if (WSGIappDev()->getGuiPolicy() & WS_POLICY_WINDOWS){
    _margin = 0;
  }
#else
  _margin = 0;
#endif
  return _work_width + _shadow_thick*2 + _bar_thick -_margin - _w;
}

WSCushort WSCvscrForm::_get_shift_height(){
  long _margin = _marginw;
#ifndef NO_GUI_POLICY
  if (WSGIappDev()->getGuiPolicy() & WS_POLICY_WINDOWS){
    _margin = 0;
  }
#else
  _margin = 0;
#endif
  return _work_height + _shadow_thick*2 + _bar_thick -_margin - _h;
}

void WSCvscrForm::onGetMouseFocus(){
  WSGIappMouse()->addMouseFocusClient(this);
}

void WSCvscrForm::onParentVisibleChange(WSCbool fl){
  WSCvform::onParentVisibleChange(fl);
  setPropertyV(WSNhbarValue,_wx_pos);
  setPropertyV(WSNvbarValue,_wy_pos);
  WSCvform::onSensitiveChange(fl);
  if (fl == True && _v_scr != NULL){
    if (getVisible() == True){
      WSGIappMouse()->addMouseFocusClient(this);
    }
    _adjust();
    _adjust_scr_area();
  }
  if (fl == False){
    WSGIappMouse()->deleteMouseFocusClient(this);
  }
}


WSCbool WSCvscrForm::_get_hbar_visible(){
  if (_hbar_visible == False){
    return False;
  }

  if (_work_width > _w - _shadow_thick*2){
    return True;
  }

  WSCbool vvis = False;
  long _margin = _marginw;
#ifndef NO_GUI_POLICY
  if (WSGIappDev()->getGuiPolicy() & WS_POLICY_WINDOWS){
    _margin = 0;
  }
#else
  _margin = 0;
#endif

  if (_vbar_visible == True && _work_height > _h - _shadow_thick*2 - _padding){
    vvis = True;
  }

  if (vvis == True){
    if (_work_width > _w - _shadow_thick*2 - _bar_thick -_margin){
      return True;
    }
  }
  return False;
}

WSCbool WSCvscrForm::_get_vbar_visible(){
  if (_vbar_visible == False){
    return False;
  }

  if (_work_height > _h - _shadow_thick*2 - _padding){
    return True;
  }

  WSCbool hvis = False;

  long _margin = _marginw;
#ifndef NO_GUI_POLICY
  if (WSGIappDev()->getGuiPolicy() & WS_POLICY_WINDOWS){
    _margin = 0;
  }
#else
  _margin = 0;
#endif
  if (_hbar_visible == True && _work_width > _w - _shadow_thick*2){
    hvis = True;
  }
  if (hvis == True){
    if (_work_height > _h - _shadow_thick*2 - _bar_thick -_margin){
      return True;
    }
  }

  return False;
}
#ifndef WS_EMBED
long WSCvscrForm::setPropertyEditMode(WSCbool fl){
  long ret = WSCbase::setPropertyEditMode(fl);
  if (_scr_area != NULL){
//    _scr_area->setDotMode(fl);
    _scr_area->setPropertyEditMode(fl);
  }
  return ret;
}
#endif
long WSCvscrForm::getVisibleWidth(){
      return _scr_area_w;
}

long WSCvscrForm::getVisibleHeight(){
      return _scr_area_h;
}

void WSCvscrForm::_ha_scr_work_op(WSCbase* obj){
  WSCbase* parent = obj->getParent();
  WSCvscrForm* scr = (WSCvscrForm*)parent->cast("WSCvscrForm");
//  scr->execEventProc(WSEV_ACTIVATE,NULL);
  scr->onActivate();
} 
void WSCvscrForm::onActivate(){
  execProcedure(WSEV_ACTIVATE);
}
void WSCvscrForm::_adjust_children(){
  WSClistData children = getChildren();
  long i;
  long num = children.getNum();
  for(i=0; i<num; i++){
    WSCbase* child = (WSCbase*)children[i];
    if (!(child->getObjectType() & WS_TYPE_NON_WINDOW)){
      if (child != _scr_area){
        child->setAbsoluteDraw(True);
        child->needUpdate();
      }
    }
  }
}
void WSCvscrForm::_h_scr_work_op(WSCbase* obj){
  WSCbase* parent = obj->getParent();
  WSCvscrForm* scr = (WSCvscrForm*)parent->cast("WSCvscrForm");
  WSCvscrBar* bar = (WSCvscrBar*)obj->cast("WSCvscrBar");
  WSCulong val =0;
  WSCushort sld_width =0;
  WSCushort current =0;
//  sld_width = scr->getProperty(WSNscrollWidth);
  sld_width = scr->_scroll_width;
  if (sld_width == 0){
    sld_width = 1;
  }
  scr->_scr_area->getPropertyV(WSNhbarValue,&current);

  obj->getPropertyV(WSNvalue,&val);
 
  if (val == 0 || (long)((long)current - (long)val) >= (long)sld_width ||
                  (long)((long)val - (long)current) >= sld_width ||
                  bar->getMaxSlideValue() <= val){
    if ( bar->getMaxSlideValue() <= val){
      val = bar->getMaxSlideValue();
    }else{
      if ((long)current > (long)val){
        val -= ((long)current - (long)val) % sld_width;
      }else{
        val -= ((long)val - (long)current) % sld_width;
      }
      if ((long)val < 0){
        val = 0;
      }
    }

    bar->_set_internal_value(val);
    if ( scr->_wx_pos != val){
      scr->_wx_pos = val;
      scr->_scr_offset_x = -val;
      if (scr->_no_scroll == False){
        scr->_adjust_children();
        scr->_redraw_scr();
      }else{
        scr->_adjust_no_scroll();
      }
//      scr->execEventProc(WSEV_VALUE_CH,NULL);
      scr->onValueChange();
    }
  }
}
void WSCvscrForm::onValueChange(){
  execProcedure(WSEV_VALUE_CH);
}
void WSCvscrForm::_va_scr_work_op(WSCbase* obj){
  WSCbase* parent = obj->getParent();
  WSCvscrForm* scr = (WSCvscrForm*)parent->cast("WSCvscrForm");
//  scr->execEventProc(WSEV_ACTIVATE,NULL);
  scr->onActivate();
}

void WSCvscrForm::_v_scr_work_op(WSCbase* obj){
  WSCbase* parent = obj->getParent();
  WSCvscrForm* scr = (WSCvscrForm*)parent->cast("WSCvscrForm");
  WSCvscrBar* bar = (WSCvscrBar*)obj->cast("WSCvscrBar");
  WSCulong val =0;
  WSCushort sld_width =0;
  WSCushort current = 0;
//  sld_width = scr->getProperty(WSNscrollHeight);
  sld_width = scr->_scroll_height;
  if (sld_width ==0){
    sld_width = 1;
  }
  obj->getPropertyV(WSNvalue,&val);
  if (val == 0 || (long)((long)current - (long)val) >= (long)sld_width ||
                  (long)((long)val - (long)current) >= sld_width ||
                  bar->getMaxSlideValue() <= val){
    if ( bar->getMaxSlideValue() <= val){
      val = bar->getMaxSlideValue();
    }else{
      if ((long)current > (long)val){
        val -= ((long)current - (long)val) % sld_width;
      }else{
        val -= ((long)val - (long)current) % sld_width;
      }
      if ((long)val < 0){
        val = 0;
      }
    }
    bar->_set_internal_value(val);
    if ( scr->_wy_pos != val){
      scr->_wy_pos = val;
      scr->_scr_offset_y = -val;
      if (scr->_no_scroll == False){
        scr->_adjust_children();
        scr->_redraw_scr();
      }else{
        scr->_adjust_no_scroll();
      }
//      scr->execEventProc(WSEV_VALUE_CH,NULL);
      scr->onValueChange();
    }
  }
}

WSCbase* WSCvscrForm::getScrFrame(){
  return _scr_area;
}
void WSCvscrForm::onChildAdded(WSCbase* child){
#ifndef NO_SCALE_OFFSET
  if (child->getUseParentBaseDev() == False){
    child->setXOffsetPtr(&_scr_offset_x);
    child->setYOffsetPtr(&_scr_offset_y);
    child->update();
  }
#endif
}
static char* _scr_bar_cname = NULL;
void WSCvscrForm::setUseScrBarClass(char* cname){
  if (_scr_bar_cname != NULL){
    delete[] _scr_bar_cname;
    _scr_bar_cname = NULL;
  }
  if (cname != NULL){
    _scr_bar_cname = WSGFstrdup(cname);
  }
}
char* WSCvscrForm::getUseScrBarClass(){
  if (_scr_bar_cname == NULL){
    return "WSCvbscrBar";
  }
  return _scr_bar_cname;
}

void(*WSCvscrForm::_ext_draw_proc)(void*) = NULL;
char* WSCvscrForm::_policy_name = NULL;

#ifndef NO_GUI_POLICY
void WSCvscrForm::onGuiPolicyChange(long policy){
  WSCbase::onGuiPolicyChange(policy);
  if (WSGIappDev()->getExtGuiPolicySelected() == False){
    _ext_draw_proc = NULL;
  }else{
    if (_policy_name != NULL &&
        !strcmp(_policy_name,(char*)WSGIappDev()->getExtGuiPolicyName())){
    }else{
      _ext_draw_proc = (void(*)(void*))WSGIappDev()->getExtGuiPolicyProc("WSCvscrForm::draw");
      if (_policy_name != NULL){
        delete[] _policy_name;
      }
      _policy_name = WSGFstrdup(WSGIappDev()->getExtGuiPolicyName());
    }
  }
  setAbsoluteDraw(True);
  draw();
}
#endif
void WSCvscrForm::onMousePress(WSCpoint* pt){
  if (WSGIappMouse()->getTargetBtn() == WS_MOUSE_BTN4){
    if (getVisible() == False){
      return;
    }
    if (getSensitive() == False){
      return;
    }
    long val = _wy_pos - _page_increment;
    if (val < 0){
//      setProperty(WSNvbarValue,0);
      _v_scr->setProperty(WSNvalue,0);
    }else{
//      setProperty(WSNvbarValue,val);
      _v_scr->setProperty(WSNvalue,val);
    }
    return;
  }else
  if (WSGIappMouse()->getTargetBtn() == WS_MOUSE_BTN5){
    if (getVisible() == False){
      return;
    }
    if (getSensitive() == False){
      return;
    }
    long val = _wy_pos + _page_increment;
    long slidersize = _v_scr->getProperty(WSNsliderSize);
    long max = _v_scr->getProperty(WSNmaximum);
    if (val > max - slidersize){
      val = max - slidersize;
    }
//    setProperty(WSNvbarValue,val);
    _v_scr->setProperty(WSNvalue,val);
    return;
  }

  WSGIappMouse()->addMouseFocusClient(this);
  WSCbase::onMousePress(pt);
}
void WSCvscrForm::_scr_mouse_press(WSCbase* obj){
  WSCbase* parent = obj->getParent();
  WSCvscrForm* scr = (WSCvscrForm*)parent->cast("WSCvscrForm");
  if (scr == NULL){
    return;
  }
  if (scr->getSensitive() == False){
    return;
  }
  short x=0,y=0;
  obj->getMouseAddr(&x,&y);
  WSCpoint pt;
  pt.x = x;
  pt.y = y;
  scr->onScrMousePress(&pt);
}
void WSCvscrForm::_scr_mouse_dclick(WSCbase* obj){
  WSCbase* parent = obj->getParent();
  WSCvscrForm* scr = (WSCvscrForm*)parent->cast("WSCvscrForm");
  if (scr == NULL){
    return;
  }
  if (scr->getSensitive() == False){
    return;
  }
  short x=0,y=0;
  obj->getMouseAddr(&x,&y);
  WSCpoint pt;
  pt.x = x;
  pt.y = y;
//printf("WSCvscrForm::_scr_mouse_double_click %d,%d\n",x,y);
  scr->onScrMouseDoubleClick(&pt);
}



void WSCvscrForm::_scr_mouse_release(WSCbase* obj){
  WSCbase* parent = obj->getParent();
  WSCvscrForm* scr = (WSCvscrForm*)parent->cast("WSCvscrForm");
  if (scr == NULL){
    return;
  }
  if (scr->getSensitive() == False){
    return;
  }
  short x=0,y=0;
  obj->getMouseAddr(&x,&y);
  WSCpoint pt;
  pt.x = x;
  pt.y = y;
  scr->onScrMouseRelease(&pt);
}
void WSCvscrForm::_scr_mouse_move(WSCbase* obj){
  WSCbase* parent = obj->getParent();
  WSCvscrForm* scr = (WSCvscrForm*)parent->cast("WSCvscrForm");
  if (scr == NULL){
    return;
  }
  if (scr->getSensitive() == False){
    return;
  }
  short x=0,y=0;
  obj->getMouseAddr(&x,&y);
  WSCpoint pt;
  pt.x = x;
  pt.y = y;
  scr->onScrMouseMove(&pt);
}

void WSCvscrForm::onScrMousePress(WSCpoint* pt){
//  WSGIappMouse()->addMouseFocusClient(this);
  execProcedure(WSEV_SCR_MOUSE_PRESS);
}
void WSCvscrForm::onScrMouseRelease(WSCpoint* pt){
  execProcedure(WSEV_SCR_MOUSE_RELEASE);
}
void WSCvscrForm::onScrMouseMove(WSCpoint* pt){
  execProcedure(WSEV_SCR_MOUSE_MOVE);
}
void WSCvscrForm::onScrMouseDoubleClick(WSCpoint* pt){
//printf("WSCvscrForm::onScrMouseDoubleClick %s\n",getInstanceName());
  execProcedure(WSEV_SCR_MOUSE_DOUBLE_CLICK);
}
void WSCvscrForm::_set_no_scroll(WSCbool fl){
  _no_scroll = fl;
}
void WSCvscrForm::_adjust_no_scroll(){
}
#ifndef NO_ANCHOR
void WSCvscrForm::_exec_child_adjust_for_anchors(){
  if (adjustAnchor() != False){
    if (_geometry_changed != False || _update_work_area != False){
      _update_work_area = False;
      WSClistData children = getChildren();
      long num = children.getNum();
      long i;
      WSCbase** buf = (WSCbase**)children._data;
      for(i=0; i<num; i++){
        WSCbase* child = buf[i];
//        if (child == _scr_area || child == _v_scr || child == _h_scr){
//          continue;
//        }
        child->_adjust_for_anchors(_work_width,_work_height);
      }
    }
  }
}
#endif
long WSCvscrForm::getObjectType(){
  return (WS_TYPE_MANAGER | WS_TYPE_FORM | WS_TYPE_SCR_FORM | WS_TYPE_NON_WINDOW);
}
WSCbase* WSCvscrForm::getVScrBar(){
  return _v_scr;
}   
WSCbase* WSCvscrForm::getHScrBar(){
  return _h_scr;
}
void WSCvscrForm::onVisibleChange(WSCbool fl){
  WSCvform::onVisibleChange(fl);
  WSCvform::onSensitiveChange(fl);
  if (fl != False && _v_scr != NULL){
    if (getVisible() == True){
      WSGIappMouse()->addMouseFocusClient(this);
    }
    _adjust();
    _adjust_scr_area();
  }
  if (fl == False){
    WSGIappMouse()->deleteMouseFocusClient(this);
  }
}
#ifdef WS_EMBED
#ifndef NO_EXT_GUI_POLICY
class _gui_policy_register_{
  public: _gui_policy_register_(){
extern void WSCvscrForm_draw_mdr1(void*);
    WSGIappGuiPolicy()->setExtGuiPolicyProc("Modern1","WSCvscrForm::draw",WSCvscrForm_draw_mdr1);
  }
};
static _gui_policy_register_ _run_register;
#endif
#endif

