//
// Copyright (C) 1999-2009 WideStudio/MWT Project Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
//

#include <WScom.h>
#include <WSDappDev.h>
#include <WSCblink.h>
#include <WSCimageSet.h>
#include <WSCcolorSet.h>
#include <WSCfontSet.h>
#include <WSDmouse.h>
#include <WSCvform.h>
#include <WSCvscrForm.h>
#include <WSCguiPolicy.h>

#ifdef WS_EMBED
#ifndef NO_EXT_GUI_POLICY
void _libwsc_extgui_policy(){};
#endif
#endif

extern short WSGFgetParentBackColor(WSCbase* client);
void WSCvform_draw_mdr1(void* ptr){
  WSCvform_draw_struct* st = (WSCvform_draw_struct*)ptr;

  WSCbool absolute = st->_this->getAbsoluteDraw();
  WSDdev* dev = st->dev;

  long err = dev->beginDraw(st->x,st->y,st->width,st->height,absolute);
  if (err != WS_NO_ERR){
    return;
  }
  short ex = 0;
  short ey = 0;
  WSCushort ew = st->width;
  WSCushort eh = st->height;
  if (absolute == False){
    dev->getExposedArea(&ex,&ey,&ew,&eh);
  }
  st->_this->WSCbase::update();
  st->_this->setAbsoluteDraw(False);

  if (st->back_pixmap == -1){
#ifndef NO_GRADATION
    if (st->gradation == 0){
#endif
      dev->setForeColor(st->back_color);
      dev->drawFillRect(0,0,st->width,st->height);
      dev->setForeColor(st->back_color);

#ifndef NO_GRADATION
    }else{
      dev->drawGradation(st->gradation,st->top_shadow_color,st->back_color,st->bottom_shadow_color,0,0,st->width,st->height,st->gradation_margin);
    }
#endif
  }
  if (st->_this->getDotMode() == True){
    dev->setForeColor(st->fore_color);
    long i,j;
    for(i=0; i<st->width; i+=10){
      for(j=0; j<st->height; j+=10){
        if (ex < i+1 && i < ex+ ew+1 &&
            ey < j+1 && j < ey+ eh+1 ){
          dev->drawFillRect(i,j,1,1);
        }
      }
    }
  }
//draw shadow
  if (st->shadow_thickness > 0){
#if 0
    dev->setLineWidth(1);
    dev->setLineDashType(0);
    dev->setForeColor(st->bottom_shadow_color);
    dev->drawRect(0,0,st->width,st->height);
#endif
    short tsno = st->top_shadow_color;
    short bsno = st->bottom_shadow_color;
    short bgc = st->back_color;
    short pbg = WSGFgetParentBackColor(st->_this);
    WSGFdrawModern1Shadow(dev, st->shadow_type, st->shadow_thickness,
        tsno, tsno, bsno, bgc, pbg, 0, 0, st->width, st->height,False);

  }

  dev->endDraw();

  return;
}

void WSCvscrForm_draw_mdr1(void* ptr){
  WSCvscrForm_draw_struct* dt = (WSCvscrForm_draw_struct*)ptr;

  WSCvscrForm* _this = dt->_this;
  WSDdev* dev = dt->dev;
  WSCbool absolute = _this->getAbsoluteDraw();

  long err = dev->beginDraw(dt->x,dt->y,dt->width,dt->height,absolute);
  if (err != WS_NO_ERR){
    return;
  }
//  short _x          = dt->x;
//  short _y          = dt->y;
  WSCushort _w      = dt->width;
  WSCushort _h      = dt->height;
  WSCushort _shadow_thick = dt->shadow_thickness;
  WSCuchar _shadow_type   = dt->shadow_type;
  short _fore_color = dt->fore_color;
  short _back_color = dt->back_color;
  short _work_back_color = dt->work_back_color;
  short _ts_color   = dt->top_shadow_color;
  short _bs_color   = dt->bottom_shadow_color;
  short _bp_color   = dt->back_pixmap;
#ifndef NO_GRADATION
//  long  _grad_no    = dt->gradation;
//  long  _grad_margin = dt->gradation_margin;
#endif
  long  _bar_thick  = dt->bar_thickness;
  long  _marginw    = dt->margin_width;
//  long  _padding    = dt->padding;
//  WSCbool  _frame   = dt->frame;
  unsigned v_bar_thick = _bar_thick + _marginw;
  unsigned h_bar_thick = _bar_thick + _marginw;
  if (dt->vbar_visible == False){
    v_bar_thick = 0;
  }
  if (dt->hbar_visible == False){
    h_bar_thick = 0;
  }

  if ( _shadow_thick > 0){
    WSGFdrawModern1Shadow(dev,_shadow_type, _shadow_thick, _fore_color,
                   _ts_color,_bs_color,_back_color,_back_color,
                   0,0,dt->width,dt->height,False);
  }
  dev->endDraw();

  long err2 = dev->beginDraw(dt->x,dt->y,dt->width,dt->height,absolute);
  if (err2 != WS_NO_ERR){
    return;
  }

  _this->WSCbase::update();
  _this->setAbsoluteDraw(False);
  if (_bp_color == -1){
    dev->setForeColor(_back_color);
    dev->drawFillRect(_w - _shadow_thick - v_bar_thick,
                        _h - _shadow_thick - h_bar_thick,
                        v_bar_thick,
                        h_bar_thick);
  }

  dev->setForeColor(_work_back_color);
  dev->drawFillRect(_shadow_thick,_shadow_thick,
         dt->width - v_bar_thick - _shadow_thick*2,
         dt->height - h_bar_thick - _shadow_thick*2);
  dev->endDraw();
  return;
}

#ifndef NO_GUI_POLICY
class _gui_policy_register1_{
  public: _gui_policy_register1_(){
    WSGIappGuiPolicy()->setExtGuiPolicyProc("Modern1","WSCvform::draw",WSCvform_draw_mdr1);
    WSGIappGuiPolicy()->setExtGuiPolicyProc("Modern1","WSCvscrForm::draw",WSCvscrForm_draw_mdr1);
  }
};

static _gui_policy_register1_ _run_register;
#endif
