//
// Copyright (C) 1999-2008 WideStudio/MWT Project Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#include <WScom.h>
#include <devfb/devfb.h>
#include <devfb/devfb_dep.h>

extern int _add_event(WSDdeviceEventList* evt);
extern int _device_check_event_available();
extern int _search_window(short x,short y);

extern int _touch_pannel_x;
extern int _touch_pannel_y;
extern int _mouse_status;

//#define NO_DRAW_FB_MOUSE_CURSOR
void _draw_mouse_cursor(){
#ifdef NO_DRAW_FB_MOUSE_CURSOR
return;
#else
static  int _cursor_x = -1;
static  int _cursor_y = -1;
static  unsigned int val_back = 0;
static  unsigned int val_back2 = 0;

static  unsigned short val_back_ex[200];
  int dx = _cursor_x;
  int dy = _cursor_y;
  int x = _touch_pannel_x;
  int y = _touch_pannel_y;
  _cursor_x = x;
  _cursor_y = y;
#ifdef ROTATE90
  {
     int tmp = dx;
     dx = dy;
     dy = _device_height - tmp -1;
     tmp = x;
     x = y;
     y = _device_height - tmp -1;
  }
#endif

#ifdef ROTATE270
  {
     int tmp = dx;
     dx = _device_width -dy -1;
     dy = tmp;
     tmp = x;
     x = _device_width -y -1;
     y = tmp;
  }
#endif


#ifdef DOUBLE_SCALE
   dx *=2;
   dy *=2;
   x *=2;
   y *=2;
#endif
  if (x < 0 || y < 0){
    return;
  }
  unsigned int depth =   _device_depth;
  unsigned int row_bytes = _device_row_bytes;
  if (depth == 32){
    if (dx > -1 && dy > -1){
      unsigned int* ptr = (unsigned int*)&_buffer[dy*row_bytes + dx*depth/8];
      *ptr++ = val_back;
      *ptr = val_back2;
    }
    unsigned int* ptr2 = (unsigned int*)&_buffer[y*row_bytes + x*depth/8];
    val_back = *ptr2;
    *ptr2 = 0xffffffff;
    ptr2++;
    val_back2 = *ptr2;
    *ptr2 = 0x00000000;
  }else
  if (depth == 16){
#if 0
    if (dx > -1 && dy > -1){
      unsigned short* ptr = (unsigned short*)&_buffer[dy*row_bytes + dx*depth/8];
      *ptr++ = val_back;
      *ptr = val_back2;
    }
    unsigned short* ptr2 = (unsigned short*)&_buffer[y*row_bytes + x*depth/8];
    val_back = *ptr2;
    *ptr2 = 0xffff;
    ptr2++;
    val_back2 = *ptr2;
    *ptr2 = 0x0000;
#endif
    if (dx > -1 && dy > -1){
      int i;
      for(i=0; i<=20; i++){
        if ((dy + i -10) > 0 && dx > 0 && dy + i -10 < _device_height && dx < _device_width){
          unsigned short* ptr = (unsigned short*)&_buffer[(dy + i -10)*row_bytes + dx*depth/8];
          if(*ptr == 0xfffe){
            *ptr = val_back_ex[i*4];
          }
        }
        if ((dy + i -10) > 0 && dx+1 > 0 && dy + i -10 < _device_height && dx +1< _device_width){
          unsigned short* ptr = (unsigned short*)&_buffer[(dy + i -10)*row_bytes + (dx+1)*depth/8];
          if(*ptr == 0x0001){
            *ptr = val_back_ex[i*4 +1];
          }
        }
        if (dy-1  > 0 && (dx +i -10) > 0 && dy-1 < _device_height && dx +i -10 < _device_width){
          unsigned short* ptr = (unsigned short*)&_buffer[(dy-1)*row_bytes + (dx + i -10)*depth/8];
          if( (i < 10) || (11 < i) ){
            if(*ptr == 0xfffe){
              *ptr = val_back_ex[i*4+2];
            }
          }
        }
        if (dy  > 0 && (dx +i -10) > 0 && dy < _device_height && dx +i -10 < _device_width){
          unsigned short* ptr = (unsigned short*)&_buffer[dy*row_bytes + (dx + i -10)*depth/8];
          if( (i < 10) || (11 < i) ){
            if(*ptr == 0x0001){
              *ptr = val_back_ex[i*4+3];
            }
          }
        }
      }
    }
    int i;
    for(i=0; i<=20; i++){
      if ((y + i -10) > 0 && x > 0 && y + i -10 < _device_height && x < _device_width){
        unsigned short* ptr2 = (unsigned short*)&_buffer[(y + i -10)*row_bytes + x*depth/8];
        val_back_ex[i*4] = *ptr2;
        *ptr2 = 0xfffe;
      }
      if ((y + i -10) > 0 && x+1 > 0 && y + i -10 < _device_height && x +1< _device_width){
        unsigned short* ptr2 = (unsigned short*)&_buffer[(y + i -10)*row_bytes + (x+1)*depth/8];
        val_back_ex[i*4+1] = *ptr2;
        *ptr2 = 0x0001;
      }
      if (y-1  > 0 && (x +i -10) > 0 && y-1 < _device_height && x +i -10 < _device_width){
        unsigned short* ptr2 = (unsigned short*)&_buffer[(y-1)*row_bytes + (x + i -10)*depth/8];
        if( (i < 10) || (11 < i) ){
          val_back_ex[i*4+2] = *ptr2;
          *ptr2 = 0xfffe;
        }
      }
      if (y  > 0 && (x +i -10) > 0 && y < _device_height && x +i -10 < _device_width){
        unsigned short* ptr2 = (unsigned short*)&_buffer[y*row_bytes + (x + i -10)*depth/8];
        if( (i < 10) || (11 < i) ){
          val_back_ex[i*4+3] = *ptr2;
          *ptr2 = 0x0001;
        }
      }
    }
    _update_frame_buffer(dx-10,dy-10,21,21);
    _update_frame_buffer(x-10,y-10,21,21);

  }else
  if (depth == 8){
    if (dx > -1 && dy > -1){
      unsigned char* ptr = (unsigned char*)&_buffer[dy*row_bytes + dx*depth/8];
      *ptr++ = val_back;
      *ptr = val_back2;
    }
    unsigned char* ptr2 = (unsigned char*)&_buffer[y*row_bytes + x*depth/8];
    val_back = *ptr2;
    *ptr2 = 0xff;
    ptr2++;
    val_back2 = *ptr2;
    *ptr2 = 0x00;
  }

#endif
}

int _get_event(WSDdeviceEvent* evt,unsigned int mode){
//printf("_get_event start..\n");
//printf("_get_event()\n");
  if (_evt_list == NULL){
    if ( _device_check_event_available() != False ){
      evt->s.type = EV_MSG;
//printf("_get_event done0..\n");
      return WS_NO_ERR;
    }
//printf("_get_event done1..\n");
    return WS_ERR;
  }

  WSDdeviceEventList* item = _evt_list;
  WSDdeviceEventList* item_bak = NULL;
  while(1){
    if (item == NULL){ 
      break;
    }
    if ((mode & 0xfff0 ) == DSPEVT){
      if (item->_event.r.type != EV_REQUEST){
        item_bak = item;
        item = item->_next;
        continue;
      }
      if (item->_event.r.cmd != W_REDISP){
        item_bak = item;
        item = item->_next;
        continue;
      }
    }
    if (item_bak == NULL){
      _evt_list = item->_next;
    }else{
      item_bak->_next = item->_next;
    }
    memcpy(evt,&(item->_event),sizeof(WSDdeviceEvent));
    free(item);
//printf("_get_event done2..\n");
    return WS_NO_ERR;
  }
//printf("_get_event done3..\n");
  if ((mode & 0xfff0 ) == DSPEVT){
    return WS_ERR;
  }
  //TODO: get mouse event..
  //TODO: get key event..
  if ( _device_check_event_available() != False ){
    evt->s.type = EV_MSG;
    return WS_NO_ERR;
  }
  return WS_NO_ERR;
}

void _add_mouse_move_evt(int px,int py){
  int wid = _search_window(px,py);
  if (wid == 0){
    _touch_pannel_x = px;
    _touch_pannel_y = py;
    _draw_mouse_cursor();
    return;
  }
  WSDdeviceEventList* evtl = (WSDdeviceEventList*)wsmalloc(sizeof(WSDdeviceEventList));
  WSDdeviceEvent* evt = &(evtl->_event);
  evt->s.type = EV_NULL;
  evt->s.cmd = W_WORK;
  evt->s.wid = wid;
  short wx = _window_list[wid -1]._x;
  short wy = _window_list[wid -1]._y;
  evt->s.wid = wid;
  evt->e.pos.x = px -wx;
  evt->e.pos.y = py -wy;
//  evt->s.stat = _mouse_status;
  evt->s.stat = ES_BUT;
  _touch_pannel_x = px;
  _touch_pannel_y = py;
  _draw_mouse_cursor();
//printf("add butmove.. %d,%d\n",px,py);
  _add_event(evtl);
}

void _add_mouse_evt(int px,int py,int pressed){
  int wid = _search_window(px,py);
  if (wid == 0){
    _touch_pannel_x = px;
    _touch_pannel_y = py;
    _draw_mouse_cursor();
    return;
  }
  WSDdeviceEventList* evtl = (WSDdeviceEventList*)wsmalloc(sizeof(WSDdeviceEventList));
  WSDdeviceEvent* evt = &(evtl->_event);
  if (pressed == 0){
    evt->s.type = EV_BUTUP;
    evt->s.stat = ES_BUT;
//printf("add butup.. %d,%d\n",px,py);
  }else{
    evt->s.type = EV_BUTDWN;
    evt->s.stat = ES_BUT;
//printf("add butdown.. %d,%d\n",px,py);
  }
  evt->s.cmd = W_WORK;
  evt->s.wid = wid;
  short wx = _window_list[wid -1]._x;
  short wy = _window_list[wid -1]._y;
  evt->s.wid = wid;
  evt->e.pos.x = px -wx;
  evt->e.pos.y = py -wy;
  _touch_pannel_x = px;
  _touch_pannel_y = py;
  _draw_mouse_cursor();
  _add_event(evtl);
}
#ifndef NO_VIRTUAL_EVENT_SEND
void _add_mouse_evt2(int px,int py,int btn,int pressed){
  int wid = _search_window(px,py);
  if (wid == 0){
    _touch_pannel_x = px;
    _touch_pannel_y = py;
    _draw_mouse_cursor();
    return;
  }
  WSDdeviceEventList* evtl = (WSDdeviceEventList*)wsmalloc(sizeof(WSDdeviceEventList));
  WSDdeviceEvent* evt = &(evtl->_event);
  if (pressed == 0){
    evt->s.type = EV_BUTUP;
    evt->s.stat = btn;
//printf("add butup.. %d,%d\n",px,py);
  }else{
    evt->s.type = EV_BUTDWN;
    evt->s.stat = btn;
//printf("add butdown.. %d,%d\n",px,py);
  }
  evt->s.cmd = W_WORK;
  evt->s.wid = wid;
  short wx = _window_list[wid -1]._x;
  short wy = _window_list[wid -1]._y;
  evt->s.wid = wid;
  evt->e.pos.x = px -wx;
  evt->e.pos.y = py -wy;
  _touch_pannel_x = px;
  _touch_pannel_y = py;
  _draw_mouse_cursor();
  _add_event(evtl);
}
#endif
