//
// Copyright (C) 1999-2008 WideStudio/MWT Project Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
//

#include <WScom.h>
#include <WSCflashForm.h>
#include <WSCclassInformation.h>
#include <WSClocaleSet.h>
#include <WSDdev.h>

//windows com depend headers
#include <wscntrctl.h>
#include <windows.h>
#include <oaidl.h>
#include <cstdio>
#include <cassert>
#include <stdarg.h>
#include <exdisp.h>
#include <olectl.h>
#include <oleidl.h>
#include <shlguid.h>
#include <cguid.h>
#include <initguid.h>

//FLASH CLASS ID
DEFINE_GUID(CLSID_ShockwaveFlash, 0xD27CDB6EL,0xAE6D,0x11CF,0x96,0xB8,0x44,0x45,0x53,0x54,0x00,0x00);

WSMFguiClassInitialize(WSCflashForm, WSCform);
WSMFversion(WSCflashForm, WSCform);

WSCflashForm::WSCflashForm(WSCbase* base, char* objname):
			WSCform(base, objname){
  _file_name = WSGFstrdup("");
  _cont = 0;
  _cntr = new WSDcntrControl(NULL);
  _playing = False;
  _com_initialized = False;
  _disp_handle = NULL;
  _cntl_handle = NULL;

  WSMFpropertyCreateStart
    WSMFparentCheckVerSrc(WSCflashForm);

    WSMFpropertyCreate(WSNfileName,  char*,   _file_name, WSSfileName );
    WSMFpropertyCreate(WSNcont,      WSCbool, _cont,      WSScont );

    WSMFpropertyDelete(WSNpixmapStyle);

  WSMFpropertyCreateEnd

}
WSCflashForm::~WSCflashForm(){
  if (_disp_handle != NULL){
    IDispatch* disp_ptr = (IDispatch*)_disp_handle;
    disp_ptr->Release();
  }
#if 0
  if (_cntl_handle != NULL){
    IOleControl* disp_ptr = (IOleControl*)_cntl_handle;
    disp_ptr->Release();
  }
#endif
  if (_cntr != NULL){
    delete _cntr;
  }
}

WSMFproperty( WSCflashForm, WSNfileName,char*, _file_name ,WSGFstrdup(""));
WSMFproperty( WSCflashForm, WSNcont,WSCbool, _cont ,0);
void WSCflashForm::setWorkWSNfileName(char* str){
  if (getVisible() != False && _com_initialized != False){
    if (strcmp(_file_name,"")){
      VARIANT retv;
      VARIANT str;
      OLECHAR* f_name = ComGetOleChar(_file_name);
      VariantInit(&str);
      str.bstrVal = f_name;
      str.vt = VT_BSTR;

      VariantInit(&retv);
      IDispatch* disp_ptr = (IDispatch*)_disp_handle;
      HRESULT hr = ComPutProperty(disp_ptr, L"Movie", &str);
      SysFreeString(f_name);
      if(FAILED(hr)){
        return;
      }
    }
  }
}
void WSCflashForm::getWorkWSNfileName(char** str){
}
void WSCflashForm::setWorkWSNcont(WSCbool fl){
}
void WSCflashForm::getWorkWSNcont(WSCbool* fl){
}


void WSCflashForm::_init(){
  if (getVisible() == False){
    return;
  }
  void* wnd = (void*)getdev()->getWindowResource();
  if (wnd == NULL){
    return;
  }
  _cntr->SetHandle(wnd);

  HRESULT hr;
  VARIANT retv;
  if (_com_initialized == False){
    _com_initialized = True;
    hr = ComCoInitialize(NULL);
    if(FAILED(hr)){
      return;
    }
    CLSID clsid = CLSID_ShockwaveFlash;
    IDispatch* disp_ptr = NULL;
    hr = ::CoCreateInstance(
                clsid, NULL,
                CLSCTX_INPROC,
                IID_IDispatch,
                (void**)&disp_ptr);
    if(FAILED(hr)){
      return;
    }
    _disp_handle = (void*)disp_ptr;

    VariantInit(&retv);
    IOleObject* com_obj = NULL;
    hr = disp_ptr->QueryInterface(
      IID_IOleObject,
      (void**)&com_obj);
    if(FAILED(hr)){
      return;
    }
    com_obj->SetClientSite(_cntr);
    _cntl_handle = (void*)com_obj;
    
    SIZEL sizel;
    sizel.cx = _w;
    sizel.cy = _h;
    hr = com_obj->SetExtent(DVASPECT_CONTENT,&sizel);
    if(FAILED(hr)){
      return;
    }

    HWND hWnd = (HWND)getdev()->getWindowResource();
    RECT rect;
    rect.left = 0;
    rect.top = 0;
    rect.right = _w;
    rect.bottom = _h;
    com_obj->DoVerb(OLEIVERB_SHOW,0,_cntr,0,hWnd,&rect);
    com_obj->DoVerb(OLEIVERB_INPLACEACTIVATE,0,_cntr,0,hWnd,&rect);

    if (strcmp(_file_name,"")){
      VARIANT str;
      OLECHAR* f_name = ComGetOleChar(_file_name);
      VariantInit(&str);
      str.bstrVal = f_name;
      str.vt = VT_BSTR;

      hr = ComPutProperty(disp_ptr, L"Movie", &str);
      SysFreeString(f_name);
      if(FAILED(hr)){
        return;
      }
    }
  }
}
void WSCflashForm::_deinit(){
  if (_disp_handle == NULL){
    return;
  }
  IOleObject* com_obj = (IOleObject*)_cntl_handle;
  com_obj->DoVerb(OLEIVERB_HIDE,0,_cntr,0,0,0);


  IDispatch* disp_ptr =(IDispatch*)_disp_handle;
  disp_ptr->Release();
  _disp_handle = NULL;
  _cntl_handle = NULL;
  _com_initialized = False;
}

void WSCflashForm::onResize(WSCrect* rect){
  WSCform::onResize(rect);
  _deinit();
//  _init();
}

void WSCflashForm::onVisibleChange(WSCbool fl){
  WSCform::onVisibleChange(fl);
  if (fl == True && getVisible() != False){
    _init();
  }
  if (fl == False){
    _deinit();
  }
}
void WSCflashForm::onParentVisibleChange(WSCbool fl){
  WSCform::onParentVisibleChange(fl);
  if (fl == True && getVisible() != False){
    _init();
  }
  if (fl == False){
    _deinit();
  }
}
long WSCflashForm::draw(){
  if (getVisible() != False && _com_initialized == False){
    void* wnd = (void*)getdev()->getWindowResource();
    if (wnd == NULL){
      return WSCform::draw();
    }
    _cntr->SetHandle((void*)getdev()->getWindowResource());
    _init();
   }
  return WSCform::draw();
}
