//
// Copyright (C) 1999-2008 WideStudio/MWT Project Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
//

#include <WScom.h>
#include <WSCieForm.h>
#include <WSCclassInformation.h>
#include <WSClocaleSet.h>
#include <WSDdev.h>

//windows com depend headers
#include <wscntrctl.h>
#include <windows.h>
#include <oaidl.h>
#include <cstdio>
#include <cassert>
#include <stdarg.h>
#include <exdisp.h>
#include <olectl.h>
#include <oleidl.h>
#include <shlguid.h>
#include <cguid.h>
#include <initguid.h>

extern "C" {
WSDLEX32 void libwscom_func();
};
void libwscom_func(){
}

WSMFguiClassInitialize(WSCieForm, WSCform);
WSMFversion(WSCieForm, WSCform);

WSCieForm::WSCieForm(WSCbase* base, char* objname):
			WSCform(base, objname){
dbprintf("WSCieForm::WSCieForm() %s:%d started\n",__FILE__,__LINE__);
  _file_name = WSGFstrdup("");
  _cntr = new WSDcntrControl(NULL);
  _playing = False;
  _com_initialized = False;
  _disp_handle = NULL;
  _cntl_handle = NULL;

  WSMFpropertyCreateStart
    WSMFparentCheckVerSrc(WSCieForm);

    WSMFpropertyCreate(WSNfileName,  char*,   _file_name, WSSfileName );

    WSMFpropertyDelete(WSNpixmapStyle);

  WSMFpropertyCreateEnd

dbprintf("WSCieForm::WSCieForm() %s:%d done\n",__FILE__,__LINE__);
}
WSCieForm::~WSCieForm(){
dbprintf("WSCieForm::~WSCieForm() %s:%d started\n",__FILE__,__LINE__);
  if (_disp_handle != NULL){
    IDispatch* disp_ptr = (IDispatch*)_disp_handle;
    disp_ptr->Release();
  }
#if 0
  if (_cntl_handle != NULL){
    IOleControl* disp_ptr = (IOleControl*)_cntl_handle;
    disp_ptr->Release();
  }
#endif
  if (_cntr != NULL){
    delete _cntr;
  }
dbprintf("WSCieForm::~WSCieForm() %s:%d done\n",__FILE__,__LINE__);
}

WSMFproperty( WSCieForm, WSNfileName,char*, _file_name ,WSGFstrdup(""));
void WSCieForm::setWorkWSNfileName(char* str){
dbprintf("WSCieForm::setWorkWSNfileName() %s:%d started\n",__FILE__,__LINE__);
  if (getVisible() != False && _com_initialized != False){
    if (strcmp(_file_name,"")){
      VARIANT retv;
      VARIANT str;
      OLECHAR* f_name = ComGetOleChar(_file_name);
      VariantInit(&str);
      str.bstrVal = f_name;
      str.vt = VT_BSTR;

      VariantInit(&retv);
      IDispatch* disp_ptr = (IDispatch*)_disp_handle;
      HRESULT hr = ComInvoke(disp_ptr, L"Navigate", &retv, 1, str);
      SysFreeString(f_name);
      if(FAILED(hr)){
dbprintf("WSCieForm::setWorkWSNfileName() %s:%d done\n",__FILE__,__LINE__);
        return;
      }
    }
  }
dbprintf("WSCieForm::setWorkWSNfileName() %s:%d done\n",__FILE__,__LINE__);
}
void WSCieForm::getWorkWSNfileName(char** str){
dbprintf("WSCieForm::getWorkWSNfileName() %s:%d\n",__FILE__,__LINE__);
}
void WSCieForm::_init(){
dbprintf("WSCieForm::_init() %s:%d started\n",__FILE__,__LINE__);
  if (getVisible() == False){
    return;
  }
  void* wnd = (void*)getdev()->getWindowResource();
  if (wnd == NULL){
dbprintf("WSCieForm::_init() %s:%d done\n",__FILE__,__LINE__);
    return;
  }
dbprintf("WSCieForm::_init() %s:%d _cntr->SetHandle(0x%x) this=0x%x\n",__FILE__,__LINE__,wnd,this);
  _cntr->SetHandle(wnd);

  HRESULT hr;
  VARIANT retv;
  if (_com_initialized == False){
    _com_initialized = True;
dbprintf("WSCieForm::_init() %s:%d ComCoInitialize started\n",__FILE__,__LINE__);
    hr = ComCoInitialize(NULL);
dbprintf("WSCieForm::_init() %s:%d ComCoInitialize done\n",__FILE__,__LINE__);
    if(FAILED(hr)){
dbprintf("WSCieForm::_init() %s:%d done\n",__FILE__,__LINE__);
      return;
    }
    IDispatch* disp_ptr = NULL;
    CLSID clsid = CLSID_WebBrowser;
dbprintf("WSCieForm::_init() %s:%d CoCreateInst started\n",__FILE__,__LINE__);
    hr = ::CoCreateInstance(
                clsid, NULL,
                CLSCTX_INPROC,
                IID_IDispatch,
                (void**)&disp_ptr);
dbprintf("WSCieForm::_init() %s:%d CoCreateInst done\n",__FILE__,__LINE__);
    if(FAILED(hr)){
dbprintf("WSCieForm::_init() %s:%d done\n",__FILE__,__LINE__);
      return;
    }
    _disp_handle = (void*)disp_ptr;

    VariantInit(&retv);
    IOleObject* com_obj = NULL;
dbprintf("WSCieForm::_init() %s:%d QueryInterface() started\n",__FILE__,__LINE__);
    hr = disp_ptr->QueryInterface(
      IID_IOleObject,
      (void**)&com_obj);
dbprintf("WSCieForm::_init() %s:%d QueryInterface() done\n",__FILE__,__LINE__);
    if(FAILED(hr)){
dbprintf("WSCieForm::_init() %s:%d done\n",__FILE__,__LINE__);
      return;
    }
dbprintf("WSCieForm::_init() %s:%d SetClientSite() started\n",__FILE__,__LINE__);
    com_obj->SetClientSite(_cntr);
dbprintf("WSCieForm::_init() %s:%d SetClientSite() done\n",__FILE__,__LINE__);
    _cntl_handle = (void*)com_obj;

    SIZEL sizel;
    sizel.cx = _w;
    sizel.cy = _h;

dbprintf("WSCieForm::_init() %s:%d SetExtent() started\n",__FILE__,__LINE__);
    hr = com_obj->SetExtent(DVASPECT_CONTENT,&sizel);
dbprintf("WSCieForm::_init() %s:%d SetExtent() done\n",__FILE__,__LINE__);
    if(FAILED(hr)){
dbprintf("WSCieForm::_init() %s:%d done\n",__FILE__,__LINE__);
      return;
    }

    HWND hWnd = (HWND)getdev()->getWindowResource();
    RECT rect;
    rect.left = 0;
    rect.top = 0;
    rect.right = _w;
    rect.bottom = _h;
dbprintf("WSCieForm::_init() %s:%d DoVerb() started\n",__FILE__,__LINE__);
    com_obj->DoVerb(OLEIVERB_SHOW,0,_cntr,0,hWnd,&rect);
dbprintf("WSCieForm::_init() %s:%d DoVerb() done\n",__FILE__,__LINE__);
dbprintf("WSCieForm::_init() %s:%d DoVerb() started\n",__FILE__,__LINE__);
    com_obj->DoVerb(OLEIVERB_INPLACEACTIVATE,0,_cntr,0,hWnd,&rect);
dbprintf("WSCieForm::_init() %s:%d DoVerb() done\n",__FILE__,__LINE__);

    if (strcmp(_file_name,"")){
      VARIANT str;
      OLECHAR* f_name = ComGetOleChar(_file_name);
      VariantInit(&str);
      str.bstrVal = f_name;
      str.vt = VT_BSTR;
      VariantInit(&retv);
dbprintf("WSCieForm::_init() %s:%d Invoke() started\n",__FILE__,__LINE__);
      hr = ComInvoke(disp_ptr, L"Navigate", &retv, 1, str);
dbprintf("WSCieForm::_init() %s:%d Invoke() done\n",__FILE__,__LINE__);
      SysFreeString(f_name);
      if(FAILED(hr)){
dbprintf("WSCieForm::_init() %s:%d done\n",__FILE__,__LINE__);
        return;
      }
    }
  }
dbprintf("WSCieForm::_init() %s:%d done\n",__FILE__,__LINE__);
}
void WSCieForm::_deinit(){
dbprintf("WSCieForm::_deinit() %s:%d started\n",__FILE__,__LINE__);
  if (_disp_handle == NULL){
    return;
  }
  IOleObject* com_obj = (IOleObject*)_cntl_handle;
  com_obj->DoVerb(OLEIVERB_HIDE,0,0,0,0,0);


  IDispatch* disp_ptr = (IDispatch*)_disp_handle;
  disp_ptr->Release();
  _disp_handle = NULL;
  _cntl_handle = NULL;
  _com_initialized = False;
dbprintf("WSCieForm::_deinit() %s:%d done\n",__FILE__,__LINE__);
}

void WSCieForm::onResize(WSCrect* rect){
  WSCform::onResize(rect);
  _deinit();
//  _init();
}
void WSCieForm::onVisibleChange(WSCbool fl){
dbprintf("WSCieForm::onVisibleChange() %s:%d started fl=%d\n",__FILE__,__LINE__,fl);
  WSCform::onVisibleChange(fl);
  if (fl == True && getVisible() != False){
    _init();
  }
  if (fl == False){
    _deinit();
  }
dbprintf("WSCieForm::onVisibleChange() %s:%d done\n",__FILE__,__LINE__);
}
void WSCieForm::onParentVisibleChange(WSCbool fl){
dbprintf("WSCieForm::onParentVisibleChange() %s:%d started fl=%d\n",__FILE__,__LINE__,fl);
  WSCform::onParentVisibleChange(fl);
  if (fl == True && getVisible() != False){
    _init();
  }
  if (fl == False){
    _deinit();
  }
dbprintf("WSCieForm::onParentVisibleChange() %s:%d done\n",__FILE__,__LINE__);
}
long WSCieForm::draw(){
dbprintf("WSCieForm::draw() %s:%d started\n",__FILE__,__LINE__);
  if (getVisible() != False && _com_initialized == False){
    void* wnd = (void*)getdev()->getWindowResource();
    if (wnd == NULL){
      long ret = WSCform::draw();
dbprintf("WSCieForm::draw() %s:%d done\n",__FILE__,__LINE__);
      return ret;
    }
    _cntr->SetHandle((void*)getdev()->getWindowResource());
    _init();
   }
  long ret = WSCform::draw();
dbprintf("WSCieForm::draw() %s:%d done\n",__FILE__,__LINE__);
  return ret;
}
