#ifdef UNICODE
#undef UNICODE
#endif

#include "ipserver.h"

#include "guids.h"
#include "util.h"
#include "globals.h"
#include "resource.h"
#include "wscntrctl.h"
#include <WScom.h>
#include <WSCbase.h>
#include <WSDappDev.h>

#include <stdio.h>

SZTHISFILE
extern void DisplayAssert(char*,char*,char*,UINT);
WCHAR wszImage [] = L"WScntr";

static VARTYPE rgMouse[] = { VT_I2, VT_I2, VT_I4, VT_I4 };
enum { MouseMove=0, MouseDown, MouseUp, Click, DblClick };

#define WS_CALL1
#define WS_CALL2
#define WS_CALL3
#define WS_CALL4

static EVENTINFO rgEvents [] = {
    { DISPID_MOUSEMOVE, 4, rgMouse },
    { DISPID_MOUSEDOWN, 4, rgMouse },
    { DISPID_MOUSEUP, 4, rgMouse },
    { DISPID_CLICK, 0, NULL },
    { DISPID_DBLCLICK, 0, NULL },
};

const GUID *rgWScntrPropPages [] = {
    &CLSID_WScntrGeneralPage
};

//WSClistData _instance_list;
//WSClistData _base_list;

//extern "C" {
//extern void _ws_initialize(void*);
//};

#pragma warning(disable:4355)  // using 'this' in constructor
WSDcntrControl::WSDcntrControl(IUnknown *pUnkOuter)
        :COleControl(pUnkOuter, OBJECT_TYPE_CTLWSCNTR, (IDispatch *)this){
dbprintf("WSDcntrControl::WSDcntrControl %s:%d start\n",__FILE__,__LINE__);
#ifdef WS_CALL1
static long initialized = FALSE;
  if (initialized == FALSE){
//    _ws_initialize(NULL);
    InitializeCriticalSection(&g_CriticalSection);
    initialized = TRUE;
  }
//  _instance_list.add((void*)this);
//  _base_list.add((void*)NULL);
#endif
dbprintf("WSDcntrControl::WSDcntrControl %s:%d done\n",__FILE__,__LINE__);
}
#pragma warning(default:4355)  // using 'this' in constructor

WSDcntrControl::~WSDcntrControl(){
dbprintf("WSDcntrControl::~WSDcntrControl %s:%d start\n",__FILE__,__LINE__);
dbprintf("WSDcntrControl::~WSDcntrControl %s:%d done\n",__FILE__,__LINE__);
}

WSDLEX32 LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);
BOOL WSDcntrControl::RegisterClassData(){
dbprintf("WSDcntrControl::RegisterClassData %s:%d start\n",__FILE__,__LINE__);
    WNDCLASS wndclass;
    memset(&wndclass, 0, sizeof(WNDCLASS));
    wndclass.style          = CS_VREDRAW | CS_HREDRAW | CS_DBLCLKS | CS_OWNDC;
//    wndclass.lpfnWndProc    = COleControl::ControlWindowProc;
    wndclass.lpfnWndProc    = WndProc;
    wndclass.hInstance      = g_hInstance;
    wndclass.hCursor        = LoadCursor(NULL, IDC_ARROW);
    wndclass.hbrBackground  = (HBRUSH)(COLOR_WINDOW + 1);
    wndclass.lpszClassName  = WNDCLASSNAMEOFCONTROL(OBJECT_TYPE_CTLWSCNTR);

dbprintf("WSDcntrControl::RegisterClassData %s:%d done\n",__FILE__,__LINE__);
    return RegisterClass(&wndclass);
}

HRESULT WSDcntrControl::InternalQueryInterface(REFIID  riid,void  **ppvObjOut){
dbprintf("WSDcntrControl::InternalQueryInterface %s:%d start\n",__FILE__,__LINE__);
    IUnknown *pUnk;

    *ppvObjOut = NULL;
dbprintf("WSDcntrControl::InternalQueryInterface %s:%d here1\n",__FILE__,__LINE__);
    if (DO_GUIDS_MATCH(riid, IID_IWScntr)) {
        pUnk = (IUnknown *)(IWScntr *)this;
    } else{
dbprintf("WSDcntrControl::InternalQueryInterface %s:%d here4 this=0x%x\n",__FILE__,__LINE__,this);
        HRESULT ret = COleControl::InternalQueryInterface(riid, ppvObjOut);
dbprintf("WSDcntrControl::InternalQueryInterface %s:%d done\n",__FILE__,__LINE__);
        return ret;
    }

dbprintf("WSDcntrControl::InternalQueryInterface %s:%d here2\n",__FILE__,__LINE__);
    pUnk->AddRef();
dbprintf("WSDcntrControl::InternalQueryInterface %s:%d here3\n",__FILE__,__LINE__);
    *ppvObjOut = (void *)pUnk;
dbprintf("WSDcntrControl::InternalQueryInterface %s:%d done2\n",__FILE__,__LINE__);
    return S_OK;
}

STDMETHODIMP WSDcntrControl::LoadTextState( IPropertyBag *pPropertyBag,IErrorLog    *pErrorLog){
dbprintf("WSDcntrControl::LoadTextState %s:%d start\n",__FILE__,__LINE__);
	VARIANT v;
	HRESULT hr;
#if 0
	VariantInit(&v);    

	v.vt = VT_I2;
	hr = pPropertyBag->Read(L"Number",&v,pErrorLog);
	if (SUCCEEDED(hr))
		m_number = (enumWScntrNumber) v.iVal;
	ValidateNumber();
	VariantClear(&v);

	v.vt = VT_I2;
	hr = pPropertyBag->Read(L"Suite",&v,pErrorLog);
	if (SUCCEEDED(hr))
		m_suite = (enumWScntrSuite) v.iVal;
	ValidateSuite();
	VariantClear(&v);

	v.vt = VT_BOOL;
	hr = pPropertyBag->Read(L"Invert",&v,pErrorLog);
	if (SUCCEEDED(hr))
		m_invert = v.boolVal;
	VariantClear(&v);

	v.vt = VT_I2;
	hr = pPropertyBag->Read(L"WScntrAlignment",&v,pErrorLog);
	if (SUCCEEDED(hr))
		m_cardalignment = (enumWScntrAlignment) v.iVal;
	ValidateWScntrAlignment();
	VariantClear(&v);
#endif
dbprintf("WSDcntrControl::LoadTextState %s:%d done\n",__FILE__,__LINE__);
    return S_OK;
}

#define		STREAMHDR_MAGIC		1296924267
STDMETHODIMP WSDcntrControl::LoadBinaryState(IStream *pStream){
dbprintf("WSDcntrControl::LoadBinaryState %s:%d start\n",__FILE__,__LINE__);
    HRESULT hr;
	DWORD sh;
#if 0
	hr = pStream->Read(&sh, sizeof(sh), NULL);
	RETURN_ON_FAILURE(hr);

	if (sh != STREAMHDR_MAGIC )
		return E_UNEXPECTED;

	hr = pStream->Read(&(m_number),sizeof(m_number),NULL);
	RETURN_ON_FAILURE(hr);
	ValidateNumber();

	hr = pStream->Read(&(m_suite),sizeof(m_suite),NULL);
	RETURN_ON_FAILURE(hr);
	ValidateSuite();

	hr = pStream->Read(&(m_invert),sizeof(m_invert),NULL);
	RETURN_ON_FAILURE(hr);

	hr = pStream->Read(&(m_cardalignment),sizeof(m_cardalignment),NULL);
	RETURN_ON_FAILURE(hr);
	ValidateWScntrAlignment();
#endif
dbprintf("WSDcntrControl::LoadBinaryState %s:%d done\n",__FILE__,__LINE__);
	return S_OK;
}

STDMETHODIMP WSDcntrControl::SaveTextState(IPropertyBag *pPropertyBag,BOOL fWriteDefaults){
	VARIANT v;
	HRESULT hr;
#if 0
	if( m_number != DefaultNumber )
	{
		VariantInit(&v);
		v.vt = VT_I2;
		v.iVal = m_number;
		hr = pPropertyBag->Write( L"Number", &v);
	}

	if( m_suite != DefaultSuite )
	{
		VariantInit(&v);
		v.vt = VT_I2;
		v.iVal = m_suite;
		hr = pPropertyBag->Write( L"Suite", &v);
	}

	if( m_invert != DefaultInvert )
	{
		VariantInit(&v);
		v.vt = VT_BOOL;
		v.boolVal = m_invert;
		hr = pPropertyBag->Write( L"Invert", &v);
	}

	if( m_cardalignment != DefaultWScntrAlignment )
	{
		VariantInit(&v);
		v.vt = VT_I2;
		v.iVal = m_cardalignment;
		hr = pPropertyBag->Write( L"WScntrAlignment", &v);
	}
#endif
	return S_OK;
}

STDMETHODIMP WSDcntrControl::SaveBinaryState(IStream *pStream){
    HRESULT hr;
    DWORD sh = STREAMHDR_MAGIC;    
#if 0
    // write out the stream hdr.
    //
    hr = pStream->Write(&sh, sizeof(sh), NULL);
    RETURN_ON_FAILURE(hr);

    hr = pStream->Write(&(m_number),sizeof(m_number),NULL);
    RETURN_ON_FAILURE(hr);

    hr = pStream->Write(&(m_suite),sizeof(m_suite),NULL);
    RETURN_ON_FAILURE(hr);

    hr = pStream->Write(&(m_invert),sizeof(m_invert),NULL);
    RETURN_ON_FAILURE(hr);

    hr = pStream->Write(&(m_cardalignment),sizeof(m_cardalignment),NULL);
    RETURN_ON_FAILURE(hr);
#endif
    return S_OK;
}

STDMETHODIMP WSDcntrControl::OnDraw(
    DWORD    dvaspect,        
    HDC      hdcDraw,
    LPCRECTL prcBounds,
    LPCRECTL prcWBounds,
    HDC      hicTargetDevice,
    BOOL     fOptimize ){
dbprintf("WSDcntrControl::OnDraw %s:%d start\n",__FILE__,__LINE__);
	int OffsetX, OffsetY;
	RECTL rcBoundsDP;
	int width, height;
	int savedDC;
	HDC drawDc;
	HBITMAP drawDcMem;
	int c;
#if 0
	if( !Windowless() && !BackBrush )
	{
		OLE_COLOR BackColor;
		COLORREF BackColorCR;
		if( !GetAmbientProperty( DISPID_AMBIENT_BACKCOLOR, VT_I4, &BackColor ) )
			BackColor = 0;
		OleTranslateColor( BackColor, NULL, &BackColorCR );
		BackBrush = CreateSolidBrush( BackColorCR );
	}
		
	rcBoundsDP = *prcBounds;
	LPtoDP( hdcDraw, (POINT *) &rcBoundsDP, 2 );

	width = rcBoundsDP.right - rcBoundsDP.left;
	height = rcBoundsDP.bottom - rcBoundsDP.top;

	switch( m_cardalignment )
	{
		case WScntrTopCenter: 
		case WScntrCenter:
		case WScntrBottomCenter:
			OffsetX = (width - CWScntrDraw::WScntrSizeX) / 2;
			break;
		case WScntrTopRight: 
		case WScntrCenterRight:
		case WScntrBottomRight:
			OffsetX = (width - CWScntrDraw::WScntrSizeX);
			break;
		default:
			OffsetX = 0;
			break;
	}
	switch( m_cardalignment )
	{
		case WScntrCenterRight:
		case WScntrCenter:
		case WScntrCenterLeft:
			OffsetY = (height - CWScntrDraw::WScntrSizeY) / 2;
			break;
		case WScntrBottomRight: 
		case WScntrBottomCenter: 
		case WScntrBottomLeft:
			OffsetY = (height - CWScntrDraw::WScntrSizeY);
			break;
		default:
			OffsetY = 0;
			break;
	}

	if( BackBrush )
		FillRect( hdcDraw, (RECT *) prcBounds, BackBrush );

	if( m_suite == WScntrBlank )
		return S_OK;

	savedDC = SaveDC( hdcDraw );

	SetMapMode( hdcDraw, MM_TEXT );
	SetWindowOrgEx( hdcDraw, -(OffsetX + rcBoundsDP.left), 
				 -(OffsetY + rcBoundsDP.top), NULL );
	SetViewportOrgEx( hdcDraw, 0, 0, NULL );

	if( width < CWScntrDraw::WScntrSizeX || height < CWScntrDraw::WScntrSizeY )
	{
		HRGN clipRgn;
		clipRgn = CreateRectRgn( rcBoundsDP.left, 
					 rcBoundsDP.top, 
					 rcBoundsDP.left + width, 
					 rcBoundsDP.top + height );
		SelectClipRgn( hdcDraw, clipRgn );
		DeleteObject( clipRgn );
	}		

	SelectObject( hdcDraw, GetStockObject( m_invert ? WHITE_PEN : BLACK_PEN ) );

	drawDc = CreateCompatibleDC( NULL );

	if( m_suite > 0 )
		c = (m_suite-1)*14 + (m_number-1);
	else
		c = (m_suite < -12) ? 56 : -m_suite + 56;

	if( !cardcacheMem[c] )
	{
		CWScntrDraw cd( (c > 55 ? CWScntrDraw::DrawBack : (int) m_number) );

	        EnterCriticalSection( &drawCritSec );
		if( !cardcacheMem[c] )
		{
			cardcacheMem[c] = cd.CreateDIBWScntr( hdcDraw );
			drawDcMem = (HBITMAP) SelectObject( drawDc, cardcacheMem[c] );	
			cd.DrawWScntr( drawDc, m_suite, m_number );
		}
		else
			drawDcMem = (HBITMAP) SelectObject( drawDc, cardcacheMem[c] );	
		LeaveCriticalSection( &drawCritSec );
	}
	else
		drawDcMem = (HBITMAP) SelectObject( drawDc, cardcacheMem[c] );	

	if( m_cardalignment != WScntrStretch )
	{
	  	BitBlt( hdcDraw, 1, 1, CWScntrDraw::WScntrSizeX-2, CWScntrDraw::WScntrSizeY-2,
		 	   drawDc, 1, 1, m_invert ? NOTSRCCOPY : SRCCOPY );
		Polyline( hdcDraw, CWScntrDraw::WScntrBorder, 
				sizeof(CWScntrDraw::WScntrBorder)/sizeof(POINT) );
	}
	else
	{
		POINT border[9];
		memcpy( border, CWScntrDraw::WScntrBorder, sizeof(border) );
		border[2].x = border[5].x = width-3;
		border[3].x = border[4].x = width-1;
		border[4].y = border[7].y = height-3;
		border[5].y = border[6].y = height-1;
		StretchBlt( hdcDraw, 1, 1, width-2, height-2,
				drawDc, 1, 1, 
				CWScntrDraw::WScntrSizeX-2,
				CWScntrDraw::WScntrSizeY-2,
				m_invert ? NOTSRCCOPY : SRCCOPY );
		Polyline( hdcDraw, border, sizeof(border)/sizeof(POINT) );
	}

	RestoreDC( hdcDraw, savedDC );

	SelectObject( drawDc, drawDcMem );
	DeleteDC( drawDc );
#endif	
dbprintf("WSDcntrControl::OnDraw %s:%d done\n",__FILE__,__LINE__);
    return S_OK;
}

LRESULT WSDcntrControl::WindowProc( UINT msg, WPARAM wParam, LPARAM lParam){
dbprintf("WSDcntrControl::WindowProc %s:%d start\n",__FILE__,__LINE__);
    POINTS pt;
    RECT rect;
    int b, s;
    int ev = -1;
#if 0
    switch( msg )
    {
	case WM_MOUSEMOVE:
		ev = MouseMove;
		// FALL THROUGH!
	case WM_LBUTTONDOWN:
	case WM_MBUTTONDOWN:
	case WM_RBUTTONDOWN:
		if( ev == -1 )	ev = MouseDown;
		// FALL THROUGH!
	case WM_LBUTTONUP:
	case WM_MBUTTONUP:
	case WM_RBUTTONUP:
		if( ev == -1 )  ev = MouseUp;
		pt = MAKEPOINTS( lParam );
		OcxGetWindowRect( &rect );
		b = (wParam & 3) == 3 ? 4 : wParam & 3;
		s = (wParam >> 2) & 7;
		FireEvent( &rgEvents[ev], b, s, pt.x-rect.left, pt.y-rect.top );
		if( msg == WM_LBUTTONUP )
			FireEvent( &rgEvents[Click] );
		break;
	case WM_LBUTTONDBLCLK:
		FireEvent( &rgEvents[DblClick] );
		break;
    }
#endif
    LRESULT ret = OcxDefWindowProc(msg, wParam, lParam);
dbprintf("WSDcntrControl::WindowProc %s:%d done\n",__FILE__,__LINE__);
    return ret;
}

IUnknown *WSDcntrControl::Create( IUnknown *pUnkOuter ){
dbprintf("WSDcntrControl::Create %s:%d start\n",__FILE__,__LINE__);
    WSDcntrControl *pNew = new WSDcntrControl(pUnkOuter);
dbprintf("WSDcntrControl::Create %s:%d done pNew=0x%x\n",__FILE__,__LINE__,pNew);
    return pNew->PrivateUnknown();
}

void dummy_wscntrctl(){
}
extern "C" {
extern void _ws_set_window(void*);
extern WSCbase* _ws_create_window();
};

BOOL WSDcntrControl::AfterCreateWindow(){
dbprintf("WSDcntrControl::AfterCreateWindow() %s:%d start m_hwnd=0x%x\n",__FILE__,__LINE__,m_hwnd);
#if 0
#ifdef WS_CALL2
  if (m_hwnd == NULL){
dbprintf("WSDcntrControl::AfterCreateWindow() %s:%d done. error.\n",__FILE__,__LINE__);
    return FALSE;
  }
  long num = _instance_list.getNum();
  long i;
  for(i=0; i<num; i++){
    WSDcntrControl* item = (WSDcntrControl*)_instance_list[i];
    WSCbase* inst = (WSCbase*)_base_list[i];
    if (item == this){
      if (inst == NULL){
        _ws_set_window(m_hwnd);
        _base_list.setData(i,_ws_create_window());
        break;
      }else{
        inst->setVisible(True);
      }
    }
  }
  InvalidateRect(m_hwnd,NULL,TRUE);
  UpdateWindow(m_hwnd);
#endif
#endif
  BOOL ret = COleControl::AfterCreateWindow();
dbprintf("WSDcntrControl::AfterCreateWindow() %s:%d done.ret=%d \n",__FILE__,__LINE__,ret);
  return ret;
}

void WSDcntrControl::BeforeDestroyWindow(){
dbprintf("WSDcntrControl::BeforeDestroyWindow %s:%d start\n",__FILE__,__LINE__);
#if 0
#ifdef WS_CALL3
  long num = _instance_list.getNum();
  long i;
  for(i=0; i<num; i++){
    WSDcntrControl* item = (WSDcntrControl*)_instance_list[i];
    WSCbase* client = (WSCbase*)_base_list[i];
    if (item == this){
      _instance_list.delPos(i);
      _base_list.delPos(i);
dbprintf("WSDcntrControl::BeforeDestroyWindow %s:%d delete client=%s\n",__FILE__,__LINE__,client->getInstanceName());
#ifdef WS_CALL4
      delete client;
#endif
      break;
    }
  }
  COleControl::BeforeDestroyWindow();
#endif
#endif
dbprintf("WSDcntrControl::BeforeDestroyWindow %s:%d done\n",__FILE__,__LINE__);
  return;
}
void WSDcntrControl::AfterDestroyWindow(){
dbprintf("WSDcntrControl::AfterDestroyWindow %s:%d start\n",__FILE__,__LINE__);
#if 0
#ifdef WS_CALL3
  long num = _instance_list.getNum();
  long i;
  for(i=0; i<num; i++){
    WSDcntrControl* item = (WSDcntrControl*)_instance_list[i];
    WSCbase* client = (WSCbase*)_base_list[i];
    if (item == this){
      _instance_list.delPos(i);
      _base_list.delPos(i);
dbprintf("WSDcntrControl::AfterDestroyWindow %s:%d delete client=%s\n",__FILE__,__LINE__,client->getInstanceName());
#ifdef WS_CALL4
      delete client;
#endif
      break;
    }
  }
  COleControl::AfterDestroyWindow();
#endif
#endif
dbprintf("WSDcntrControl::AfterDestroyWindow %s:%d done\n",__FILE__,__LINE__);
  return;
}
STDMETHODIMP WSDcntrControl::SetHandle(void* pValue){
  _handle = pValue;
  m_hwnd_ws = (HWND)pValue;
  return S_OK;
}

#if 0
STDMETHODIMP WSDcntrControl::GetUserType(DWORD p1,WCHAR* p2){
  return COleControl::GetUserType(p1,p2);
}
STDMETHODIMP WSDcntrControl::GetExtent(DWORD p1,LONG p2,DVTARGETDEVICE* p3,tagSIZE* p4){
  return COleControl::GetExtent(p1,p2,p3,p4);
}
#endif
HRESULT ComCoInitialize(void* ptr){
static int initialized = 0;
  if (initialized == 0){
    initialized = 1;
    return CoInitialize(ptr);
  }
  return S_OK;
}
OLECHAR* ComGetOleChar(char* str){
  WSCstring tmp(str);
  char* utf8str = tmp.getString(WS_EN_UTF8);
  int len = (int)MultiByteToWideChar( CP_UTF8, 0, utf8str, strlen(utf8str), NULL, 0 );
  OLECHAR* ret = SysAllocStringLen(NULL,len);
  MultiByteToWideChar(CP_UTF8, 0, utf8str, strlen(utf8str), ret, len );
  return ret;
}
HRESULT ComGetProperty(IDispatch* disp_ptr, OLECHAR* pname, VARIANT* ret){
  HRESULT hr;
  DISPID dispId;
  DISPPARAMS dparams = {
    NULL,
    NULL,
    0,
    0
  };

  hr = disp_ptr->GetIDsOfNames(IID_NULL, &pname, 1,LOCALE_USER_DEFAULT,&dispId);
  if (FAILED(hr)){
    return hr;
  }
  hr = disp_ptr->Invoke(dispId, IID_NULL,LOCALE_USER_DEFAULT,
                DISPATCH_PROPERTYGET,&dparams, ret,NULL, NULL);
  return hr;
}

HRESULT ComPutProperty(IDispatch* disp_ptr, OLECHAR* pname, const VARIANT* pvValue){
  DISPID dispIdNamedArgs[1] = {
    DISPID_PROPERTYPUT
  };

  DISPID dispId;
  HRESULT hr = disp_ptr->GetIDsOfNames(IID_NULL, &pname, 1,LOCALE_USER_DEFAULT,&dispId);
  if (FAILED(hr)) {
    return hr;
  }

  VARIANTARG args[1];
  VariantInit(&args[0]);
  VariantCopy(&args[0], const_cast<VARIANT*>(pvValue));

  DISPPARAMS dparams;
  dparams.rgvarg = args;
  dparams.rgdispidNamedArgs = dispIdNamedArgs;
  dparams.cArgs = 1;
  dparams.cNamedArgs = 1;

  hr = disp_ptr->Invoke( dispId, IID_NULL, LOCALE_USER_DEFAULT,
                DISPATCH_PROPERTYPUT, &dparams, NULL, NULL, NULL);
  VariantClear(&args[0]);

  return hr;
}

HRESULT ComInvoke(IDispatch* disp_ptr, OLECHAR* pname, VARIANT* ret, int nArgs, ...){

  DISPID dispId;
  HRESULT hr = disp_ptr->GetIDsOfNames(IID_NULL, &pname, 1,LOCALE_USER_DEFAULT,&dispId);
  if (FAILED(hr)) {
    return hr;
  }

  VARIANTARG *pargs = NULL;
  int i;
  if(nArgs > 0){
    pargs = new VARIANTARG[nArgs];

    va_list ap;
    va_start(ap, nArgs);
    for(i=0;i<nArgs;i++){
      VariantInit(&pargs[i]);
      VARIANT v = va_arg(ap, VARIANT);
      VariantCopy(&pargs[i], &v);
    }
    va_end(ap);
  }

  DISPPARAMS dparams;
  dparams.rgvarg = pargs;
  dparams.rgdispidNamedArgs = NULL;
  dparams.cArgs = nArgs;
  dparams.cNamedArgs = 0;

  hr = disp_ptr->Invoke( dispId, IID_NULL, LOCALE_USER_DEFAULT,
                DISPATCH_METHOD, &dparams, ret, NULL, NULL);

  for(i=0;i<nArgs;i++){
    VariantClear(&pargs[i]);
  }
  if(pargs != NULL){
    delete[] pargs;
    pargs = NULL;
  }
  return hr;
}

