//
// Copyright (C) 1999-2008 WideStudio/MWT Project Team
// Copyright (C) 2006,2007 FUJITSU LIMITED
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#include <WScom.h>
#include <devfb/devfb.h>
#include <devfb/devfb_dep.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <fbconfig.h>
#include <WSkeysym.h>
#ifdef LINUX
#include <sys/time.h>
#include <linux/kd.h>
#include <sys/ioctl.h>
#include <termios.h>
#endif

extern int _add_event(WSDdeviceEventList* evt);
extern int _device_check_event_available();
extern int _search_window(short x,short y);

#include <linux/fb.h>
#include <sys/mman.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <pthread.h>

#define USE_SAME_BUF

int _fb_fd = 0;
struct fb_var_screeninfo var_info;
struct fb_fix_screeninfo fix_info;
int _device_buffer_size = 0;
char* _fb_addr = 0;
extern int tp_offset_x;
extern int tp_offset_y;
extern int tp_adjust_w;
extern int tp_adjust_h;

#define KEYB_EVENT 0
#define KEYB_TTY   1
int _keyb_protocol = KEYB_EVENT;

#define MOUSE_EVENT   0
#define MOUSE_MOUSE   1
#define MOUSE_TMM1000 2
#define MOUSE_TS_EVENT 3
int _mouse_protocol = MOUSE_EVENT;

#define KEYB_101  0
#define KEYB_JP   1
int _keyb_map = KEYB_101;

#define CMAP_ENTRIES 256
fb_cmap cmap;

#ifndef NO_THREAD
extern int _init_for_event_function();
extern int _wake_up_event();
extern int _wait_event();
//pthread_sem_t _event_sem;
#endif
unsigned int _mouse_status = 0;
unsigned int _keyb_status = 0;

int _touch_pannel_x = 0;
int _touch_pannel_y = 0;
void _get_mouse_pos(short* x,short* y){
  *x = _touch_pannel_x;
  *y = _touch_pannel_y;
}
void _set_mouse_pos(short x,short y){
  if (x <0){
    x = 0;
  }
  if (x >= _device_width){
    x = _device_width -1;
  }
  if (y <0){
    y = 0;
  }
  if (y >= _device_height){
    y = _device_height -1;
  }
  if (_touch_pannel_x != x || _touch_pannel_y != y){
    _touch_pannel_x = x;
    _touch_pannel_y = y;
#ifndef ZAURUS
extern void post_mouse_move(long,long);
    post_mouse_move(x,y);
#endif
  }
}
#ifndef NO_VIRTUAL_EVENT_SEND
int post_mouse_press_evt(short x,short y,long btn){ //btn = ES_BUT or ES_BUT2
  int mouse_status = _mouse_status;
  if (btn & WS_MOUSE_BTN1){
    mouse_status |= ES_BUT;
  }else
  if (btn & WS_MOUSE_BTN3){
    mouse_status |= ES_BUT2;
  }else{
    return WS_ERR;
  }
  int px = x;
  int py = y;
  int ev_type = 0;

  if (mouse_status != _mouse_status){
    ev_type = EV_BUTDWN;
    _mouse_status = mouse_status;
    WSDdeviceEventList* evtl = (WSDdeviceEventList*)wsmalloc(sizeof(WSDdeviceEventList));
    WSDdeviceEvent* evt = &(evtl->_event);
    int wid = _search_window(px,py);
    if (wid != 0){
      evt->s.type = ev_type;
      evt->s.cmd = W_WORK;
      evt->s.wid = wid;
      short wx = _window_list[wid -1]._x;
      short wy = _window_list[wid -1]._y;
      evt->s.wid = wid;
      evt->e.pos.x = px -wx;
      evt->e.pos.y = py -wy;
      evt->s.stat = _mouse_status;
      evt->s.time = WSGFclocktime();
      _touch_pannel_x = px;
      _touch_pannel_y = py;
      WSGFdeviceSemLock(_event_sem_id);
      _add_event(evtl);
      WSGFdeviceSemUnlock(_event_sem_id);
#ifndef NO_THREAD
      _wake_up_event();
//            pthread_sem_unlock_np(&_event_sem);
#endif
    }else{
      wsfree(evtl);
    }
  }
  return WS_NO_ERR;
}
int post_mouse_release_evt(short x,short y,long btn){ //btn = ES_BUT or ES_BUT2
  int mouse_status = _mouse_status;
  if (btn & WS_MOUSE_BTN1){
    mouse_status &= ~ES_BUT;
  }else
  if (btn & WS_MOUSE_BTN3){
    mouse_status &= ~ES_BUT2;
  }

  int px = _touch_pannel_x;
  int py = _touch_pannel_y;
  int ev_type = 0;

  if (mouse_status != _mouse_status){
    ev_type = EV_BUTUP;
    _mouse_status = mouse_status;
    WSDdeviceEventList* evtl = (WSDdeviceEventList*)wsmalloc(sizeof(WSDdeviceEventList));
    WSDdeviceEvent* evt = &(evtl->_event);
    int wid = _search_window(px,py);
    if (wid != 0){
      evt->s.type = ev_type;
      evt->s.cmd = W_WORK;
      evt->s.wid = wid;
      short wx = _window_list[wid -1]._x;
      short wy = _window_list[wid -1]._y;
      evt->s.wid = wid;
      evt->e.pos.x = px -wx;
      evt->e.pos.y = py -wy;
      evt->s.stat = _mouse_status;
      evt->s.time = WSGFclocktime();
      _touch_pannel_x = px;
      _touch_pannel_y = py;
      WSGFdeviceSemLock(_event_sem_id);
      _add_event(evtl);
      WSGFdeviceSemUnlock(_event_sem_id);
#ifndef NO_THREAD
      _wake_up_event();
//            pthread_sem_unlock_np(&_event_sem);
#endif
    }else{
      wsfree(evtl);
    }
  }
  return WS_NO_ERR;
}
#endif


#ifndef ZAURUS
#include <linux/input.h>
#include <errno.h>
pthread_t     _input_mouse_thr=0;
pthread_t     _input_key_thr=0;
int _mouse_dev =0;
int _keyb_dev =0;

void _draw_mouse_cursor(){
#ifdef NO_DRAW_FB_MOUSE_CURSOR
return;
#else
static  int _cursor_x = -1;
static  int _cursor_y = -1;
static  unsigned int val_back = 0;
static  unsigned int val_back2 = 0;

static  unsigned short val_back_ex[200];

  int dx = _cursor_x;
  int dy = _cursor_y;
  int x = _touch_pannel_x;
  int y = _touch_pannel_y;
  _cursor_x = x;
  _cursor_y = y;
#ifdef ROTATE90
  {
     int tmp = dx;
     dx = dy;
     dy = _device_height - tmp -1;
     tmp = x;
     x = y;
     y = _device_height - tmp -1;
  }
#endif

#ifdef ROTATE270
  {
     int tmp = dx;
     dx = _device_width -dy -1;
     dy = tmp;
     tmp = x;
     x = _device_height -y -1;
     y = tmp;
  }
#endif

#ifdef DOUBLE_SCALE
   dx *=2;
   dy *=2;
   x *=2;
   y *=2;
#endif
  if (x < 0 || y < 0){
    return;
  }
  unsigned int depth =   _device_depth;
  unsigned int row_bytes = _device_row_bytes;
  if (depth == 32){
    if (dx > -1 && dy > -1){
      unsigned int* ptr = (unsigned int*)&_buffer[dy*row_bytes + dx*depth/8];
      *ptr++ = val_back;
      *ptr = val_back2;
    }
    unsigned int* ptr2 = (unsigned int*)&_buffer[y*row_bytes + x*depth/8];
    val_back = *ptr2;
    *ptr2 = 0xffffffff;
    ptr2++;
    val_back2 = *ptr2;
    *ptr2 = 0x00000000;
  }else
  if (depth == 16){
#if 0
    if (dx > -1 && dy > -1){
      unsigned short* ptr = (unsigned short*)&_buffer[dy*row_bytes + dx*depth/8];
      *ptr++ = val_back;
      *ptr = val_back2;
    }
    unsigned short* ptr2 = (unsigned short*)&_buffer[y*row_bytes + x*depth/8];
    val_back = *ptr2;
    *ptr2 = 0xffff;
    ptr2++;
    val_back2 = *ptr2;
    *ptr2 = 0x0000;
#endif
    if (dx > -1 && dy > -1){
      int cnt = 0;
      int i;
      for(i=0; i<=20; i++){
        if ((dy + i -10) > 0 && dx > 0 && (dy + i -10) < _device_height && dx < _device_width){
          unsigned short* ptr = (unsigned short*)&_buffer[(dy + i -10)*row_bytes + dx*depth/8];
          if(*ptr == 0xfffe){
            *ptr = val_back_ex[cnt];
          }
          cnt++;
        }
        if ((dy + i -10) > 0 && dx+1 > 0 && (dy + i -10) < _device_height && dx+1 < _device_width){
          unsigned short* ptr = (unsigned short*)&_buffer[(dy + i -10)*row_bytes + (dx+1)*depth/8];
          if(*ptr == 0x0001){
            *ptr = val_back_ex[cnt];
          }
          cnt++;
        }
        if (dy-1  > 0 && (dx +i -10) > 0 && dy-1  < _device_height && (dx +i -10) < _device_width){
          unsigned short* ptr = (unsigned short*)&_buffer[(dy-1)*row_bytes + (dx + i -10)*depth/8];
          if( (i < 10) || (11 < i) ){
            if(*ptr == 0xfffe){
              *ptr = val_back_ex[cnt];
            }
            cnt++;
          }
        }
        if (dy  > 0 && (dx +i -10) > 0 && dy  < _device_height && (dx +i -10) < _device_width){
          unsigned short* ptr = (unsigned short*)&_buffer[dy*row_bytes + (dx + i -10)*depth/8];
          if( (i < 10) || (11 < i) ){
            if(*ptr == 0x0001){
              *ptr = val_back_ex[cnt];
            }
            cnt++;
          }
        }
      }
    }
    int cnt = 0;
    int i;
    for(i=0; i<=20; i++){
      if ((y + i -10) > 0 && x > 0 && (y + i -10) < _device_height && x < _device_width){
        unsigned short* ptr2 = (unsigned short*)&_buffer[(y + i -10)*row_bytes + x*depth/8];
        val_back_ex[cnt++] = *ptr2;
        *ptr2 = 0xfffe;
      }
      if ((y + i -10) > 0 && x+1 > 0 && (y + i -10) < _device_height && x+1 < _device_width){
        unsigned short* ptr2 = (unsigned short*)&_buffer[(y + i -10)*row_bytes + (x+1)*depth/8];
        val_back_ex[cnt++] = *ptr2;
        *ptr2 = 0x0001;
      }
      if (y-1  > 0 && (x +i -10) > 0 && y-1  < _device_height && (x +i -10) < _device_width){
        unsigned short* ptr2 = (unsigned short*)&_buffer[(y-1)*row_bytes + (x + i -10)*depth/8];
        if( (i < 10) || (11 < i) ){
          val_back_ex[cnt++] = *ptr2;
          *ptr2 = 0xfffe;
        }
      }
      if (y  > 0 && (x +i -10) > 0 && y  < _device_height && (x +i -10) < _device_width){
        unsigned short* ptr2 = (unsigned short*)&_buffer[y*row_bytes + (x + i -10)*depth/8];
        if( (i < 10) || (11 < i) ){
          val_back_ex[cnt++] = *ptr2;
          *ptr2 = 0x0001;
        }
      }
    }

  }else
  if (depth == 8){
    if (dx > -1 && dy > -1){
      unsigned char* ptr = (unsigned char*)&_buffer[dy*row_bytes + dx*depth/8];
      *ptr++ = val_back;
      *ptr = val_back2;
    }
    unsigned char* ptr2 = (unsigned char*)&_buffer[y*row_bytes + x*depth/8];
    val_back = *ptr2;
    *ptr2 = 0xff;
    ptr2++;
    val_back2 = *ptr2;
    *ptr2 = 0x00;
  }
#endif
}
void _post_mouse_evt(long px,long py,long ev){
  WSDdeviceEventList* evtl = (WSDdeviceEventList*)wsmalloc(sizeof(WSDdeviceEventList));
  WSDdeviceEvent* evt = &(evtl->_event);
  int wid = _search_window(px,py);
  _touch_pannel_x = px;
  _touch_pannel_y = py;
  _draw_mouse_cursor();
  if (wid != 0){
    evt->s.type = ev;
    evt->s.cmd = W_WORK;
    evt->s.wid = wid;
    short wx = _window_list[wid -1]._x;
    short wy = _window_list[wid -1]._y;
    evt->s.wid = wid;
    evt->e.pos.x = px -wx;
    evt->e.pos.y = py -wy;
    evt->s.stat = _mouse_status;
    evt->s.time = WSGFclocktime();

    WSGFdeviceSemLock(_event_sem_id);
    _add_event(evtl);
    WSGFdeviceSemUnlock(_event_sem_id);
#ifndef NO_THREAD
    _wake_up_event();
//          pthread_sem_unlock_np(&_event_sem);
#endif
  }else{
    _touch_pannel_x = px;
    _touch_pannel_y = py;
    _draw_mouse_cursor();
    wsfree(evtl);
  }
}
void post_mouse_move(long px,long py){
  _post_mouse_evt(px,py,EV_NULL);
}
#ifdef FR461
void post_mouse_press(long px,long py){
  _mouse_status = ES_BUT;
  _post_mouse_evt(px,py,EV_BUTDWN);
}
void post_mouse_release(long px,long py){
  _mouse_status = 0;
  _post_mouse_evt(px,py,EV_BUTUP);
}
#endif

typedef struct {
    short pressure;
    short x;
    short y;
    short millisecs;
} ts_event;

#ifndef NO_THREAD
void* _mouse_input_thread(void*){
  int readlen;
  struct input_event event;
//printf("_input_thread started.. _mouse_dev=0x%x pt=%d\n",_mouse_dev,_mouse_protocol);
  while(1){
    if (_mouse_protocol == MOUSE_EVENT){
      if (tp_adjust_w == 0 || tp_adjust_h == 0){
        WSGFdeviceSleep(100);
        continue;
      }

      readlen = read(_mouse_dev,&event,sizeof(struct input_event));
      if (readlen != sizeof(struct input_event)){
        continue;
      }
      int px = _touch_pannel_x;
      int py = _touch_pannel_y;
      if (event.type == EV_REL){
        if (event.code == REL_X){
          px += event.value;
          if (px < 0){
            px =0;
          }else if (!(px < _device_width)){
            px = _device_width -1;
          }
        }else
        if (event.code == REL_Y){
          py += event.value;
          if (py < 0){
            py =0;
          }else if (!(py < _device_height)){
            py = _device_height -1;
          }
        }
        if (px != _touch_pannel_x || py != _touch_pannel_y){
          post_mouse_move(px,py);
          continue;
        }
      }else
      if (event.type == EV_ABS){
        if (event.code == ABS_X){
//#ifdef FR461
          event.value = (event.value -tp_offset_x)*_device_width/tp_adjust_w;
//#endif
          px = event.value;
          if (px < 0){
            px =0;
          }else if (!(px < _device_width)){
            px = _device_width -1;
          }
        }else
        if (event.code == ABS_Y){
//#ifdef FR461
          event.value = (event.value -tp_offset_y)*_device_height/tp_adjust_h;
//#endif
          py = event.value;
          if (py < 0){
            py =0;
          }else if (!(py < _device_height)){
            py = _device_height -1;
          }
#ifdef FR461
          if (px != _touch_pannel_x || py != _touch_pannel_y){
            post_mouse_press(px,py);
            post_mouse_release(px,py);
            continue;
          }
#endif
        }
        if (px != _touch_pannel_x || py != _touch_pannel_y){
          post_mouse_move(px,py);
          continue;
        }
      }

      if (event.type == EV_KEY){
        if (event.code == BTN_TOUCH){
          event.code = BTN_LEFT;
        }
        if (event.code == BTN_LEFT ||
            event.code == BTN_MIDDLE ||
            event.code == BTN_RIGHT){
          int mouse_status = _mouse_status;
          if (event.value == 1){
            switch(event.code){
              case BTN_LEFT:
                mouse_status |= ES_BUT;
                break;
              case BTN_RIGHT:
                mouse_status |= ES_BUT2;
                break;
            }
          }else{
            switch(event.code){
              case BTN_LEFT:
                mouse_status &= ~ES_BUT;
                break;
              case BTN_RIGHT:
                mouse_status &= ~ES_BUT2;
                break;
            }
          }
          if (mouse_status != _mouse_status){
            _mouse_status = mouse_status;
            WSDdeviceEventList* evtl = (WSDdeviceEventList*)wsmalloc(sizeof(WSDdeviceEventList));
            WSDdeviceEvent* evt = &(evtl->_event);
            int wid = _search_window(px,py);
            if (wid != 0){
              if (event.value == 1){
                evt->s.type = EV_BUTDWN;
              }else{
                evt->s.type = EV_BUTUP;
              }
              evt->s.cmd = W_WORK;
              evt->s.wid = wid;
              short wx = _window_list[wid -1]._x;
              short wy = _window_list[wid -1]._y;
              evt->s.wid = wid;
              evt->e.pos.x = px -wx;
              evt->e.pos.y = py -wy;
              evt->s.stat = _mouse_status;
              evt->s.time = WSGFclocktime();
              _touch_pannel_x = px;
              _touch_pannel_y = py;
              _draw_mouse_cursor();
              WSGFdeviceSemLock(_event_sem_id);
              _add_event(evtl);
              WSGFdeviceSemUnlock(_event_sem_id);
#ifndef NO_THREAD
              _wake_up_event();
//            pthread_sem_unlock_np(&_event_sem);
#endif
            }else{
              wsfree(evtl);
            }
            continue;
          }
        }
      }
    }else
    if (_mouse_protocol == MOUSE_MOUSE){
      char evbuf[32];
      readlen = read(_mouse_dev,evbuf,sizeof(evbuf));
      if (readlen < 1){
        continue;
      }
      int px = _touch_pannel_x;
      int py = _touch_pannel_y;
      int mouse_status = _mouse_status;
      int status_changed = False;
      int ev_type = 0;
      if (evbuf[0] & 0x01){
        mouse_status |= ES_BUT;
        if (mouse_status != _mouse_status){
          ev_type = EV_BUTDWN;
          status_changed = True;
        }
      }else{
        mouse_status &= ~ES_BUT;
        if (mouse_status != _mouse_status){
          ev_type = EV_BUTUP;
          status_changed = True;
        }
      }
      _mouse_status = mouse_status;
      if (evbuf[0] & 0x02){
        mouse_status |= ES_BUT2;
        if (mouse_status != _mouse_status){
          ev_type = EV_BUTDWN;
          status_changed = True;
        }
      }else{
        mouse_status &= ~ES_BUT2;
        if (mouse_status != _mouse_status){
          ev_type = EV_BUTUP;
          status_changed = True;
        }
      }

      if (status_changed != False){
        _mouse_status = mouse_status;
        WSDdeviceEventList* evtl = (WSDdeviceEventList*)wsmalloc(sizeof(WSDdeviceEventList));
        WSDdeviceEvent* evt = &(evtl->_event);
        int wid = _search_window(px,py);
        if (wid != 0){
          evt->s.type = ev_type;
          evt->s.cmd = W_WORK;
          evt->s.wid = wid;
          short wx = _window_list[wid -1]._x;
          short wy = _window_list[wid -1]._y;
          evt->s.wid = wid;
          evt->e.pos.x = px -wx;
          evt->e.pos.y = py -wy;
          evt->s.stat = _mouse_status;
          evt->s.time = WSGFclocktime();
          _touch_pannel_x = px;
          _touch_pannel_y = py;
          _draw_mouse_cursor();
          WSGFdeviceSemLock(_event_sem_id);
          _add_event(evtl);
          WSGFdeviceSemUnlock(_event_sem_id);
#ifndef NO_THREAD
          _wake_up_event();
//            pthread_sem_unlock_np(&_event_sem);
#endif
        }else{
          wsfree(evtl);
        }
      }
      if (evbuf[1] != 0){
        signed char diff = (signed char)evbuf[1];
        px += (int)diff;
        if (px < 0){
          px =0;
        }else if (!(px < _device_width)){
          px = _device_width -1;
        }
      }
      if (evbuf[2] != 0){
        signed char diff = (signed char)evbuf[2];
        py -= (int)diff;
        if (py < 0){
          py =0;
        }else if (!(py < _device_height)){
          py = _device_height -1;
        }
      }
      if (px != _touch_pannel_x || py != _touch_pannel_y){
        post_mouse_move(px,py);
        continue;
      }
    }else
    if (_mouse_protocol == MOUSE_TMM1000){
      char c[12];
      char t;
      int ptr = 0;
      int pushed = False;
      while((readlen = read(_mouse_dev,&t,sizeof(char)*1)) > 0 || errno == EINTR){
        if ( t=='T' || t == 'R'){
          if ( t=='T'){
            pushed = True;
          }else{
            pushed = False;
          }
          ptr = 0;
        }
        if ( t==0xd){
          break;
        }
        c[ptr++] = t;
        if (ptr > 11){
          break;
        }
      }
      c[10] = 0;
      if (ptr != sizeof(char) *10){
        continue;
      }
      c[5] = 0;
      c[10] = 0;
      int pxv = (c[1]-'0') * 1000 +
                (c[2]-'0') *  100 +
                (c[3]-'0') *   10 +
                (c[4]-'0') *    1;
      int pyv = (c[6]-'0') * 1000 +
                (c[7]-'0') *  100 +
                (c[8]-'0') *   10 +
                (c[9]-'0') *    1;
      if (c[0]== 'T'){
        pushed = True;
      }else{
        pushed = False;
      }
      int px = (pxv -tp_offset_x)*_device_width/tp_adjust_w;
      if (px < 0){
        px =0;
      }else if (!(px < _device_width)){
        px = _device_width -1;
      }
      int py = (pyv -tp_offset_y)*_device_height/tp_adjust_h;
      if (py < 0){
        py =0;
      }else if (!(py < _device_height)){
        py = _device_height -1;
      }
      if (pushed == False && _mouse_status != 0){
        _mouse_status = 0;
        _post_mouse_evt(px,py,EV_BUTUP);
        continue;
      }
      if (pushed != False && _mouse_status == 0){
        _mouse_status = ES_BUT;
        _post_mouse_evt(px,py,EV_BUTDWN);
        continue;
      }
      if (px != _touch_pannel_x || py != _touch_pannel_y){
        post_mouse_move(px,py);
        continue;
      }
    }else
    if (_mouse_protocol == MOUSE_TS_EVENT){
      ts_event event;
static int _touched = 0;
      readlen = read(_mouse_dev,&event,sizeof(ts_event));
      if (readlen != sizeof(ts_event)){
        continue;
      }
//      int px = event.x;
//      int py = event.y;
      int px = (event.x -tp_offset_x)*_device_width/tp_adjust_w;
      if (px < 0){
        px =0;
      }else if (!(px < _device_width)){
        px = _device_width -1;
      }
      int py = (event.y -tp_offset_y)*_device_height/tp_adjust_h;
      if (py < 0){
        py =0;
      }else if (!(py < _device_height)){
        py = _device_height -1;
      }
      if (_touched == 0 && event.pressure != 0){
        _touched = 1;
        _mouse_status = ES_BUT;
        _post_mouse_evt(px,py,EV_BUTDWN);
      }else
      if (_touched == 1 && event.pressure == 0){
        _touched = 0;
        _mouse_status = 0;
        _post_mouse_evt(px,py,EV_BUTUP);
      }else
      if (px != _touch_pannel_x || py != _touch_pannel_y){
        post_mouse_move(px,py);
        continue;
      }
    }
  }
}
#endif
struct key_map{
  int keycode;
  int keysym;
  int shift_keysym;
};

key_map key_map_101[] = {
{KEY_LEFTSHIFT,     WSK_Shift_L,     WSK_Shift_L    },
{KEY_RIGHTSHIFT,    WSK_Shift_R,     WSK_Shift_R    },
{KEY_CAPSLOCK,      WSK_Caps_Lock,   WSK_Caps_Lock  },
{KEY_LEFTCTRL,      WSK_Control_L,   WSK_Control_L  },
{KEY_RIGHTCTRL,     WSK_Control_R,   WSK_Control_R  },
{KEY_LEFTALT,       WSK_Alt_L,       WSK_Alt_L      },
{KEY_RIGHTALT,      WSK_Alt_R,       WSK_Alt_R      },
{KEY_ESC,           WSK_Escape,      WSK_Escape     },
{KEY_1,             WSK_1,           WSK_exclam     },
{KEY_2,             WSK_2,           WSK_at         },
{KEY_3,             WSK_3,           WSK_numbersign },
{KEY_4,             WSK_4,           WSK_dollar     },
{KEY_5,             WSK_5,           WSK_percent    },
{KEY_6,             WSK_6,           WSK_asciicircum},
{KEY_7,             WSK_7,           WSK_ampersand  },
{KEY_8,             WSK_8,           WSK_asterisk   },
{KEY_9,             WSK_9,           WSK_parenleft  },
{KEY_0,             WSK_0,           WSK_parenright },
{KEY_MINUS,         WSK_minus,       WSK_underscore },
{KEY_EQUAL,         WSK_equal,       WSK_plus       },
{KEY_KPCOMMA,       WSK_KP_Separator,WSK_KP_Separator},

{KEY_NUMLOCK,       WSK_Num_Lock,    WSK_Num_Lock   },
{KEY_SCROLLLOCK,    WSK_Scroll_Lock, WSK_Scroll_Lock},
{KEY_F1,            WSK_F1,          WSK_F1         },
{KEY_F2,            WSK_F2,          WSK_F2         },
{KEY_F3,            WSK_F3,          WSK_F3         },
{KEY_F4,            WSK_F4,          WSK_F4         },
{KEY_F5,            WSK_F5,          WSK_F5         },
{KEY_F6,            WSK_F6,          WSK_F6         },
{KEY_F7,            WSK_F7,          WSK_F7         },
{KEY_F8,            WSK_F8,          WSK_F8         },
{KEY_F9,            WSK_F9,          WSK_F9         },
{KEY_F10,           WSK_F10,         WSK_F10        },
{KEY_F11,           WSK_F11,         WSK_F11        },
{KEY_F12,           WSK_F12,         WSK_F12        },
{KEY_F13,           WSK_F13,         WSK_F13        },
{KEY_F14,           WSK_F14,         WSK_F14        },
{KEY_F15,           WSK_F15,         WSK_F15        },
{KEY_F16,           WSK_F16,         WSK_F16        },
{KEY_F17,           WSK_F17,         WSK_F17        },
{KEY_F18,           WSK_F18,         WSK_F18        },
{KEY_F19,           WSK_F19,         WSK_F19        },
{KEY_F20,           WSK_F20,         WSK_F20        },

{KEY_KP0,           WSK_KP_0,        WSK_KP_0       },
{KEY_KP1,           WSK_KP_1,        WSK_KP_1       },
{KEY_KP2,           WSK_KP_2,        WSK_KP_2       },
{KEY_KP3,           WSK_KP_3,        WSK_KP_3       },
{KEY_KP4,           WSK_KP_4,        WSK_KP_4       },
{KEY_KP5,           WSK_KP_5,        WSK_KP_5       },
{KEY_KP6,           WSK_KP_6,        WSK_KP_6       },
{KEY_KP7,           WSK_KP_7,        WSK_KP_7       },
{KEY_KP8,           WSK_KP_8,        WSK_KP_8       },
{KEY_KP9,           WSK_KP_9,        WSK_KP_9       },
{KEY_KPMINUS,       WSK_KP_Subtract, WSK_KP_Subtract},
{KEY_KPPLUS,        WSK_KP_Add,      WSK_KP_Add     },
{KEY_KPDOT,         WSK_KP_Decimal,  WSK_KP_Decimal },
{KEY_KPENTER,       WSK_KP_Enter,    WSK_KP_Enter   },
{KEY_KPSLASH,       WSK_KP_Divide,   WSK_KP_Divide  },
{KEY_KPASTERISK,    WSK_KP_Multiply, WSK_KP_Multiply},
{KEY_KPEQUAL,       WSK_KP_Equal,    WSK_KP_Equal   },
{KEY_KPPLUSMINUS,   WSK_plusminus,   WSK_plusminus  },
{KEY_LEFTBRACE,     WSK_bracketleft, WSK_braceleft  },
{KEY_RIGHTBRACE,    WSK_bracketright,WSK_braceright },
{KEY_BACKSLASH,     WSK_backslash,   WSK_bar        },
{KEY_SEMICOLON,     WSK_semicolon,   WSK_colon      },
{KEY_APOSTROPHE,    WSK_apostrophe,  WSK_quotedbl   },
{KEY_ENTER,         WSK_Return,      WSK_Return     },
{KEY_COMMA,         WSK_comma,       WSK_less       },
{KEY_DOT,           WSK_period,      WSK_greater    },
{KEY_SLASH,         WSK_slash,       WSK_question   },
{KEY_INSERT,        WSK_Insert,      WSK_Insert     },
{KEY_DELETE,        WSK_Delete,      WSK_Delete     },
{KEY_HOME,          WSK_Home,        WSK_Home       },
{KEY_END,           WSK_End,         WSK_End        },
{KEY_PAGEUP,        WSK_Page_Up,     WSK_Page_Up    },
{KEY_PAGEDOWN,      WSK_Page_Down,   WSK_Page_Down  },
{KEY_SYSRQ,         WSK_Sys_Req,     WSK_Sys_Req    },
{KEY_GRAVE,         WSK_grave,       WSK_asciitilde },
{KEY_PAUSE,         WSK_Pause,       WSK_Pause      },
{KEY_TAB,           WSK_Tab,         WSK_Tab        },
{KEY_SPACE,         WSK_space,       WSK_space      },
{KEY_LEFT,          WSK_Left,        WSK_Left       },
{KEY_RIGHT,         WSK_Right,       WSK_Right      },
{KEY_UP,            WSK_Up,          WSK_Up         },
{KEY_DOWN,          WSK_Down,        WSK_Down       },
{KEY_LINEFEED,      WSK_Linefeed,    WSK_Linefeed   },
{KEY_BACKSPACE,     WSK_BackSpace,   WSK_BackSpace  },
#ifdef KEY_RO
{KEY_RO,            WSK_backslash,   WSK_underscore },
#endif

{KEY_A,             WSK_a,           WSK_A          },
{KEY_B,             WSK_b,           WSK_B          },
{KEY_C,             WSK_c,           WSK_C          },
{KEY_D,             WSK_d,           WSK_D          },
{KEY_E,             WSK_e,           WSK_E          },
{KEY_F,             WSK_f,           WSK_F          },
{KEY_G,             WSK_g,           WSK_G          },
{KEY_H,             WSK_h,           WSK_H          },
{KEY_I,             WSK_i,           WSK_I          },
{KEY_J,             WSK_j,           WSK_J          },
{KEY_K,             WSK_k,           WSK_K          },
{KEY_L,             WSK_l,           WSK_L          },
{KEY_M,             WSK_m,           WSK_M          },
{KEY_N,             WSK_n,           WSK_N          },
{KEY_O,             WSK_o,           WSK_O          },
{KEY_P,             WSK_p,           WSK_P          },
{KEY_Q,             WSK_q,           WSK_Q          },
{KEY_R,             WSK_r,           WSK_R          },
{KEY_S,             WSK_s,           WSK_S          },
{KEY_T,             WSK_t,           WSK_T          },
{KEY_U,             WSK_u,           WSK_U          },
{KEY_V,             WSK_v,           WSK_V          },
{KEY_W,             WSK_w,           WSK_W          },
{KEY_X,             WSK_x,           WSK_X          },
{KEY_Y,             WSK_y,           WSK_Y          },
{KEY_Z,             WSK_z,           WSK_Z          },
{-1,                -1,              -1             },
};



key_map key_map_jp[] = {
{KEY_LEFTSHIFT,     WSK_Shift_L,     WSK_Shift_L    },
{KEY_RIGHTSHIFT,    WSK_Shift_R,     WSK_Shift_R    },
{KEY_CAPSLOCK,      WSK_Caps_Lock,   WSK_Caps_Lock  },
{KEY_LEFTCTRL,      WSK_Control_L,   WSK_Control_L  },
{KEY_RIGHTCTRL,     WSK_Control_R,   WSK_Control_R  },
{KEY_LEFTALT,       WSK_Alt_L,       WSK_Alt_L      },
{KEY_RIGHTALT,      WSK_Alt_R,       WSK_Alt_R      },
{KEY_ESC,           WSK_Escape,      WSK_Escape     },
{KEY_1,             WSK_1,           WSK_exclam     },
{KEY_2,             WSK_2,           WSK_quotedbl   },
{KEY_3,             WSK_3,           WSK_numbersign },
{KEY_4,             WSK_4,           WSK_dollar     },
{KEY_5,             WSK_5,           WSK_percent    },
{KEY_6,             WSK_6,           WSK_ampersand  },
{KEY_7,             WSK_7,           WSK_apostrophe },
{KEY_8,             WSK_8,           WSK_parenleft  },
{KEY_9,             WSK_9,           WSK_parenright },
{KEY_0,             WSK_0,           WSK_asciitilde },
{KEY_MINUS,         WSK_minus,       WSK_equal      },
{KEY_EQUAL,         WSK_asciicircum, WSK_asciitilde },
#ifdef KEY_YEN
{KEY_YEN,           WSK_backslash,   WSK_bar        },
#endif
{KEY_NUMLOCK,       WSK_Num_Lock,    WSK_Num_Lock   },
{KEY_SCROLLLOCK,    WSK_Scroll_Lock, WSK_Scroll_Lock},
{KEY_F1,            WSK_F1,          WSK_F1         },
{KEY_F2,            WSK_F2,          WSK_F2         },
{KEY_F3,            WSK_F3,          WSK_F3         },
{KEY_F4,            WSK_F4,          WSK_F4         },
{KEY_F5,            WSK_F5,          WSK_F5         },
{KEY_F6,            WSK_F6,          WSK_F6         },
{KEY_F7,            WSK_F7,          WSK_F7         },
{KEY_F8,            WSK_F8,          WSK_F8         },
{KEY_F9,            WSK_F9,          WSK_F9         },
{KEY_F10,           WSK_F10,         WSK_F10        },
{KEY_F11,           WSK_F11,         WSK_F11        },
{KEY_F12,           WSK_F12,         WSK_F12        },
{KEY_F13,           WSK_F13,         WSK_F13        },
{KEY_F14,           WSK_F14,         WSK_F14        },
{KEY_F15,           WSK_F15,         WSK_F15        },
{KEY_F16,           WSK_F16,         WSK_F16        },
{KEY_F17,           WSK_F17,         WSK_F17        },
{KEY_F18,           WSK_F18,         WSK_F18        },
{KEY_F19,           WSK_F19,         WSK_F19        },
{KEY_F20,           WSK_F20,         WSK_F20        },

{KEY_KP0,           WSK_KP_0,        WSK_KP_0       },
{KEY_KP1,           WSK_KP_1,        WSK_KP_1       },
{KEY_KP2,           WSK_KP_2,        WSK_KP_2       },
{KEY_KP3,           WSK_KP_3,        WSK_KP_3       },
{KEY_KP4,           WSK_KP_4,        WSK_KP_4       },
{KEY_KP5,           WSK_KP_5,        WSK_KP_5       },
{KEY_KP6,           WSK_KP_6,        WSK_KP_6       },
{KEY_KP7,           WSK_KP_7,        WSK_KP_7       },
{KEY_KP8,           WSK_KP_8,        WSK_KP_8       },
{KEY_KP9,           WSK_KP_9,        WSK_KP_9       },
{KEY_KPMINUS,       WSK_KP_Subtract, WSK_KP_Subtract},
{KEY_KPPLUS,        WSK_KP_Add,      WSK_KP_Add     },
{KEY_KPDOT,         WSK_KP_Decimal,  WSK_KP_Decimal },
{KEY_KPENTER,       WSK_KP_Enter,    WSK_KP_Enter   },
{KEY_KPSLASH,       WSK_KP_Divide,   WSK_KP_Divide  },
{KEY_KPASTERISK,    WSK_KP_Multiply, WSK_KP_Multiply},
{KEY_KPEQUAL,       WSK_KP_Equal,    WSK_KP_Equal   },
{KEY_KPPLUSMINUS,   WSK_plusminus,   WSK_plusminus  },
{KEY_LEFTBRACE,     WSK_at,          WSK_grave      },
{KEY_RIGHTBRACE,    WSK_bracketleft, WSK_braceleft  },
{KEY_BACKSLASH,     WSK_bracketright,WSK_braceright },
{KEY_APOSTROPHE,    WSK_colon,       WSK_asterisk   },
{KEY_SEMICOLON,     WSK_semicolon,   WSK_plus      },
{KEY_ENTER,         WSK_Return,      WSK_Return     },

{KEY_COMMA,         WSK_comma,       WSK_less       },
{KEY_DOT,           WSK_period,      WSK_greater    },
{KEY_SLASH,         WSK_slash,       WSK_question   },
{KEY_INSERT,        WSK_Insert,      WSK_Insert     },
{KEY_DELETE,        WSK_Delete,      WSK_Delete     },
{KEY_HOME,          WSK_Home,        WSK_Home       },
{KEY_END,           WSK_End,         WSK_End        },
{KEY_PAGEUP,        WSK_Page_Up,     WSK_Page_Up    },
{KEY_PAGEDOWN,      WSK_Page_Down,   WSK_Page_Down  },
{KEY_SYSRQ,         WSK_Sys_Req,     WSK_Sys_Req    },
{KEY_GRAVE,         WSK_grave,       WSK_asciitilde },
{KEY_PAUSE,         WSK_Pause,       WSK_Pause      },
{KEY_TAB,           WSK_Tab,         WSK_Tab        },
{KEY_SPACE,         WSK_space,       WSK_space      },
{KEY_LEFT,          WSK_Left,        WSK_Left       },
{KEY_RIGHT,         WSK_Right,       WSK_Right      },
{KEY_UP,            WSK_Up,          WSK_Up         },
{KEY_DOWN,          WSK_Down,        WSK_Down       },
{KEY_LINEFEED,      WSK_Linefeed,    WSK_Linefeed   },
{KEY_BACKSPACE,     WSK_BackSpace,   WSK_BackSpace  },
#ifdef KEY_RO
{KEY_RO,            WSK_backslash,   WSK_underscore },
#endif

{KEY_A,             WSK_a,           WSK_A          },
{KEY_B,             WSK_b,           WSK_B          },
{KEY_C,             WSK_c,           WSK_C          },
{KEY_D,             WSK_d,           WSK_D          },
{KEY_E,             WSK_e,           WSK_E          },
{KEY_F,             WSK_f,           WSK_F          },
{KEY_G,             WSK_g,           WSK_G          },
{KEY_H,             WSK_h,           WSK_H          },
{KEY_I,             WSK_i,           WSK_I          },
{KEY_J,             WSK_j,           WSK_J          },
{KEY_K,             WSK_k,           WSK_K          },
{KEY_L,             WSK_l,           WSK_L          },
{KEY_M,             WSK_m,           WSK_M          },
{KEY_N,             WSK_n,           WSK_N          },
{KEY_O,             WSK_o,           WSK_O          },
{KEY_P,             WSK_p,           WSK_P          },
{KEY_Q,             WSK_q,           WSK_Q          },
{KEY_R,             WSK_r,           WSK_R          },
{KEY_S,             WSK_s,           WSK_S          },
{KEY_T,             WSK_t,           WSK_T          },
{KEY_U,             WSK_u,           WSK_U          },
{KEY_V,             WSK_v,           WSK_V          },
{KEY_W,             WSK_w,           WSK_W          },
{KEY_X,             WSK_x,           WSK_X          },
{KEY_Y,             WSK_y,           WSK_Y          },
{KEY_Z,             WSK_z,           WSK_Z          },
{-1,                -1,              -1             },
};

int convert_key(int keycode,WSCbool shift){
  key_map (*keymap)[] = (key_map (*)[])key_map_101;
  if (_keyb_map == KEYB_JP){
    keymap = (key_map (*)[])key_map_jp;
  }
  long cnt = 0;     
  while(1){
    if ((*keymap)[cnt].keycode == -1){
      break;
    }
//printf("dest=0x%x\n",(*keymap)[cnt].keycode);
    if ((*keymap)[cnt].keycode == keycode){
      if (shift == False){
        return (*keymap)[cnt].keysym;
      }
      return (*keymap)[cnt].shift_keysym;
    }
    cnt++;
  }
  return -1;
}
#ifndef NO_THREAD
void* _keyboard_input_thread(void*){
  int readlen;
  struct input_event event;
  while(1){
//printf("keyboard event readlen=0x%x %x ev=%d code=%x val=%x\n",readlen,sizeof(struct input_event),event.type,event.code,event.value);
//printf("mouse event readlen=0x%x %x\n",readlen,sizeof(struct input_event));
    if (_keyb_protocol == KEYB_EVENT){
      readlen = read(_keyb_dev,&event,sizeof(struct input_event));
      if (readlen != sizeof(struct input_event)){
        continue;
      }
    }else
    if (_keyb_protocol == KEYB_TTY){
      char buffer[32];
      char pre_key=0;
      readlen = read(_keyb_dev,buffer,sizeof(char));
      if (readlen < 1){
        continue;
      }
      event.type = EV_KEY;
      event.value = (buffer[0] & 0x80)? 0:1;
      event.code = (buffer[0] & 0x7f);
#ifdef KEY_YEN
      if (event.code == KEY_LEFTMETA){
        event.code = KEY_YEN;
      }
#endif
#ifdef KEY_RO
      if (event.code == KEY_VOLUMEUP){
        event.code = KEY_RO;
      }
#endif
      if (buffer[0] == pre_key){
        event.value = 2;
      }
      pre_key=buffer[0];
    }
    if (event.type == EV_KEY){
        int keyb_status = _keyb_status;
        if (event.value == 1){
          switch(event.code){
            case KEY_LEFTSHIFT:
            case KEY_RIGHTSHIFT:
              keyb_status |= 0x10;
              break;
            case KEY_CAPSLOCK:
              keyb_status |= 0x08;
              break;
            case KEY_LEFTCTRL:
            case KEY_RIGHTCTRL:
              keyb_status |= 0x80;
              break;
            case KEY_LEFTALT:
            case KEY_RIGHTALT:
              keyb_status |= 0x40;
              break;
          }
        }else
        if (event.value == 0){
          switch(event.code){
            case KEY_LEFTSHIFT:
            case KEY_RIGHTSHIFT:
              keyb_status &= ~0x10;
              break;
            case KEY_CAPSLOCK:
              keyb_status &= ~0x08;
              break;
            case KEY_LEFTCTRL:
            case KEY_RIGHTCTRL:
              keyb_status &= ~0x80;
              break;
            case KEY_LEFTALT:
            case KEY_RIGHTALT:
              keyb_status &= ~0x40;
              break;
          }
        }else{
          switch(event.code){
            case KEY_LEFTSHIFT:
            case KEY_RIGHTSHIFT:
            case KEY_CAPSLOCK:
            case KEY_LEFTCTRL:
            case KEY_RIGHTCTRL:
            case KEY_LEFTALT:
            case KEY_RIGHTALT:
              continue;
          }
        }
//        if (keyb_status != _keyb_status){
          _keyb_status = keyb_status;
//printf("type=%d value=0x%x code=0x%x _keyb_status=0x%x\n",event.type,event.value,event.code,_keyb_status);
          WSDdeviceEventList* evtl = (WSDdeviceEventList*)wsmalloc(sizeof(WSDdeviceEventList));
          WSDdeviceEvent* evt = &(evtl->_event);
//          int wid = _search_window(px,py);
//          if (wid != 0){
            if (event.value == 1){
              evt->s.type = EV_KEYDWN;
            }else
            if (event.value == 2){
              evt->s.type = EV_AUTKEY;
            }else{
              evt->s.type = EV_KEYUP;
            }
            evt->s.cmd = 0;
            evt->s.stat = _keyb_status;
            evt->s.time = WSGFclocktime();
            evt->s.wid = convert_key(event.code,(keyb_status & 0x10) ? True : False);

//printf("evt->.s.wid=%d\n",evt->s.wid);
            WSGFdeviceSemLock(_event_sem_id);
            _add_event(evtl);
            WSGFdeviceSemUnlock(_event_sem_id);
#ifndef NO_THREAD
            _wake_up_event();
//            pthread_sem_unlock_np(&_event_sem);
#endif
//          }else{
//            wsfree(evtl);
//          }
          continue;
//        }
    }
  }
}
#endif

#if (defined NO_THREAD) && !(defined MB93093)
void _mouse_input_proc(){
  int readlen;
  struct input_event event;
//printf("_zaurus_input_thread started..\n");
  while(1){
    int readlen;
    char buffer[16];
//printf("_mouse_input_proc started..\n");fflush(stdout);
    fd_set read_fds;
    FD_ZERO(&read_fds);
    int width=_mouse_dev+1;
    FD_SET(_mouse_dev,&read_fds);
    struct timeval tm;
    tm.tv_sec = 0;
    tm.tv_usec = 0;
    int ret = select(width,&read_fds,NULL,NULL,&tm);
    if (ret > 0){

      while((readlen = read(_mouse_dev,&event,sizeof(struct input_event))) > 0 || errno == EINTR){
        if (readlen != sizeof(struct input_event)){
          continue;
        }
        int px = _touch_pannel_x;
        int py = _touch_pannel_y;

        if (event.type == EV_REL){
          if (event.code == REL_X){
            px += event.value;
            if (px < 0){
              px =0;
            }else if (!(px < _device_width)){
              px = _device_width -1;
            }
          }else
          if (event.code == REL_Y){
            py += event.value;
            if (py < 0){
              py =0;
            }else if (!(py < _device_height)){
              py = _device_height -1;
            }
          }
          if (px != _touch_pannel_x || py != _touch_pannel_y){
            WSDdeviceEventList* evtl = (WSDdeviceEventList*)wsmalloc(sizeof(WSDdeviceEventList));
            WSDdeviceEvent* evt = &(evtl->_event);
            int wid = _search_window(px,py);
            if (wid != 0){
              evt->s.type = EV_NULL;
              evt->s.cmd = W_WORK;
              evt->s.wid = wid;
              short wx = _window_list[wid -1]._x;
              short wy = _window_list[wid -1]._y;
              evt->s.wid = wid;
              evt->e.pos.x = px -wx;
              evt->e.pos.y = py -wy;
              evt->s.stat = _mouse_status;
              evt->s.time = WSGFclocktime();
              _touch_pannel_x = px;
              _touch_pannel_y = py;
              _draw_mouse_cursor();
              _add_event(evtl);
            }else{
              wsfree(evtl);
            }
            continue;
          }
        }

        if (event.type == EV_KEY){
          if (event.code == BTN_LEFT ||
              event.code == BTN_MIDDLE ||
              event.code == BTN_RIGHT){
            int mouse_status = _mouse_status;
            if (event.value == 1){
              switch(event.code){
                case BTN_LEFT:
                  mouse_status |= ES_BUT;
                  break;
                case BTN_RIGHT:
                  mouse_status |= ES_BUT2;
                  break;
              }
            }else{
              switch(event.code){
                case BTN_LEFT:
                  mouse_status &= ~ES_BUT;
                  break;
                case BTN_RIGHT:
                  mouse_status &= ~ES_BUT2;
                  break;
              }
            }
            if (mouse_status != _mouse_status){
              _mouse_status = mouse_status;
              WSDdeviceEventList* evtl = (WSDdeviceEventList*)wsmalloc(sizeof(WSDdeviceEventList));
              WSDdeviceEvent* evt = &(evtl->_event);
              int wid = _search_window(px,py);
              if (wid != 0){
                if (event.value == 1){
                  evt->s.type = EV_BUTDWN;
                }else{
                  evt->s.type = EV_BUTUP;
                }
                evt->s.cmd = W_WORK;
                evt->s.wid = wid;
                short wx = _window_list[wid -1]._x;
                short wy = _window_list[wid -1]._y;
                evt->s.wid = wid;
                evt->e.pos.x = px -wx;
                evt->e.pos.y = py -wy;
                evt->s.stat = _mouse_status;
                evt->s.time = WSGFclocktime();
                _touch_pannel_x = px;
                _touch_pannel_y = py;
                _draw_mouse_cursor();
                _add_event(evtl);
              }else{
                wsfree(evtl);
              }
              continue;
            }
          }
        }
      }
    }else{
      return;
    }
  }
}
#endif

#ifdef MB93093
int _touch_pannel_pressed = 0;
int _mouse_input_proc(){
  while(1){
  int readlen;
  char buffer[16];
//printf("_mouse_input_proc started..\n");fflush(stdout);
  fd_set read_fds;
  FD_ZERO(&read_fds);
  int width=_mouse_dev+1;
  FD_SET(_mouse_dev,&read_fds);
  struct timeval tm;
  tm.tv_sec = 0;
  tm.tv_usec = 0;
  int ret = select(width,&read_fds,NULL,NULL,&tm);
  if (ret > 0){
    int i;
    for(i=0; i<11; i++){
      char tmp;
      int r = read(_mouse_dev,&tmp,1);
      if (tmp == 0x0d){
        buffer[i] = 0;
        break;
      }
      buffer[i] = tmp;
//printf("0x%x ",tmp);
    }
//printf("\n");
    buffer[11] = 0;
    if (strlen(buffer) != 10){
      return 0;
    }
    int pressed = False;
//printf("buffer[0]=0x%x\n",buffer[0]);
    if (buffer[0] == 0x54){
      pressed = True;
    }else if (buffer[0]== 0x52){
      pressed = False;
    }else{
      return 0;
    }
    int dx=0,dy=0;
    sscanf(&buffer[1],"%d,%d",&dx,&dy);
//printf("press=%d %d,%d\n",pressed,dx,dy);
#define OFFSET_X  40
#define OFFSET_Y  80
#define X_WIDTH  940
#define Y_WIDTH  890
    int px = (X_WIDTH - (dx - OFFSET_X))*_device_width/X_WIDTH;
    int py = (dy - OFFSET_Y)*_device_height/Y_WIDTH;
#ifdef DOUBLE_SCALE
    px /=2;
    py /=2;
#endif
    if (px < 0){
      px = 0;
    }
    if (px > _device_width -1){
      px = _device_width -1;
    }
    if (py < 0){
      py = 0;
    }
    if (py > _device_height -1){
      py = _device_height -1;
    }
#ifdef ROTATE90
    {
       int tmp = px;
       px = _device_height - py -1;
       py = tmp;
    }
#endif

#ifdef ROTATE270
    {
       int tmp = px;
       px = py;
       py = _device_width -tmp -1;
    }
#endif


//printf("pressed=%d _t_pressed=%d\n",pressed,_touch_pannel_pressed);
    if (pressed != 0 && _touch_pannel_pressed == 0){
//printf("px,py=%d,%d pressed\n",px,py);
      WSDdeviceEventList* evtl = (WSDdeviceEventList*)wsmalloc(sizeof(WSDdeviceEventList));
      WSDdeviceEvent* evt = &(evtl->_event);
      int wid = _search_window(px,py);
      if (wid != 0){
        evt->s.type = EV_BUTDWN;
        evt->s.cmd = W_WORK;
        evt->s.wid = wid;
        short wx = _window_list[wid -1]._x;
        short wy = _window_list[wid -1]._y;
        evt->s.wid = wid;
        evt->e.pos.x = px -wx;
        evt->e.pos.y = py -wy;
        evt->s.stat = ES_BUT;
        evt->s.time = WSGFclocktime();

        _touch_pannel_x = px;
        _touch_pannel_y = py;
        _touch_pannel_pressed = 1;
        _draw_mouse_cursor();
//        WSGFdeviceSemLock(_event_sem_id);
        _add_event(evtl);
//        WSGFdeviceSemUnlock(_event_sem_id);
      }
//      return 0;
      continue;
    }
    if (pressed != 0 ){
      if ( _touch_pannel_x -2 < px && px < _touch_pannel_x +2){
        continue;
//        return 0;
      }
      if ( _touch_pannel_y -2 < py && py < _touch_pannel_y +2){
        continue;
//        return 0;
      }
    }


      WSDdeviceEventList* evtl = (WSDdeviceEventList*)wsmalloc(sizeof(WSDdeviceEventList));
      WSDdeviceEvent* evt = &(evtl->_event);
      int wid = _search_window(px,py);
      if (wid != 0){
        if (pressed == 0 && _touch_pannel_pressed != 0){
//printf("px,py=%d,%d released\n",px,py);
          evt->s.type = EV_BUTUP;
          _touch_pannel_pressed = 0;
        }else{
//printf("px,py=%d,%d moved\n",px,py);
          evt->s.type = EV_NULL;
        }
        evt->s.cmd = W_WORK;
        evt->s.wid = wid;
        short wx = _window_list[wid -1]._x;
        short wy = _window_list[wid -1]._y;
        evt->s.wid = wid;
        evt->e.pos.x = px -wx;
        evt->e.pos.y = py -wy;
        evt->s.stat = ES_BUT;
        if (_touch_pannel_pressed == 0){
          evt->s.stat = 0;
        }
        evt->s.time = WSGFclocktime();
        _touch_pannel_x = px;
        _touch_pannel_y = py;
        _draw_mouse_cursor();
//        WSGFdeviceSemLock(_event_sem_id);
        _add_event(evtl);
//        WSGFdeviceSemUnlock(_event_sem_id);
      }
//      return 0;


  }else{
    return 0;
  }
  }
  return 0;
}
#endif

int init_mouse_input_dev(){
  char* moused = DEFAULT_LINUX_MOUSE_DEVICE;
  if (getenv("DEFAULT_LINUX_MOUSE_DEVICE") != NULL){
    moused = getenv("DEFAULT_LINUX_MOUSE_DEVICE");
  }
  _mouse_protocol = MOUSE_EVENT;
  if (!strcmp(DEFAULT_LINUX_MOUSE_PROTOCOL,"EVENT")){
    _mouse_protocol = MOUSE_EVENT;
  }else
  if (!strcmp(DEFAULT_LINUX_MOUSE_PROTOCOL,"MOUSE")){
    _mouse_protocol = MOUSE_MOUSE;
  }else
  if (!strcmp(DEFAULT_LINUX_MOUSE_PROTOCOL,"TMM1000")){
    _mouse_protocol = MOUSE_TMM1000;
  }else
  if (!strcmp(DEFAULT_LINUX_MOUSE_PROTOCOL,"TS_EVENT")){
    _mouse_protocol = MOUSE_TS_EVENT;
  }
  char* mouse_protocol_env = getenv("DEFAULT_LINUX_MOUSE_PROTOCOL");
  if (mouse_protocol_env != NULL){
    if (!strcmp(mouse_protocol_env,"EVENT")){
      _mouse_protocol = MOUSE_EVENT;
    }else
    if (!strcmp(mouse_protocol_env,"MOUSE")){
      _mouse_protocol = MOUSE_MOUSE;
    }else
    if (!strcmp(mouse_protocol_env,"TMM1000")){
      _mouse_protocol = MOUSE_TMM1000;
    }else
    if (!strcmp(mouse_protocol_env,"TS_EVENT")){
      _mouse_protocol = MOUSE_TS_EVENT;
    }
  }
  if (_mouse_protocol == MOUSE_EVENT ||
      _mouse_protocol == MOUSE_MOUSE ||
      _mouse_protocol == MOUSE_TS_EVENT ){
    _mouse_dev = open(moused,O_RDONLY | O_NOCTTY);
  }else
  if (_mouse_protocol == MOUSE_TMM1000){
    _mouse_dev = open(moused,O_RDWR | O_NOCTTY,0777);
    if (_mouse_dev > -1){
      struct  termios rs_arg;
      int baud = B9600;
      char* mouse_baud_env = getenv("DEFAULT_LINUX_MOUSE_BAUD");
      if (mouse_baud_env != NULL){
        int val = atoi(mouse_baud_env);
        if (val != 0){
          switch(val){
            case 115200:{
              baud = B115200;
              break;
            }
            case 57600:{
              baud = B57600;
              break;
            }
            case 38400:{
              baud = B38400;
              break;
            }
            case 19200:{
              baud = B19200;
              break;
            }
            default:{
              baud = B9600;
              break;
            }
          }
        }
      }

      if (tcgetattr(_mouse_dev, &rs_arg) == -1){
        return WS_ERR;
      }
      cfsetospeed(&rs_arg, baud);
      cfsetispeed(&rs_arg, 0);
      rs_arg.c_cflag |= CRTSCTS | CS8 | CREAD;
      rs_arg.c_lflag = 0;
      rs_arg.c_cc[VTIME]    = 0;
      rs_arg.c_cc[VMIN]     = 1;
      rs_arg.c_iflag = IGNPAR;
      rs_arg.c_oflag = 0;
      tcflush(_mouse_dev, TCIFLUSH);
      if (tcsetattr(_mouse_dev, TCSANOW, &rs_arg) == -1){
        return WS_ERR;
      }
    }
  }


  if (_mouse_dev == -1){
fprintf(stderr,"Can not open mouse device.. dev=%s\n",moused);
    return WS_ERR;
  }



#ifndef NO_THREAD
  pthread_create(&_input_mouse_thr,NULL,_mouse_input_thread,NULL);
#endif
  return WS_NO_ERR;
}

#ifndef MB93093
static int _keyb_stat;
static termios t_back;
void _key_exit(void){
  ioctl(_keyb_dev,KDSKBMODE,_keyb_stat);
  ioctl(_keyb_dev,TCSETA,&t_back);
}
#endif

int init_keyboard_input_dev(){
#ifndef MB93093
  char* keybd = DEFAULT_LINUX_KEYB_DEVICE;
  char* keybdev_env = getenv("DEFAULT_LINUX_KEYB_DEVICE");
  if (keybdev_env != NULL){
    keybd = keybdev_env;
  }
  if (!strcmp(DEFAULT_LINUX_KEYB_PROTOCOL,"EVENT")){
    _keyb_protocol = KEYB_EVENT;
  }else
  if (!strcmp(DEFAULT_LINUX_KEYB_PROTOCOL,"TTY")){
    _keyb_protocol = KEYB_TTY;
  }
  char* keyb_protocol_env = getenv("DEFAULT_LINUX_KEYB_PROTOCOL");
  if (keyb_protocol_env != NULL){
    if (!strcmp(keyb_protocol_env,"EVENT")){
      _keyb_protocol = KEYB_EVENT;
    }else
    if (!strcmp(keyb_protocol_env,"TTY")){
      _keyb_protocol = KEYB_TTY;
    }
  }

  if (!strcmp(DEFAULT_LINUX_KEYBOARD,"101")){
    _keyb_map = KEYB_101;
  }else
  if (!strcmp(DEFAULT_LINUX_KEYBOARD,"JP")){
    _keyb_map = KEYB_JP;
  }else
  if (!strcmp(DEFAULT_LINUX_KEYBOARD,"jp")){
    _keyb_map = KEYB_JP;
  }
  char* key_map_env = getenv("DEFAULT_LINUX_KEYBOARD");
  if (key_map_env != NULL){
    if (!strcmp(key_map_env,"101")){
      _keyb_map = KEYB_101;
    }else
    if (!strcmp(key_map_env,"JP")){
      _keyb_map = KEYB_JP;
    }else
    if (!strcmp(key_map_env,"jp")){
      _keyb_map = KEYB_JP;
    }
  }

  _keyb_dev = -1;
  _keyb_dev = open(keybd,O_RDONLY | O_NOCTTY);

  if (_keyb_dev == -1){
fprintf(stderr,"Can not open keyboard device.. dev=%s\n",keybd);
  }
  if (_keyb_protocol == KEYB_TTY){
    ioctl(_keyb_dev,KDGKBMODE,&_keyb_stat);
    ioctl(_keyb_dev,KDSKBMODE,K_RAW);
    termios t;
    ioctl(_keyb_dev,TCGETA,&t);
    ioctl(_keyb_dev,TCGETA,&t_back);
    atexit(_key_exit);

    t.c_iflag = (IGNPAR | IGNBRK) & (~PARMRK) & (~ISTRIP);
    t.c_oflag = 0;
    t.c_cflag = CREAD | CS8;
    t.c_lflag = 0;
    t.c_cc[VTIME]=0;
    t.c_cc[VMIN]=1;
    cfsetispeed(&t,9600);
    cfsetospeed(&t,9600);
    ioctl(_keyb_dev,TCSETA,&t);
  }

#ifndef NO_THREAD
  if (_keyb_dev != -1){
    pthread_create(&_input_key_thr,NULL,_keyboard_input_thread,NULL);
  }
#endif
#endif
  return WS_NO_ERR;
}
#else //ZAURUS

//#define DOUBLE_SCALE
#include <linux/h3600_ts.h>
#include <errno.h>
pthread_t     _input_thr=0;
int _touch_pannel_dev =0;
int _touched = 0;
void* _zaurus_input_thread(void*){
  int readlen;
  TS_EVENT ts_event;
//printf("_zaurus_input_thread started..\n");
  while((readlen = read(_touch_pannel_dev,&ts_event,sizeof(TS_EVENT))) > 0 || errno == EINTR){
//printf("ts_event.x=%d y=%d p=%d\n",ts_event.x,ts_event.y,ts_event.pressure);
    int px = ts_event.x;
    int py = ts_event.y;
#ifdef ROTATE90
    {
      int tmp = px;
      px = _device_height - py-1;
      py = tmp;
    }
#endif

#ifdef ROTATE270
    {
      int tmp = px;
      px = py;
      py = _device_width - tmp -1;
    }
#endif


#ifdef DOUBLE_SCALE
    px /= 2;
    py /= 2;
#endif
    int diffx = _touch_pannel_x - px;
    if (diffx < 0){
      diffx = -diffx;
    }
    int diffy = _touch_pannel_y - py;
    if (diffy < 0){
      diffy = -diffy;
    }
    if (_touched == 0 && ts_event.pressure != 0){
      _touched = 1;
      WSDdeviceEventList* evtl = (WSDdeviceEventList*)wsmalloc(sizeof(WSDdeviceEventList));
      WSDdeviceEvent* evt = &(evtl->_event);
      int wid = _search_window(px,py);
      if (wid != 0){
        evt->s.type = EV_BUTDWN;
        evt->s.cmd = W_WORK;
        evt->s.wid = wid;
        short wx = _window_list[wid -1]._x;
        short wy = _window_list[wid -1]._y;
        evt->s.wid = wid;
        evt->e.pos.x = px -wx;
        evt->e.pos.y = py -wy;
        evt->s.stat = ES_BUT;
        evt->s.time = WSGFclocktime();
        _touch_pannel_x = px;
        _touch_pannel_y = py;
//printf("_input_dev add press event\n");
        WSGFdeviceSemLock(_event_sem_id);
        _add_event(evtl);
        WSGFdeviceSemUnlock(_event_sem_id);
//printf("_input_dev add press event done..\n");
#ifndef NO_THREAD
        _wake_up_event();
//        pthread_sem_unlock_np(&_event_sem);
#endif
      }
      continue;
    }else
    if (_touched == 1 && ts_event.pressure == 0){
      _touched = 0;
      WSDdeviceEventList* evtl = (WSDdeviceEventList*)wsmalloc(sizeof(WSDdeviceEventList));
      WSDdeviceEvent* evt = &(evtl->_event);
      int wid = _search_window(px,py);
      if (wid != 0){
        evt->s.type = EV_BUTUP;
        evt->s.cmd = W_WORK;
        evt->s.wid = wid;
        short wx = _window_list[wid -1]._x;
        short wy = _window_list[wid -1]._y;
        evt->s.wid = wid;
        evt->e.pos.x = px -wx;
        evt->e.pos.y = py -wy;
        evt->s.stat = 0;
        evt->s.time = WSGFclocktime();

        _touch_pannel_x = px;
        _touch_pannel_y = py;
//printf("_input_dev add release event\n");
        WSGFdeviceSemLock(_event_sem_id);
        _add_event(evtl);
        WSGFdeviceSemUnlock(_event_sem_id);
//printf("_input_dev add release event done..\n");
#ifndef NO_THREAD
        _wake_up_event();
//        pthread_sem_unlock_np(&_event_sem);
#endif
      }
      continue;
    }else if (diffx > 0 || diffy >0){
      if (_evt_list != NULL){
        continue;
      }
      WSDdeviceEventList* evtl = (WSDdeviceEventList*)wsmalloc(sizeof(WSDdeviceEventList));
      WSDdeviceEvent* evt = &(evtl->_event);
      int wid = _search_window(px,py);
      evt->s.type = EV_NULL;
      evt->s.wid = 0;
      evt->e.pos.x = px;
      evt->e.pos.y = py;
      evt->s.stat = ES_BUT;
      if (wid != 0){
        evt->s.cmd = W_WORK;
        evt->s.wid = wid;
        short wx = _window_list[wid -1]._x;
        short wy = _window_list[wid -1]._y;
        evt->s.wid = wid;
        evt->e.pos.x = px -wx;
        evt->e.pos.y = py -wy;
      }
      _touch_pannel_x = px;
      _touch_pannel_y = py;
      WSGFdeviceSemLock(_event_sem_id);
      _add_event(evtl);
      WSGFdeviceSemUnlock(_event_sem_id);
#ifndef NO_THREAD
      _wake_up_event();
//      pthread_sem_unlock_np(&_event_sem);
#endif
      continue;
    }
  }
  return NULL;
}

int init_zaurus_input_dev(){
  _touch_pannel_dev = open("/dev/sharp_ts",O_RDONLY | O_NOCTTY);
  if (_touch_pannel_dev == -1){
    return WS_ERR;
  }
  pthread_create(&_input_thr,NULL,_zaurus_input_thread,NULL);
  return WS_NO_ERR;
}
#endif
int _init_frame_buffer(){
  char* fbd = DEFAULT_LINUX_FRAME_BUFFER_DEVICE;
  if (getenv("DEFAULT_LINUX_FRAME_BUFFER_DEVICE") != NULL){
    fbd = getenv("DEFAULT_LINUX_FRAME_BUFFER_DEVICE");
  }
  _fb_fd = open(fbd, O_RDWR);
  if (!_fb_fd) {
    fprintf(stderr,"Error: cannot open %s device.\n",fbd);
    WSGFexit(1);
  }
  if (ioctl(_fb_fd, FBIOGET_FSCREENINFO, &fix_info)) {
    fprintf(stderr,"Error reading the fixed information of the frame buffer.\n");
    WSGFexit(1);
  }
  if (ioctl(_fb_fd, FBIOGET_VSCREENINFO, &var_info)) {
    fprintf(stderr,"Error reading the variable information of the frame buffer.\n");
    WSGFexit(1);
  }
//printf("res=%dx%d, %dbpp\n", var_info.xres, var_info.yres, var_info.bits_per_pixel );
  _device_width = var_info.xres;
  _device_height = var_info.yres;

  _device_buffer_size =
             var_info.xres * var_info.yres * var_info.bits_per_pixel / 8;
  _fb_addr = (char *)mmap(0, _device_buffer_size,
                          PROT_READ | PROT_WRITE, MAP_SHARED,
                          _fb_fd, 0);
  if ((int)_fb_addr == -1){
#ifdef MB93093
    _fb_addr = (char*)fix_info.smem_start;
    memset(_fb_addr,0x00,_device_buffer_size);
    _fb_addr = (char*)fix_info.smem_start+32;
#else
    _fb_addr = (char*)fix_info.smem_start;
#endif
dbprintf("type=%d type_aux=%d visual=%d panstep=%d,%d wrap=%d\n",fix_info.type,fix_info.type_aux,fix_info.visual,fix_info.xpanstep,fix_info.ypanstep,fix_info.ywrapstep);
dbprintf("line_len=%d mmio=0x%x buf=0x%x accel=%d\n",fix_info.line_length,fix_info.mmio_start,fix_info.smem_start,fix_info.accel);
  }
  _device_depth = var_info.bits_per_pixel;
  _device_row_bytes = _device_width * _device_depth / 8;
dbprintf("_device_row_bytes=%d depth=%d\n",_device_row_bytes,_device_depth);
dbprintf("red=%d,%d green=%d,%d blue=%d,%d transp=%d,%d\n", var_info.red.offset, var_info.red.length, var_info.green.offset, var_info.green.length, var_info.blue.offset, var_info.blue.length, var_info.transp.offset, var_info.transp.length);
#ifdef USE_SAME_BUF
dbprintf("fix_info.visual=%d\n",fix_info.visual);
  if (fix_info.visual == FB_VISUAL_PSEUDOCOLOR){
    fb_cmap cmap;
    cmap.start = 0;
    cmap.len = 256;
    cmap.red = new unsigned short[256];
    cmap.green = new unsigned short[256];
    cmap.blue = new unsigned short[256];
    cmap.transp = NULL;
    if (ioctl(_fb_fd,FBIOGETCMAP,&cmap)){
      return WS_ERR;
    }
    
    int i = 0;
    ws_vmap = new WSDcmap[cmap.len];
    for(i=0; i<cmap.len; i++){
      ws_vmap[i].r = cmap.red[i];
      ws_vmap[i].g = cmap.green[i];
      ws_vmap[i].b = cmap.blue[i];
    }

    int r_max = WS_CMAP_R_ENTRIES;
    int g_max = WS_CMAP_G_ENTRIES;
    int b_max = WS_CMAP_B_ENTRIES;
    ws_cmap = new WSDcmap[r_max * g_max * b_max]; 
    int r,g,b;

    i=0;
    for(r=0; r < WS_CMAP_R_ENTRIES; r++){
      for(g=0; g < WS_CMAP_G_ENTRIES; g++){
        for(b=0; b < WS_CMAP_B_ENTRIES; b++){
          int r1 = r * 255 / (r_max -1)*0x101;
          int g1 = g * 255 / (g_max -1)*0x101;
          int b1 = b * 255 / (b_max -1)*0x101;
          ws_cmap[i].r = r1;
          ws_cmap[i].g = g1;
          ws_cmap[i].b = b1;
          int j;
          unsigned int dist = 0xffffffff;
          int entry = 0;
          for(j=cmap.start; j<cmap.len; j++){
            int rd = cmap.red[j] - r1;
            int gd = cmap.green[j] - g1;
            int bd = cmap.blue[j] -b1;
            if (rd < 0){
              rd = -rd;
            }
            if (gd < 0){
              gd = -gd;
            }
            if (bd < 0){
              bd = -bd;
            }
            int dist1 =  rd + gd + bd;
            if (dist > dist1){
              dist = dist1;
              entry = j;
            }
          }
          ws_cmap[i].index = entry;
          i++;
        }
      }
    }
  }else
  if (fix_info.visual == FB_VISUAL_TRUECOLOR){
    _device_start_red = var_info.red.offset;
    _device_start_green = var_info.green.offset;
    _device_start_blue = var_info.blue.offset;
    _device_red_bits = var_info.red.length;
    _device_green_bits = var_info.green.length;
    _device_blue_bits = var_info.blue.length;
  }else{
    if (_device_depth == 32){
      _device_start_red = 16;
      _device_start_green = 8;
      _device_start_blue = 0;
      _device_red_bits = 8;
      _device_green_bits = 8;
      _device_blue_bits = 8;
    }else if (_device_depth == 24){
      _device_start_red = 16;
      _device_start_green = 8;
      _device_start_blue = 0;
      _device_red_bits = 8;
      _device_green_bits = 8;
      _device_blue_bits = 8;
    }else if (_device_depth == 16){
      _device_start_red = 11;
      _device_start_green = 5;
      _device_start_blue = 0;
      _device_red_bits = 5;
      _device_green_bits = 6;
      _device_blue_bits = 5;
    }
  }
//printf("device: w,h,d=%d,%d,%d\n",_device_width,_device_height,_device_depth);
  _buffer = (unsigned char*)_fb_addr;
  memset(_buffer,0xff,_device_buffer_size);
#else
  long buf_size = _device_height * _device_row_bytes;
  _buffer = (unsigned char*)wsmalloc(buf_size);
#endif

#ifndef NO_THREAD
//  pthread_sem_init_np(&_event_sem);
//  pthread_sem_lock_np(&_event_sem);
#endif

#ifndef ZAURUS
  init_mouse_input_dev();
  init_keyboard_input_dev();
#else
  init_zaurus_input_dev();
#endif

  if ((int)_fb_addr == -1) {
    fprintf(stderr,"Error: failed to map framebuffer device to memory.\n");
    WSGFexit(1);
  }
  return 0;
}
int _update_frame_buffer(int x1,int y1,unsigned int w1,unsigned int h1){
//printf("_update_frame_buffer.. started\n");
#ifdef USE_SAME_BUF
#else
  unsigned int depth =   _device_depth;
  unsigned int row_bytes = _device_row_bytes;
#ifdef ROTATE90
  long tmp = x1;
  x1 = y1;
  y1 = _device_height - tmp - w1;
  tmp = w1;
  w1 = h1;
  h1 = tmp;
#endif

#ifdef ROTATE270
  long tmp = x1;
  x1 = _device_width - y1 -h1;
  y1 = tmp;
  tmp = w1;
  w1 = h1;
  h1 = tmp;
#endif


  int x;
  int y;
  for ( y = y1; y < y1 + h1; y++ ){
    int pos = (var_info.xoffset + x1) * (var_info.bits_per_pixel/8) +
                       (y+var_info.yoffset) * fix_info.line_length;
    for ( x = x1; x < x1 + w1; x++ ){
      unsigned int val = 0;

      if (depth == 32){
        unsigned int* ptr = (unsigned int*)&_buffer[y*row_bytes + x*depth/8];
        val = *ptr;
      }else
      if (depth == 16){
        unsigned short* ptr = (unsigned short*)&_buffer[y*row_bytes + x*depth/8];
        val = *ptr;
      }

      unsigned char rr = (val >> _device_start_red) << (8 -_device_red_bits);
      unsigned char gg = (val >> _device_start_green) << (8 -_device_green_bits);
      unsigned char bb = (val >> _device_start_blue) << (8 -_device_blue_bits);
      if ( var_info.bits_per_pixel == 32 ) {
        _fb_addr[pos++] = bb;
        _fb_addr[pos++] = gg;
        _fb_addr[pos++] = rr;
        _fb_addr[pos++] = 0;
      }else if (var_info.bits_per_pixel == 16){
        unsigned short* ptr = (unsigned short*)&_fb_addr[pos++];
        unsigned short int v = (rr>>3)<<11 | (gg>>2) << 5 | (bb>>3);
        *((unsigned short int*)(ptr)) = v;
        pos++;
      }
    }
  }
#endif
//printf("_update_frame_buffer.. done\n");
  return 0;
}
int _get_event(WSDdeviceEvent* evt,unsigned int mode){
#ifdef NO_THREAD
  _mouse_input_proc();
#endif
  if (_evt_list == NULL){
    if ( _device_check_event_available() != False ){
      evt->s.type = EV_MSG;
      return WS_NO_ERR;
    }
    return WS_ERR;
  }

  WSDdeviceEventList* item = _evt_list;
  WSDdeviceEventList* item_bak = NULL;
  while(1){
    if (item == NULL){
      break;
    }
    if ((mode & 0xfff0 ) == DSPEVT){
      if (item->_event.r.type != EV_REQUEST){
        item_bak = item;
        item = item->_next;
        continue;
      }
      if (item->_event.r.cmd != W_REDISP){
        item_bak = item;
        item = item->_next;
        continue;
      }
    }
    if (item_bak == NULL){
      _evt_list = item->_next;
    }else{
      item_bak->_next = item->_next;
    }
    memcpy(evt,&(item->_event),sizeof(WSDdeviceEvent));
    wsfree(item);
    return WS_NO_ERR;
  }
  if ((mode & 0xfff0 ) == DSPEVT){
    return WS_ERR;
  }
  //TODO: get mouse event..
  //TODO: get key event..
  if ( _device_check_event_available() != False ){
    evt->s.type = EV_MSG;
    return WS_NO_ERR;
  }
  return 0;
}

