//
// Copyright (C) 1999-2008 WideStudio/MWT Project Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#include <WScom.h>
#include "WSCsheetComboBox.h"
#include <WSCclassInformation.h>
#include <WSCdevice.h>
#include <WSDdev.h>
#include <WSCwindow.h>
#include <WSClist.h>
#include <WSDappDev.h>
#include <WSDwindowDev.h>
#include <WSDmouse.h>
#include <WSDprivateTimer.h>
#include <WSCvifield.h>
#include <WSCblink.h>
#include <WSCfontSet.h>
#include <WSDkeyboard.h>

#include <WSCcolorSet.h>

#include <udebug.h>
static WSCbool global_mouse_hook_proc(long ev,WSCbase* inst);

WSMFguiClassInitialize(WSCsheetComboBox,WSCform);
WSMFversion(WSCsheetComboBox, WSCform);
#define WS_CM_BORDER 2
#define WS_STRETCH_HEIGHT 300
WSMFpropertyValueChange( WSCsheetComboBox, WSNshadowType , char,WS_SHADOW_IN);

static WSDprivateTimer* _timer = NULL;
WSCsheetComboBox::WSCsheetComboBox(WSCbase* base,char* objname):WSCform(base,objname){
  _register_focus_move();

  _menu_str = WSGFstrdup("item1,item2,item3");
  _max_height = 0;
  _win = NULL;
  _list = NULL;
  _if = NULL;
  _shadow_type = WS_SHADOW_IN;
  _bg_blink_color = WS_DF_NWBACKCOLOR;
  _work_back_color = WS_DF_WORKBACKCOLOR;
  _font = (char)WSGIappFontSet()->getDefaultFontNo();
  _increment = 10;
  _page_increment = 100;

  _item_height = 20;
  _selected_by_key = False;

  _dropdown_type = WSCSHEET_COMBO_EDIT;
  _list_down = 0;
  _text = WSGFstrdup("");
  _focus = False;
  _focus_color = WSGIappColorSet()->getColorNo("#000080");
  _listindex = -1;

  WSMFpropertyCreateStart
    WSMFparentCheckVerSrc(WSCsheetComboBox);

    WSMFpropertyCreate(WSNmenuItems, char*, _menu_str,WSSmenuItems);
    WSMFpropertyCreate(WSNmaxHeight, WSCushort, _max_height,WSSmaxHeight);

    WSMFpropertyCreate(WSNbackBlinkColor, short, _bg_blink_color,WSSbackBlinkColor);
    WSMFpropertyCreate(WSNworkBackColor,short,_work_back_color,WSSworkBackColor);
    WSMFpropertyCreate(WSNfont,  WSCuchar, _font,WSSfont  );

    WSMFpropertyCreate(WSNitemHeight,  WSCuchar, _item_height,WSSitemHeight  );
    WSMFpropertyCreate(WSNincrement,    WSCushort, _increment,WSSincrement );
    WSMFpropertyCreate(WSNpageIncrement,WSCushort, _page_increment,WSSpageIncrement );

    WSMFpropertyValueChangeDef( WSCsheetComboBox,WSNshadowType ,char);
    WSMFpropertyDelete(WSNupward);
    WSMFpropertyDelete(WSNdownward);
    WSMFpropertyDelete(WSNreturn);

    WSMFaddTrigger(WSEV_VALUE_CH    );
    WSMFaddTrigger(WSEV_ACTIVATE    );
    WSMFaddTrigger(WSEV_KEY_PRESS    );
    WSMFaddTrigger(WSEV_KEY_RELEASE   );
    WSMFaddTrigger(WSEV_KEY_HOOK   );

  WSMFpropertyCreateEnd
}
WSMFproperty(WSCsheetComboBox, WSNmenuItems,  char*, _menu_str, WSGFstrdup("item1,item2,item3"));
WSMFproperty(WSCsheetComboBox, WSNmaxHeight,  WSCushort, _max_height,       0);
WSMFproperty(WSCsheetComboBox, WSNworkBackColor, short, _work_back_color,WS_DF_WORKBACKCOLOR);
WSMFproperty(WSCsheetComboBox, WSNbackBlinkColor, short, _bg_blink_color,WS_DF_NWBACKCOLOR);
WSMFproperty(WSCsheetComboBox, WSNfont,        WSCuchar, _font,(char)WSGIappFontSet()->getDefaultFontNo());
WSMFproperty(WSCsheetComboBox, WSNitemHeight,     WSCuchar,  _item_height, 20);
WSMFproperty( WSCsheetComboBox, WSNincrement,     WSCushort, _increment,  10);
WSMFproperty( WSCsheetComboBox, WSNpageIncrement, WSCushort, _page_increment, 100);

void WSCsheetComboBox::setWorkWSNdet(WSCbool fl){
  WSCform::setWorkWSNdet(fl);
  if (_if != NULL){
    _if->setPropertyV(WSNdet,fl);
  }
}
void WSCsheetComboBox::setWorkWSNmenuItems(char*){}
void WSCsheetComboBox::getWorkWSNmenuItems(char**){}
void WSCsheetComboBox::setWorkWSNmaxHeight(WSCushort mh){
  if (_list != NULL){
    WSCulong barw = _list->getProperty(WSNbarThickness);
    if (_max_height > 0 && _max_height < barw *4){
      _max_height = barw *4;
    }
  }
}
void WSCsheetComboBox::getWorkWSNmaxHeight(WSCushort*){}
void WSCsheetComboBox::setWorkWSNworkBackColor(short data){
  _if->setPropertyV(WSNbackColor,data);
}
void WSCsheetComboBox::getWorkWSNworkBackColor(short* data){}

void WSCsheetComboBox::setWorkWSNbackBlinkColor(short data){
  _if->setPropertyV(WSNbackBlinkColor,data);
}
void WSCsheetComboBox::getWorkWSNbackBlinkColor(short*){}
void WSCsheetComboBox::setWorkWSNfont(WSCuchar data){
  _if->setPropertyV(WSNfont,data);
  if (_list != NULL){
    _list->setPropertyV(WSNfont,data);
  }
}
void WSCsheetComboBox::getWorkWSNfont(WSCuchar*){}
void WSCsheetComboBox::setWorkWSNitemHeight(WSCuchar data){
  if (_list != NULL){
    _list->setProperty(WSNitemHeight,data);
    _list->setProperty(WSNscrollHeight,data);
  }
}
void WSCsheetComboBox::getWorkWSNitemHeight(WSCuchar*){}
void WSCsheetComboBox::setWorkWSNincrement(WSCushort val){
  if (_list != NULL){
    _list->setProperty(WSNincrement,val);
  }
}
void WSCsheetComboBox::getWorkWSNincrement(WSCushort*){}
void WSCsheetComboBox::setWorkWSNpageIncrement(WSCushort val){
  if (_list != NULL){
    _list->setProperty(WSNpageIncrement,val);
  }
}
void WSCsheetComboBox::getWorkWSNpageIncrement(WSCushort*){}

WSCsheetComboBox::~WSCsheetComboBox(){
  if (_list != NULL){
    WSDdev* ldev = _list->getowndev();
    if (ldev != NULL){
      WSCbool val = False;
      ldev->setValue(WSDEV_GRAB_POINTER,(void*)&val);
    }
  }
  if (_win != NULL){
    WSCushort height;
    _win->getPropertyV(WSNheight,&height);
    if (height < WS_STRETCH_HEIGHT){
      _win->setVisible(False);
    }else{
#ifdef WS_EMBED
      _win->setVisible(False);
#else
      WSGFstretchPopdown(_win);
#endif
    }
  }
  if (_timer != NULL){
    _timer->stopTimer();
  }

  if (_win != NULL){
#ifndef WS_EMBED
    WSGFcleanupStretchAction(_win);
#endif
  }
  if (_win != NULL){
    delete _win;
  }
  if (_menu_str != NULL){
    delete[] _menu_str;
    _menu_str = NULL;
  }
}

WSCbase* WSCsheetComboBox::getPropertyInheritChild(){
  return _if;
}

long WSCsheetComboBox::initialize(){
  WSCform::initialize();
  if (_if == NULL){
    WSCstring name;
    name = (WSCstring)"cw-if-" + getInstanceName();
    _if = new WSCvifield(this,name);
    _if->setInternalObject(True);
    _if->initialize();
    _if->setPropertyV(WSNx,(short)0);
    _if->setPropertyV(WSNy,(short)0);
    _if->setPropertyV(WSNshadowType,(char)_shadow_type);
    _if->setProperty(WSNenableFocusMove,True);
    _if->setUserData("_CMB",(void*)this);
	WSCprocedure* op2 = new WSCprocedure("key press proc",WSEV_KEY_PRESS);
    op2->setInternal(True);
    op2->setFunction(_key_press_work,"_key_press_work");
    _if->addProcedure(op2);
    WSCprocedure* op3 = new WSCprocedure("key release proc",WSEV_KEY_RELEASE);
    op3->setInternal(True);
    op3->setFunction(_key_release_work,"_key_release_work");
    _if->addProcedure(op3);
    WSCprocedure* op4 = new WSCprocedure("key release proc",WSEV_KEY_HOOK);
    op4->setInternal(True);
    op4->setFunction(_key_hook_work,"_key_hook_work");
    _if->addProcedure(op4);
    WSCprocedure* op5 = new WSCprocedure("value ch proc",WSEV_VALUE_CH);
    op5->setInternal(True);
    op5->setFunction(_value_ch_work,"_value_ch_work");
    _if->addProcedure(op5);
    WSCprocedure* op6 = new WSCprocedure("focus ch proc",WSEV_FOCUS_CH);
    op6->setInternal(True);
    op6->setFunction(_focus_ch,"_focus_ch");
    _if->addProcedure(op6);

    _adjust();

    this->setUserData("_CMB",(void*)this);
	_list_down = 0;

    WSGIappMouse()->setGlobalMouseHook(global_mouse_hook_proc);

    _if->setVisible((_dropdown_type == WSCSHEET_COMBO_EDIT));
  }
  return WS_NO_ERR;
}

void WSCsheetComboBox::setWorkWSNwidth(WSCushort data){
  WSCform::setWorkWSNwidth(data);
  _adjust();  
}
void WSCsheetComboBox::setWorkWSNheight(WSCushort data){
  WSCform::setWorkWSNheight(data);
  _adjust();  
}
void WSCsheetComboBox::setWorkWSNshadowType(char data){
  WSCform::setWorkWSNshadowType(data);
  _adjust();  
}
void WSCsheetComboBox::setWorkWSNshadowThickness(WSCuchar data){
  WSCform::setWorkWSNshadowThickness(data);
  _adjust();  
}
void WSCsheetComboBox::setWorkWSNforeColor(short data){
  WSCform::setWorkWSNforeColor(data);
  _adjust();  
}
void WSCsheetComboBox::setWorkWSNbackColor(short data){
  WSCform::setWorkWSNbackColor(data);
  _adjust();  
}
void WSCsheetComboBox::setWorkWSNtopShadowColor(short data){
  WSCform::setWorkWSNtopShadowColor(data);
  _adjust();  
}
void WSCsheetComboBox::setWorkWSNbottomShadowColor(short data){
  WSCform::setWorkWSNbottomShadowColor(data);
  _adjust();  
}

long WSCsheetComboBox::_menu_popup(){
  _focus = False;
  _text = _if->getProperty(WSNlabelString); 

  setUserData("Selected-cleard",(void*)0);
  if (_timer == NULL){
    _timer = WSDprivateTimer::getNewInstance();
    _timer->setRate(20);
  }
  WSDdev* dev = getowndev();
  if (dev == NULL){
    return WS_ERR;
  }
  short px, py;
  dev->getDispAddr(&px,&py);
  py += _h;
  WSCstring str(_menu_str);
  char tmp[2];
  tmp[0] = (char)-1;
  tmp[1] = 0;
 
  str.replaceString("\\,",tmp,0);

  long num  = str.getWords(",");
  WSCushort height = num * _item_height + _shadow_thick*2;
  if (_max_height != 0 && height > _max_height){
    height = _max_height;
  }
  long min = _item_height*3;
  long min2 = _item_height * num;
  if (min > min2){
    min = min2;
  }
  if (height > WSGIappDev()->getHeight() - py){ 
    long h2 = WSGIappDev()->getHeight() -py;
    if (h2 < min){
      py -= _h;
      py -= height;
    }else{
      height = h2;
    }
  }
  if (_win == NULL){
    WSCstring name;
    name = (WSCstring)"cw-" + getInstanceName();
    _win = new WSCwindow(NULL,name);
    _win->setInternalObject(True);
    _win->initialize();
    _win->setUserData("_CMB",(void*)this);
    WSCprocedure* opw = new WSCprocedure("cancel work",WSEV_WINDOW_CANCELED);
    opw->setInternal(True);
    opw->setFunction(_cancel_work,"_cancel_work");
    _win->addProcedure(opw);
    name = (WSCstring)"cw-list-" + getInstanceName();
    _list = new WSClist(_win,name);
    _list->setInternalObject(True);
    _list->initialize();
    _list->setPropertyV(WSNhbarVisible,(WSCbool)False);
    _list->setPropertyV(WSNreverseSelect,(WSCbool)False);
    _list->setPropertyV(WSNmargin,(WSCuchar)_shadow_thick);
    _list->setProperty(WSNitemHeight,_item_height);
    _list->setProperty(WSNincrement,_increment);
    _list->setProperty(WSNpageIncrement,_page_increment);
    _list->setProperty(WSNscrollHeight,_item_height);

    _list->setUserData("_CMB",(void*)this);
    _list->setAbsoluteChangeSelectFlag(True);
    WSCprocedure* op = new WSCprocedure("select proc",WSEV_ACTIVATE);
    op->setFunction(_list_work,"_list_work");
    _list->addProcedure(op);
    WSCprocedure* op2 = new WSCprocedure("click proc",WSEV_MOUSE_PRESS);
    op2->setFunction(_list_ptr_work,"_list_ptr_work");
    _list->addProcedure(op2);

    WSCulong barw = _list->getProperty(WSNbarThickness);
    if (_max_height != 0 && _max_height < barw *4){
      _max_height = barw *4;
    }
  }
  _win->setPropertyV(WSNforeColor,_fore_color);
  _win->setPropertyV(WSNbackColor,_back_color);
  _win->setPropertyV(WSNtopShadowColor,_ts_color);
  _win->setPropertyV(WSNbottomShadowColor,_bs_color);
#ifndef NO_GUI_POLICY
  if (WSGIappDev()->getGuiPolicy() & WS_POLICY_ORIGINAL){
    _win->setPropertyV(WSNshadowThickness,(WSCuchar)_shadow_thick);
    _win->setProperty(WSNshadowType,WS_SHADOW_OUT);
  }else
  if (WSGIappDev()->getGuiPolicy() & WS_POLICY_WINDOWS){
#endif
    _win->setPropertyV(WSNshadowThickness,(WSCuchar)1);
    _win->setProperty(WSNshadowType,WS_SHADOW_BORDER);
#ifndef NO_GUI_POLICY
  }
#endif
  _win->setPropertyV(WSNx,px);
  _win->setPropertyV(WSNy,py);
  _win->setPropertyV(WSNwidth,_w);
  _win->setPropertyV(WSNheight,height);
  _win->setPropertyV(WSNtitleBar,(char)WS_NO_TITLE);
  _list->setPropertyV(WSNforeColor,_fore_color);
  _list->setPropertyV(WSNbackColor,_back_color);
  _list->setPropertyV(WSNworkBackColor,_work_back_color);
  _list->setPropertyV(WSNtopShadowColor,_ts_color);
  _list->setPropertyV(WSNbottomShadowColor,_bs_color);
#ifndef NO_GUI_POLICY
  if (WSGIappDev()->getGuiPolicy() & WS_POLICY_ORIGINAL){
    _list->setPropertyV(WSNx,(short)(_shadow_thick + WS_CM_BORDER));
    _list->setPropertyV(WSNy,(short)(_shadow_thick + WS_CM_BORDER));
    _list->setPropertyV(WSNwidth,(WSCushort)(_w - _shadow_thick*2 - WS_CM_BORDER*2));
    _list->setPropertyV(WSNheight,(WSCushort)(height - _shadow_thick*2 - WS_CM_BORDER*2));
    _list->setPropertyV(WSNshadowThickness,(WSCuchar)_shadow_thick);
  }else
  if (WSGIappDev()->getGuiPolicy() & WS_POLICY_WINDOWS){
#endif
    _list->setPropertyV(WSNx,(short)(_shadow_thick));
    _list->setPropertyV(WSNy,(short)(_shadow_thick));
    _list->setPropertyV(WSNwidth,(WSCushort)(_w - _shadow_thick*2));
    _list->setPropertyV(WSNheight,(WSCushort)(height - _shadow_thick*2));
    _list->setPropertyV(WSNshadowThickness,(WSCuchar)0);
#ifndef NO_GUI_POLICY
  }
#endif
  _list->setPropertyV(WSNpixmapStyle,(WSCuchar)WS_DYNAMIC_PIXMAP);
  _list->delAll();
  _list->setSelectItemChanged(False);
  _list->setProperty(WSNvbarValue,0);

  _listindex = -1;
  long i;
  for(i=0; i<num; i++){
    WSCstring item = str.getWord(i,",");
    item.replaceString(tmp,",",0);
    _list->addItem(item,-1);
    if(_dropdown_type == WSCSHEET_COMBO_EDIT) {
      if (_listindex == -1 && !strncmp(_text.getString(),item.getString(),_text.getChars())){
        _text = item;
        _listindex = i;
        _if->setPropertyV(WSNlabelString, (char*)_text);
      }
    } else if(item == _text) {
      _listindex = i;
    }
  }

  WSDdev* wdev = _win->attachdev();
  if (wdev != NULL){
    WSCbool val = True;
    wdev->setValue(WSDEV_NO_FRAME,(void*)&val);
    wdev->setValue(WSDEV_FLOAT_ON_TOP,(void*)&val);
  }
  _list->updateList();

  if(_listindex != -1) {
    _list->setSelectPos(_listindex);
    _list->setSelectItemChanged(True);
  }

  _list->setVisible(True);
  if (height < WS_STRETCH_HEIGHT){
    _win->setVisible(True);
  }else{
#ifdef WS_EMBED
    _win->setVisible(True);
#else
    WSGFstretchPopup(_win);
#endif
  }
  WSCwindow::setCancelWindow(_win);
  WSDdev* ldev = _list->getowndev();
  if (ldev != NULL){
    WSCbool val = True;
    ldev->setValue(WSDEV_GRAB_POINTER,(void*)&val);
    _list->setEnableActivate(False);
    _list->setFocus();
    _list->setSelectItemChanged(False);
    _list->setEnableActivate(True);
    WSGIappKeyboard()->setSpecialInputWorkProc(_special_key_handler,this,this);
  }
  if (_timer != NULL){
    _timer->setWorkProc(_list_timer_work,this);
    _timer->startTimer();
  }
  return WS_NO_ERR;
}
void WSCsheetComboBox::_adjust(){
  if (_w - _h > 0){
    _if->setPropertyV(WSNwidth,(WSCushort)(_w - WSCSHEET_COMBO_BUTTON_WIDTH-_shadow_thick*2));
  }else{
    _if->setPropertyV(WSNwidth,(WSCushort)1);
  }
  _if->setPropertyV(WSNheight,(WSCushort)_h);
///
  _if->setPropertyV(WSNx,(short)(_shadow_thick));
  _if->setPropertyV(WSNy,(short)(_shadow_thick));
  _if->setPropertyV(WSNheight,(WSCushort)(_h - _shadow_thick *2));
  _if->setPropertyV(WSNshadowType, (char)WS_SHADOW_BORDER);
  _if->setPropertyV(WSNshadowThickness, (WSCuchar)0);
////
  _if->setPropertyV(WSNbackColor,(short)_work_back_color);
  _if->setPropertyV(WSNforeColor,(short)_fore_color);
  _if->setPropertyV(WSNtopShadowColor,(short)_ts_color);
  _if->setPropertyV(WSNbottomShadowColor,(short)_bs_color);
}
long WSCsheetComboBox::_menu_popdown(){
  _list_down = 0;

  if (_list != NULL){
    WSDdev* ldev = _list->getowndev();
    if (ldev != NULL){
      WSCbool val = False;
      ldev->setValue(WSDEV_GRAB_POINTER,(void*)&val);
    }
  }
  if (_win != NULL){
    WSCushort height;
    _win->getPropertyV(WSNheight,&height);
    if (height < WS_STRETCH_HEIGHT){
      _win->setVisible(False);
    }else{
#ifdef WS_EMBED
      _win->setVisible(False);
#else
      WSGFstretchPopdown(_win);
#endif
    }
    if (WSCwindow::getCancelWindow() == _win){
      WSCwindow::setCancelWindow(NULL);
    }
  }
  if (_timer != NULL){
    _timer->stopTimer();
  }
  long fl = (long)getUserData("Selected-cleard");
  if (fl != False){
    setFocus(True);
    WSGIappKeyboard()->resetSpecialInputWorkProc();
	if(_dropdown_type != WSCSHEET_COMBO_EDIT) {
		redraw();
	}
    return WS_NO_ERR;
  }
  if (_list == NULL){
    WSGIappKeyboard()->resetSpecialInputWorkProc();
    setFocus(True);
	if(_dropdown_type != WSCSHEET_COMBO_EDIT) {
		redraw();
	}
    return WS_NO_ERR;
  }
  _listindex = -1;

  if (_list->getSelectedPos() > -1){
    WSCstring data;
    _listindex = _list->getSelectedPos();
    data = _list->getSelectedItem();
    _if->setPropertyV(WSNlabelString,(char*)data);

	_text = data;

    setVisible(True);
    onActivate();
  }
  WSGIappKeyboard()->resetSpecialInputWorkProc();
  setFocus(True);
  return WS_NO_ERR;
}
long WSCsheetComboBox::_device_initialize(){
  WSCform::_device_initialize();

  WSDdev* dev = getowndev();
  if (dev != NULL){
	long bit;
	bit = dev->getAvailableEventBit();

	dev->setEnableEventBit(bit | 
						   WSEV_FOCUS_CH_BIT | 
						   WSEV_MOUSE_PRESS_BIT | WSEV_MOUSE_RELEASE_BIT);
  }
  return WS_NO_ERR;
}
void WSCsheetComboBox::onActivate(){
  _focus = True;
  execProcedure(WSEV_ACTIVATE);
  if(_dropdown_type != WSCSHEET_COMBO_EDIT) {
    draw();
  }
}
long WSCsheetComboBox::draw(){
  if (getVisible() == False){
    return WS_NO_ERR;
  }
  WSDdev* dev = getowndev();
  if (dev == NULL){
    return WS_ERR;
  }
  WSCbool absolute = getAbsoluteDraw();
  if (absolute == False  ){
    if (getDotMode() == False){
      if ( dev->isExposed(0,0,_w,_shadow_thick) == False &&
           dev->isExposed(0,0,_shadow_thick,_h) == False &&
           dev->isExposed(_w -_shadow_thick,0,_shadow_thick,_h) == False &&
           dev->isExposed(0,_h -_shadow_thick,_w,_shadow_thick) == False ){
        return WS_NO_ERR;
      }
    }else{
      if ( dev->isExposed(0,0,_w,_h) == False ){
        return WS_NO_ERR;
      }
    }
  }
  if (_shadow_thick > 0 || getDotMode() != False){
    long err = dev->beginDraw(0,0,_w,_h,absolute);
    if (err != WS_NO_ERR){
      return WS_NO_ERR;
    }
    short ex = _w - _h;
    if (ex < 0){
      ex = 0;
    }
    short ey = 0;
    WSCushort ew = _h;
    WSCushort eh = _h;
    WSCbase::update();

    setAbsoluteDraw(True);
    WSGFdrawShadow(dev,_shadow_type,_shadow_thick,_fore_color,_ts_color,_bs_color,_back_color,0,0,_w,_h);

	WSCrect rect;
	rect.x = 0;
	rect.y = 0;
	rect.width = _w;
	rect.height = _h;
	buttonDraw(dev, rect);

    dev->endDraw();
  }
  return WS_NO_ERR;
}

void WSCsheetComboBox::_list_timer_work(void* ptr){
  WSCsheetComboBox* cmb = (WSCsheetComboBox*)ptr;
  WSClistData* lbs = cmb->_list->getLabels();
  long i;
  long num = lbs->getNum();
  WSCushort vx,vy;
  cmb->_list->getPropertyV(WSNhbarValue,&vx);
  cmb->_list->getPropertyV(WSNvbarValue,&vy);
  static short bx =0 ,by = 0;
  short tx =0 ,ty = 0;
  WSGIappMouse()->getMousePosition(&tx,&ty,cmb);
  if (tx != bx || ty != by ){
    cmb->_selected_by_key = False;
    bx = tx;
    by = ty;
  }

  for(i=0; i<num; i++){
    WSCbase* lb = (WSCbase*)(*lbs)[i];
    short px,py;
    WSGIappMouse()->getMousePosition(&px,&py,lb);
    WSCushort sw,sh;
    WSCbase* scrframe = cmb->_list->getdev()->getAttachedClient();
    scrframe->getPropertyV(WSNwidth,&sw);
    lb->getPropertyV(WSNheight,&sh);
    if (0 < px && px < sw && 
        0 < py && py < sh && cmb->_selected_by_key == False){
      cmb->_list->setEnableActivate(False);
      cmb->_list->setSelectPos(i);
      cmb->_list->setSelectItemChanged(False);
      cmb->_list->setEnableActivate(True);
      cmb->_list->cdraw();
      break;
    }
  }
}
WSCbool WSCsheetComboBox::_special_key_handler(void* ptr,WSDkeyboard* keyb,WSCbool fl){
  WSCsheetComboBox* _this = (WSCsheetComboBox*)ptr;
  if (_this->_win == NULL){
    return True;
  }
  if (_this->_win->getVisible() == False){
    WSGIappKeyboard()->resetSpecialInputWorkProc();
    return True;
  }
  long key = keyb->getKey();
  if (key == WSK_Escape || key == WSK_Super_L || key == WSK_Super_R ||
      key == WSK_Control_L || key == WSK_Control_R || key == WSK_Apps ||
      key == WSK_Alt_L || key == WSK_Alt_R ||
      key == WSK_Meta_L || key == WSK_Meta_R ){
    if (fl == False){
      return False;
    }
    WSDdev* ldev = _this->_list->getowndev();
    if (ldev != NULL){
      WSCbool val = False;
      ldev->setValue(WSDEV_GRAB_POINTER,(void*)&val);
    }
    _this->setUserData("Selected-cleard",(void*)1);
    _this->_menu_popdown();
    return False;
  }else
  if (key == WSK_Return){
    if (fl == False){
      return False;
    }
    _this->_menu_popdown();
    _this->_list->onActivate();
    return False;
  }else
  if (key == WSK_Up){
    if (fl == False){
      return False;
    }
    _this->_selected_by_key = True;
    long spos = _this->_list->getSelectedPos();
    if (spos > 0){
      spos--;
    }else{
      spos = 0;
    }
    _this->_list->setEnableActivate(False);
    _this->_list->setSelectPos(spos);
    long tpos = _this->_list->getTopPos();
    if (tpos > spos){
      _this->_list->setTopPos(spos);
    }
    WSCbase* cl = _this->_list->getLabel(spos);
    cl->setFocus();
    _this->_list->setSelectItemChanged(False);
    _this->_list->setEnableActivate(True);
    return False;
  }else if (key == WSK_Down){
    if (fl == False){
      return False;
    }
    _this->_selected_by_key = True;
    long spos = _this->_list->getSelectedPos();
    if (spos > -1){
      spos++;
    }else{
      spos = -1;
    }
    _this->_list->setEnableActivate(False);
    _this->_list->setSelectPos(spos);
    long bpos = _this->_list->getBottomPos();
    if (spos > bpos){
      _this->_list->setBottomPos(spos);
    }
    WSCbase* cl = _this->_list->getLabel(spos);
    cl->setFocus();
    _this->_list->setSelectItemChanged(False);
    _this->_list->setEnableActivate(True);
    return False;
  }else{
    if (fl == False){
      return False;
    }
    char* text = keyb->getText();
    if ( (text[0] > 'A' -1 && text[0] < 'Z' + 1) ||
         (text[0] > 'a' -1 && text[0] < 'z' + 1) ||
         (text[0] > '0' -1 && text[0] < '9' + 1) ){
      int i;
      int num = _this->_list->getNum();
      for(i=0; i<num; i++){
         WSCstring str = _this->_list->getItem(i);
         char* str2 = str.getString();
         if (text[0] == str2[0]){
           _this->_list->setEnableActivate(False);
           _this->_list->setTopPos(i);
           _this->_list->setSelectPos(i);
           WSCbase* cl = _this->_list->getLabel(i);
           cl->setFocus();
           _this->_list->setSelectItemChanged(False);
           _this->_list->setEnableActivate(True);
           return False;
         }
      }
    }
  }
  return True;
}
void WSCsheetComboBox::_list_ptr_work(WSCbase* list){
  WSCsheetComboBox* cmb = (WSCsheetComboBox*)list->getUserData("_CMB");
  if (cmb == NULL){
    return;
  }
  // for touch pannel..
  _list_timer_work(cmb);

  short px,py;
  WSGIappMouse()->getMousePosition(&px,&py,list);
  WSCushort sw=0,sh=0;
  list->getPropertyV(WSNwidth,&sw);
  list->getPropertyV(WSNheight,&sh);
  long wx = list->getProperty(WSNhbarValue);
  px -= wx;
  long wy = list->getProperty(WSNvbarValue);
  py -= wy;
  if (px < 0 || sw < px ||
      py < 0 || sh < py ){
    WSDdev* ldev = cmb->_list->getowndev();
    if (ldev != NULL){
      WSCbool val = False;
      ldev->setValue(WSDEV_GRAB_POINTER,(void*)&val);
    }
    cmb->setUserData("Selected-cleard",(void*)1);
    cmb->_menu_popdown();
  }

  WSDdev* ldev = list->getdev();
  if (ldev != NULL){
    WSCbase* scrframe = ldev->getAttachedClient();
    if (scrframe != NULL){
      scrframe->getPropertyV(WSNwidth,&sw);
      scrframe->getPropertyV(WSNheight,&sh);
    }
    if (0 < px && px < sw && 0 < py && py < sh ){
      long scrpos = list->getProperty(WSNvbarValue);
      WSCpoint pt;
      pt.x = px;
      pt.y = py + scrpos;
      cmb->_list->setSelectItemChanged(True);
      cmb->_list->onActivate();
    }
  }
}

void WSCsheetComboBox::_list_work(WSCbase* list){
  WSCsheetComboBox* cmb = (WSCsheetComboBox*)list->getUserData("_CMB");
  if (cmb == NULL){
    return;
  }
  if (cmb->_list->getSelectItemChanged() != False){
    WSDdev* ldev = cmb->_list->getowndev();
    if (ldev != NULL){
      WSCbool val = False;
      ldev->setValue(WSDEV_GRAB_POINTER,(void*)&val);
    }
    cmb->_menu_popdown();
  }
}
void WSCsheetComboBox::onFocusChange(WSCbool fl){
	WSCbool focus = _focus;
	_focus = fl;
	if (_if != NULL){
		if(_dropdown_type == WSCSHEET_COMBO_EDIT) {
			if(fl) {
				WSCstring data = _if->getString();
				_if->setSelect(0,data.getChars());
			}
			_if->setFocus(fl);
		}
	}
	WSCbase* finst = WSCbase::getFocusInstance();
	if(fl == False && finst == NULL && _dropdown_type != WSCSHEET_COMBO_EDIT) {
		WSCbool fl1 = getFocus();
		fl1 |= _win->getFocus();
		fl1 |= _list->getFocus();
		fl1 |= _if->getFocus();
		if(fl1 == False) {
			_focus = False;
			redraw();
		}
	}
}
void WSCsheetComboBox::_cancel_work(WSCbase* win){
  WSCsheetComboBox* cmb = (WSCsheetComboBox*)win->getUserData("_CMB");
  cmb->setUserData("Selected-cleard",(void*)1);
  cmb->_menu_popdown();
}
void WSCsheetComboBox::_value_ch_work(WSCbase* ifield){
  WSCsheetComboBox* cmb = (WSCsheetComboBox*)ifield->getUserData("_CMB");
  if (cmb == NULL){
    return;
  }
  cmb->execProcedure(WSEV_VALUE_CH);
}
void WSCsheetComboBox::_btn_key_press_work(WSCbase* btn){
  WSCsheetComboBox* cmb = (WSCsheetComboBox*)btn->getUserData("_CMB");
  if (cmb == NULL){
    return;
  }
  long key = WSGIappKeyboard()->getKey();
  if (key == WSK_Return || key == WSK_Up || key == WSK_Down){
    _btn_work(btn);
    btn->onMouseOut();
  }
}
void WSCsheetComboBox::_key_press_work(WSCbase* ifield){
  WSCsheetComboBox* cmb = (WSCsheetComboBox*)ifield->getUserData("_CMB");
  if (cmb == NULL){
    return;
  }
  cmb->execProcedure(WSEV_KEY_PRESS);
}
void WSCsheetComboBox::_key_release_work(WSCbase* ifield){
  WSCsheetComboBox* cmb = (WSCsheetComboBox*)ifield->getUserData("_CMB");
  if (cmb == NULL){
    return;
  }
  cmb->execProcedure(WSEV_KEY_RELEASE);
}
void WSCsheetComboBox::_key_hook_work(WSCbase* ifield){
  WSCsheetComboBox* cmb = (WSCsheetComboBox*)ifield->getUserData("_CMB");
  if (cmb == NULL){
    return;
  }
  cmb->execProcedure(WSEV_KEY_HOOK);
  long key = WSGIappKeyboard()->getKey();
  if (key == WSK_Up){
    if (cmb->_win == NULL || cmb->_win->getVisible() == False){
      cmb->_menu_popup();
      WSGIappKeyboard()->setKey(0);
    }
  }else
  if (key == WSK_Down){
    if (cmb->_win == NULL || cmb->_win->getVisible() == False){
      cmb->_menu_popup();
      WSGIappKeyboard()->setKey(0);
    }
  }
}
void WSCsheetComboBox::_btn_work(WSCbase* btn){
  WSCsheetComboBox* cmb = (WSCsheetComboBox*)btn->getUserData("_CMB");
  if (cmb == NULL){
    return;
  }
  //for popup menu..
  if ((WSGIappMouse()->getStatus() & WS_MOUSE_BTN3) == 0){
    if (cmb->_win == NULL || cmb->_win->getVisible() == False){
      cmb->_menu_popup();
    }else{
      cmb->_menu_popdown();
    }
  }

  short x,y;
  WSGIappMouse()->getMousePosition(&x,&y,btn);
  WSCpoint pt;
  pt.x = x;
  pt.y = y;
  btn->execEventProc(WSEV_MOUSE_RELEASE,(void*)&pt);
}
char* WSCsheetComboBox::getDefaultProperty(){
  return WSNlabelString;
}
WSCvifield* WSCsheetComboBox::getTextFrame(){
  return _if;
}


/////////////////////////////////////////////////////
/////////////

void WSCsheetComboBox::onMousePress(WSCpoint* pt)
{
	if (WSGIappMouse()->getTargetBtn() & WS_MOUSE_BTN1
		&& (pt->x >= _w-WSCSHEET_COMBO_BUTTON_WIDTH-1 
		|| _dropdown_type != WSCSHEET_COMBO_EDIT)) {

		_btn_work(this);
		_list_down = 1;
		redraw();

	}
}
void WSCsheetComboBox::onMouseRelease(WSCpoint* pt)
{
//	WSCform::onMouseRelease(pt);
}

void WSCsheetComboBox::buttonDraw(WSDdev* dev, WSCrect rect)
{
	static short count;
	WSCbool c = False;

	c = _list_down;

	WSCpoint pt[3];
	WSCrect rect1;

	rect1.x = rect.x+rect.width-WSCSHEET_COMBO_BUTTON_WIDTH-_shadow_thick-1;
	rect1.y = rect.y+_shadow_thick;
	rect1.width = WSCSHEET_COMBO_BUTTON_WIDTH+1;
	rect1.height = rect.height-_shadow_thick*2;

	dev->setForeColor(c ? WS_DF_BARSHADOWCOLOR : WS_DF_BACKCOLOR);
	dev->drawFillRect(rect1.x, rect1.y, rect1.width, rect1.height);

	dev->setForeColor(c ? WS_DF_FORECOLOR : WS_DF_WORKBACKCOLOR);
	dev->drawLine(rect1.x, rect1.y, rect1.x, rect1.y + rect1.height);
	dev->drawLine(rect1.x, rect1.y, rect1.x + rect1.width, rect1.y);

	dev->setForeColor(c ? WS_DF_WORKBACKCOLOR : WS_DF_FORECOLOR);
	dev->drawLine(rect1.x + rect1.width-1, rect1.y+1, rect1.x + rect1.width-1, rect1.y + rect1.height-1);
	dev->drawLine(rect1.x+1, rect1.y + rect1.height-1, rect1.x + rect1.width, rect1.y + rect1.height-1);
	
	dev->drawLine(rect1.x + rect1.width, rect1.y, rect1.x + rect1.width, rect1.y + rect1.height);
	dev->drawLine(rect1.x, rect1.y + rect1.height, rect1.x + rect1.width+1, rect1.y + rect1.height);

	pt[0].x = rect1.x + 4;
	pt[0].y = rect1.y + (rect1.height - 4) / 2;
	pt[1].x = pt[0].x + 8;
	pt[1].y = pt[0].y;
	pt[2].x = pt[0].x + 4;
	pt[2].y = pt[0].y + 4;

	dev->setForeColor(WS_DF_FORECOLOR);
	dev->drawFillPoly(pt,3);

	short color;
	if(_dropdown_type != WSCSHEET_COMBO_EDIT) {
		short w, h;
		w = _w - WSCSHEET_COMBO_BUTTON_WIDTH - _shadow_thick * 2 - 1;
		h = _h - _shadow_thick * 2;

		color = WS_DF_FORECOLOR;
		dev->setForeColor(_work_back_color);
		dev->drawFillRect(_shadow_thick, _shadow_thick, w, h);
		
		if(_focus != False && _text.getChars() > 0 && _listindex > -1) {
			dev->setForeColor(_focus_color);
			dev->drawFillRect(_shadow_thick+1, _shadow_thick+1, w-2, h-2);
			dev->setForeColor(_work_back_color);
			dev->setLineDashType(8);
			dev->drawRect(_shadow_thick+1, _shadow_thick+1, w-2, h-2); 
			dev->setLineDashType(0);
			color = _work_back_color;
		}
		dev->setForeColor(color);
		dev->drawString(_shadow_thick+1, _shadow_thick+1, w-2, h-2, _font, WS_LEFT, _text);
	}
}
void  WSCsheetComboBox::setDropdown(short type)
{
	_dropdown_type = type;
	if(_if != NULL) {
		_if->setVisible((_dropdown_type == WSCSHEET_COMBO_EDIT));
	}
}
short WSCsheetComboBox::getDropdown()
{
	return _dropdown_type;
}
void  WSCsheetComboBox::setText(WSCstring text)
{
	_text = text;
	if(_if) {
		_if->setPropertyV(WSNlabelString,(char*)_text);
	}
	_listindex = getListIndex();
}
WSCstring WSCsheetComboBox::getText()
{
	if(_if) {
		WSCstring text;
		text = _if->getProperty(WSNlabelString);
		if(_text != text) {
			_text = text;
			getListIndex();
		}
	}
	return _text;
}
void WSCsheetComboBox::_focus_ch(WSCbase* ifield){
	WSCsheetComboBox* cmb = (WSCsheetComboBox*)ifield->getUserData("_CMB");
	if (cmb == NULL){
		return;
	}
	WSCbase* finst = WSCbase::getFocusInstance();
	short focus = cmb->_focus;
	cmb->_focus = True;
	if(finst == NULL) {
		WSCbool fl1 = False;
		fl1 |= cmb->getFocus();
		if(cmb->_win != NULL) {
			fl1 |= cmb->_win->getFocus();
			fl1 |= cmb->_list->getFocus();
		}
		fl1 |= cmb->_if->getFocus();
		if(fl1 == False) {
			if(cmb->_dropdown_type == WSCSHEET_COMBO_EDIT) {
				cmb->_focus = False;
				cmb->_if->setSelect(0,0);
			} else {
				cmb->_focus = False;
				cmb->redraw();
			}
		}
	} else {
		cmb->_focus = False;
	}
}
WSCbool WSCsheetComboBox::isButton(WSCpoint* pt)
{
	if (WSGIappMouse()->getTargetBtn() & WS_MOUSE_BTN1
		&& pt->x >= _w-WSCSHEET_COMBO_BUTTON_WIDTH-1
		&& pt->x <= _w
		&& pt->y >= 0 && pt->y <= _h) {
		return True;
	}
	return False;
}
void WSCsheetComboBox::setListIndex(long index)
{
	_listindex = index;
}
long WSCsheetComboBox::getListIndex()
{
	_listindex = -1;
	long i;
	char tmp[2];
	tmp[0] = (char)-1;
	tmp[1] = 0;
	WSCstring str = _menu_str;
	long num  = str.getWords(",");
	for(i=0; i<num; i++){
		WSCstring item = str.getWord(i,",");
		item.replaceString(tmp,",",0);
//		if(_dropdown_type == WSCSHEET_COMBO_EDIT) {
//			if (_listindex == -1 && !strncmp(_text.getString(),item.getString(),_text.getChars())){
//				_text = item;
//				_listindex = i;
//				break;
//			}
//		} else 
		if(item == _text) {
			_listindex = i;
			break;
		}
	}
	return _listindex;
}
WSCbool  WSCsheetComboBox::isFocus()
{
	WSCbase* finst = WSCbase::getFocusInstance();
	if(finst == NULL) {
		WSCbool fl1 = getFocus();
		if(_win != NULL) {
			fl1 |= _win->getFocus();
			if(_list == NULL) {
				fl1 |= _list->getFocus();
			}
		}
		if(_if == NULL) {
			fl1 |= _if->getFocus();
		}
//		if(fl1 == False) {
			return fl1;
//		}
	}
	return True;
}
void WSCsheetComboBox::setSheetComboText(WSCstring text)
{
	setText(text);
	setFocus(False);
	if(_win) {
		_win->setVisible(False);
		_win->setFocus(False);
	}
#if 0 //removed. this code causes null widget trouble in linux/x11..
	if(_list) {
		_list->setVisible(False);
		_list->setFocus(False);
	}
#endif
	if(_if) {
		_if->setFocus(False);
		if(_dropdown_type == WSCSHEET_COMBO_EDIT) {
			_if->setVisible(True);
			WSCstring data = _if->getString();
			_if->setSelect(0,data.getChars());
		} else {
			_if->setVisible(False);
		}
	}
	_list_down = 0;
	_focus = True;
}
/// Global Mouse Hook
static WSCbool global_mouse_hook_proc(long ev,WSCbase* inst)
{
	WSCsheetComboBox* cmb = (WSCsheetComboBox*)inst->getUserData("_CMB");
	if(cmb == NULL) {
		return True;
	}
	if(ev == WSEV_MOUSE_RELEASE) {
		if(cmb->_list_down == 1) {
			cmb->_list_down = 0;
			cmb->redraw();
		}
	}
	return True;
}


