//
// Copyright (C) 1999-2009 WideStudio/MWT Project Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
//

#include <win/WSDwinEnv.h>
#include <WSCstring.h>
#ifndef _WSWINCE
#include <direct.h>
#endif

WSDenv* _win_env_chandler(){
  return new WSDwinEnv();
}
void WSGFwinEnvInit(){
  WSDenv::setCreateInstanceHandler(_win_env_chandler);
}
#ifndef NO_GLOBAL_CONSTRUCTORS
class _win_env_init{
  public: _win_env_init(){
    WSGFwinEnvInit();
  };
};
static _win_env_init _win_env_init_execute;
#endif

WSDwinEnv::WSDwinEnv(){}
WSDwinEnv::~WSDwinEnv(){}

char* WSDwinEnv::getEnv(char* src){
static char buffer2[2048];
  WSCstring str(src);
  str.delString("(",0);
  str.delString(")",0);
  WSCstring new_str = str.getWord(0);
  WSCbool wsdir = !strcmp("WSDIR",new_str.getString());
  WSCbool windir = !strcmp("WINDIR",new_str.getString());
  if (!strcmp("HOME",new_str.getString())){
    new_str.setString("USERPROFILE");
  }
  if (!strcmp("USER",new_str.getString())){
    new_str.setString("USERNAME");
  }

  if (windir != 0){
#ifndef _WSWINCE
#ifndef UNICODE
    GetWindowsDirectory(buffer2,2048);
#else
static WCHAR buffer3[2048];
    GetWindowsDirectory(buffer3,2048);
    char* ret = WSGFgetString((WSCushort*)buffer3,WS_EN_LOCALE);
    strncpy(buffer2,ret,2045);
    buffer2[2045]=0;
    buffer2[2046]=0;
    buffer2[2047]=0;
    delete ret;
#endif
    return buffer2;
#else
    return "\windows";
#endif
  }
#ifndef _WSWINCE
#ifdef UNICODE
  char* ret = getenv_utf8( new_str.getString(WS_EN_UTF8) );
#else
  char* ret = getenv( new_str.getString() );
#endif

  if (ret == NULL){
    if (wsdir != 0){
static int init = 0;
      if (init == 0){ 
        char buffer[2048];
#ifdef UNICODE
        _getcwd_(buffer,2000);
#else
        _getcwd(buffer,2000);
#endif
        sprintf(buffer2,"%s\\..",buffer);
        init = 1;
WSMFtrace("WSDwinEnv::getEnv getcwd=%s\n",buffer2);
      }
      return buffer2;
    }else{
      return "";
    }
  }
#ifdef UNICODE
  WSCstring tmp(ret,WS_EN_UTF8);
  memset(buffer2,0,2048);
  strncpy(buffer2,(char*)tmp,2040);
  return buffer2;
#else
  return ret;
#endif
#else
  return "";
#endif
}
